package uniba.core;

import uniba.databanker.*;
import uniba.gui.*;


import java.awt.Frame;
import java.awt.Cursor;
import java.util.Vector;
import java.util.StringTokenizer;
import java.io.*;

/**
 * Esegue la classificazione di tutte le pagine di testing
 * usando gli alberi di decisione costruite dal modulo
 * OC1. Poich questa classe usa la tecnologia J/Direct della
 * Microsoft, necessita di essere compilata con un compilatore
 * Microsoft per java.
 */
public class DTClassifyAPage {

	private String utente = null;
	private String FILEPRUNEDTREE = null;
  	private String FILEUNPRUNEDTREE = null;
  	private String FILELOG = null; 		
  	private String FILETESTING = null;
	private String FILECLASS = null;
      private CategoriesManager cgm = null;
      private int mode = 0;
	String risultato;


	public DTClassifyAPage(String utente, CategoriesManager cgm,
 								int mode, double rep[]) {
		super();
	      this.utente = utente;
		this.cgm = cgm;
            this.mode = mode;
		risultato = "";
		FILEPRUNEDTREE = ".\\DT\\" + utente + "\\training.dt";
  	    FILEUNPRUNEDTREE = ".\\DT\\" + utente + "\\training.unp";
  	    FILELOG = ".\\DT\\" + utente + "\\Oc1.log"; 		
  	    FILETESTING = ".\\DT\\" + utente + "\\testing";
	    FILECLASS = ".\\DT\\" + utente + "\\Testing.classified";
		boolean avanti = false;
		try {
			FileReader fr = new FileReader(FILEPRUNEDTREE);
			fr.close();
			avanti = true;
		} catch (Exception fnfe) {
			new StampaErrore(new Frame(),"Classify a page by decision tree", 
									"File non trovato.");
			return;
		}
		if (avanti) {
            
			//Elimina vecchi file
			java.io.File testing = new java.io.File(FILETESTING);
            	java.io.File oc1log = new java.io.File(FILELOG);
            	java.io.File fileclass = new java.io.File(FILECLASS);
			testing.delete();
			oc1log.delete();
            	fileclass.delete();
			try {
				Result result = new Result();
				result.addActual("UNKNOWN", "page");
				FileWriter fw = new FileWriter(FILETESTING, false);
				for (int k=0; k < rep.length; k++) {
					if (k == rep.length - 1)
						fw.write(rep[k] + "");
					else  
						fw.write(rep[k] + ", ");
				}
				fw.write("\n");
				fw.close();
				//Classifica
				try {
					new MkTree(".\\DT\\" + utente + "\\class.bat", mode);
				} catch (UnsatisfiedLinkError ule) {
					new StampaErrore(new Frame(), 
                                      	     "Classify by Decision Tree", 
                                      	     "Impossibile continuare:\n" +
                                               "per utilizzare questa funzione, compilare\n" +
                                               "ed eseguire WebClass con i tools\n" +
                                               "della Microsoft per Java.");
					return;
				}
				boolean fine = false;

				//attende che mktree crei il file di log
				while (!fine) {
					try {
						FileReader fr = new FileReader(FILELOG);
						fine = true;
						fr.close();
					} catch (FileNotFoundException e) {}
				}
				result = getClassificationResult(result);
				risultato = result.getAssigned(0);
			} catch (Exception e) {
				new StampaErrore(new Frame(),
                                         "Classify by Decision tree",
			      	     	     "Exception:\n" + e.getMessage());
                  	e.printStackTrace();
			} 
		} // end if (avanti)
	} // end run



	/*
	 * Restituisce il risultato della classificazione.
	 */
	public String getResult(){
		return risultato;
	}



	/*
	 * Legge dal file .cla le classi attribuite agli esempi
       * di testing da mktree.
	 */
	private Result getClassificationResult(Result r) throws Exception {

		FileReader fr = new FileReader(FILECLASS);
		int c = 0;
            StringBuffer buff = new StringBuffer();
		do {
			c = fr.read();
			buff.append((char)c);
		} while (c != -1);
		String source = buff.toString();
		int inizio = 0;
		for (int i=0; i<r.size(); i++) {
			int j = source.indexOf("\n", inizio);
			int k = j-1;
			char current = source.charAt(k);
			while (current != '\t') { 
				k--;
				current = source.charAt(k);
			}
			Integer catNum = new Integer((source.substring(k, j)).trim());
			r.addAssigned(cgm.categoryName(catNum.intValue()-1));
			inizio = j+1;
		}
			
		return r;
  	}   

} // end class
 


			