package uniba.core;

import java.util.*;
import java.sql.*;
import java.awt.*;

import uniba.databanker.*;
import uniba.gui.*;

/**
* La classe ha il compito di chiamare il metodo<br>
* di databanker<b><i>getSignificance</i></b> che<br> 
* restituisce l'elenco dei documenti in ordine di<br>
* rilevanza.<br>
* Per il calcolo di tale rilevanza sono state<br>
* utilizzate le seguenti metriche:<br>
* <b><i>QTF(j):</i></b>  il rapporto tra il numero di parole nella<br>
* query che sono presenti nel documento j<br>
* e il numero totale di parole che compongono la query.<br>
* <b><i>IDF(t):</i></b>  l'inverso del numero di pagine che<br>
* contengono almeno una volta la parola t.<br>
* <b><i>TF(j,t):</i></b>  la frequenza relativa<br>
* della parola t nel documento j. 
*/



public class DocumentRetriever {
	String utente;
	String query;
	Databanker db;
	Vector allDocuments;

	public DocumentRetriever(String utente, String query, Databanker db)throws SQLException{
		this.utente = utente;
		this.query = query;
		this.db = db;
		allDocuments = new Vector();
		allDocuments = db.getSignificance(utente, query, 0);
	}

//---------------------------------------------------------------

/**
* Visualizza sullo standard output l'elenco<br>
* dei documenti in ordine di rilevanza.
*/

public void stampaVettore() {
	for (int i = 0;i < allDocuments.size();i++) {
		System.out.println((String)allDocuments.elementAt(i));
	}
}

//-------------------------------------------------------------------------------------

/**
* Restituisce l'elenco dei documenti in ordine di rilevanza.
*/

public Vector getDocumentList() throws SQLException {
	return allDocuments;
}

//-------------------------------------------------------------------------------------

}