package uniba.core;

/**
 * Questa classe mette a disposizione una serie di metodi
 * utili per trattare i nomi dei file.
 */
public abstract class File {
  
	private static final int DIMENSIONE = 9;
	private static String[] estensioni = { ".html", ".htm",  ".gif",
      	                                 ".jpg",  ".jpeg", ".mp3",
      	                                 ".zip",  ".txt",  ".wav" 
                                           };
	
	/*
 	 * Restituisce vero se l'estensione del file  nota
 	 */
 	public static boolean estensioneNota (String file) {

		if (file != null) {		
					
                //trova l'estensione del file
                int i = file.length()-1;
                if (i < 0)
                   return false;
                while (file.charAt(i) != '.') {
          		if (i == 0)
              		return false;
	    		i = i - 1;	
		    }
                String s = file.substring(i, file.length());
                s = s.toLowerCase();

                i = 0;
                while (i < DIMENSIONE) {
         		if (s.equals(estensioni[i]))
                		return true;
         		else
                                i++;
                }
                return false;
		} else
			return false;
	}

        /**
         * Trasforma il path del file in un URL. 
         */
         public static String trasforma (String path) {
		
		path = path.toLowerCase();
		if ( (path.charAt(0) == 'a') ||
                 (path.charAt(0) == 'b') ||
		     (path.charAt(0) == 'c') ||
                 (path.charAt(0) == 'd') ||
                 (path.charAt(0) == 'e') ) {

                int i =0;
                String ris = new String("file://");
                while (i < path.length()) {
                        if (path.charAt(i)=='\\')
                                ris = ris + '/';
                        else
                                ris = ris + path.charAt(i);
                        i++;
                }
		    return ris;
             }
		 return path;
                
         }

         /**
          * Estrae il nome del file dal relativo path.
          */
          public static String nomeFile(String path) {

                String ris = null;
                int fine = path.length()-1;

                while (fine >= 0) {
                        if ((path.charAt(fine)=='\\') |
                           (path.charAt(fine)=='/') )
                                return ris;
                        else
                                ris = ris + path.charAt(fine);
                                fine--;
                }
                return ris;

          }

         

}
