package uniba.core;

import java.net.*;
import java.io.*;

public class GetURL {
  protected String url;
  protected String proxy;
  protected String socks;
  protected Socket socket;
  protected DataInputStream in;

  public GetURL(String u) {
	url = u;
	proxy = "";
	socks = "";
  }  
  public GetURL(String u, String p) {
	url = u;
	proxy = p;
	socks = "";
  }  
  public GetURL(String u, String p, String s) {
	url = u;
	proxy = "";
	socks = s;
  }  
  public DataInputStream connect() throws UnknownHostException,
    IOException {
	return getStream();
  }  
  public void finalize() throws IOException {
     
	  socket.close();
  }  
  protected DataInputStream getStream() throws UnknownHostException,
     IOException {
       
	  // Break the URL and the Proxy info into components
	  URLParse docURL = new URLParse(url);
	  URLParse proxyURL = new URLParse(proxy);
	  URLParse socksURL = new URLParse(socks);

	  // If this is a supported protocol, then get the file
	  if(!docURL.protocol.equalsIgnoreCase("HTTP://") && proxyURL.host == "") {
              return null;
	  }

	  // If proxy and socks specified, use proxy.
	  // If a proxy server was specified then make the connection
	  //  through it.

	  if(!proxyURL.host.equals("")) {
            
             socket = new Socket(proxyURL.host, proxyURL.port);
	  } else if (!socksURL.host.equals("")) {
                  
                   socket = new Socket(socksURL.host, socksURL.port);
                } else {
                 
                   socket = new Socket(docURL.host, docURL.port);
                }
               in = new DataInputStream(socket.getInputStream());
               PrintWriter out = new PrintWriter(socket.getOutputStream(), true);

              if(!proxyURL.host.equals("")) {
                 out.println("GET "+docURL+" HTTP/1.0");
              } else if (!socksURL.host.equals("")) {
        
	  InetAddress addr = InetAddress.getByName(docURL.host);
	  byte saddr[] = addr.getAddress();

	  byte sdata[] = new byte[20];
	  sdata[0] = 4;
	  sdata[1] = 1;
	  sdata[2] = 0;
	  sdata[3] = 80;
	  sdata[4] = saddr[0];
	  sdata[5] = saddr[1];
	  sdata[6] = saddr[2];
	  sdata[7] = saddr[3];
		  sdata[8] = (byte) 'a';
		  sdata[9] = (byte) 'n';
		  sdata[10] = (byte) 'o';
		  sdata[11] = (byte) 'n';
		  sdata[12] = (byte) 'y';
		  sdata[13] = (byte) 'm';
		  sdata[14] = (byte) 'o';
		  sdata[15] = (byte) 'u';
		  sdata[16] = (byte) 's';
		  sdata[17] = (byte) '\0';

	  DataOutputStream binout = new DataOutputStream(socket.getOutputStream());
	  binout.write(sdata, 0, 18);
	  byte indata[] = new byte[8];
	  in.read(indata, 0, 8);
	
	  if (indata[1] != 90) {
	    if (socket != null) socket.close();
    
	    return null;
	  }
	out.println("GET " + docURL.path + " HTTP/1.0");
	  } else {
	out.println("GET " + docURL.path + " HTTP/1.0");
	  }
	  out.println("");

	  return in;
	  //socket.close(); // closed by finalize()
  }  
}
