package uniba.core;

/**
 * Questa classe conserva il nome del tag, l'eventuale <i>URL</i> in esso
 * contenuto, e se  di apertura o di chiusura.
 */ 
public class HtmlTag {

  private String name;    // Nome del Tag.
  private String url;     // Eventuale "url" presente nel tag.
				  // (e.g. <A HREF="url">, <IMG SRC="url">, ecc.. )
  private boolean start;  // Flag che identifica un Tag di apertura o di chiusura.
				  // (e.g. <H1> o </H1>)


  /**
   * Imposta il nome del tag e se il tipo (tag di apertura o di chiusura)
   */ 
  public HtmlTag(String name, boolean start) {
	this.name=name;
	this.start=start;
  }  

 /**
  * Restituisce il nome del tag
  */
  public String getName() {
	return name;
  } 

 /**
  * Restituisce l'eventuale URL contenuto nel tag
  */
  public String getUrl() {
	return url;
  }  

  /**
   * Vero se il tag  di apertura
   */
  public boolean isStart() {
	return start;
  }  

  /**
   * Imposta il tag come apertura o chiusura
   */
  public void setStart(boolean start) {
	this.start=start;
  }  

  /**
   * Imposta l'URL
   */
  public void setUrl(String url) {
	this.url=url;
  }  

}