package uniba.core;

import java.util.*;

/**
 * Questa classe immagazzina una parola con i suoi attributi. Gli attributi sono
 * i Tag Html fra i quali la parola stessa  racchiusa.
 */
public class HtmlWord {

  private String text;                // Testo della parola.
  private String attributes = null;   // Tag associati alla parola.
  private double Occ = 0;		  // Occorrenza della parola in un documento
  private double TF = 0;		  // Frequenza della parola in un documento
  private double enfasiAdditiva = 0;
  private double enfasiMoltiplicativa = 0;
  private double hw = 0;		  //peso dei tag html fra i quali  racchisa la parola



  /**
   * Imposta il peso dei tag html
   */
  public void setHtmlWeight(double hw) {
	this.hw = hw;
  }

  /**
   * Restituisce il peso dei tag html
   */
  public double getHtmlWeight() {
	return hw;
  }

	

  /**
   * Imposta l'enfasi additiva
   */
  public void setEnfasiAdditiva(double ea) {
	enfasiAdditiva = ea;
  }
   
  /**
   * Imposta l'enfasi moltiplicativa
   */
  public void setEnfasiMoltiplicativa(double em) {
	enfasiMoltiplicativa = em;
  }

  /**
   * Restituisce l'enfasi additiva
   */
  public double getEnfasiAdditiva() {
	return enfasiAdditiva;
  }
  
  /**
   * Restituisce l'enfasi moltiplicativa
   */
  public double getEnfasiMoltiplicativa() {
	return enfasiMoltiplicativa;
  }


    /**
   * Imposta l'occorrenza della parola.
   */
  public void setOcc(double occ) {
	Occ = occ;
  }

  /**
   * Restituisce l'occorrenza della parola.
   */
  public double getOcc() {
	return Occ;
  }

  /**
   * Imposta la TF della parola.
   */
  public void setTF(double tf) {
	TF = tf;
  }

  /**
   * Restituisce la TF della parola.
   */
  public double getTF() {
	return TF;
  }
   
  /**
   * Imposta la parola
   */
  public HtmlWord (String t) {
   text=t;
  }  

  /**
   * Aggiunge un attributo alla parola. Si deve aggiungere
   * un token alla volta, per esempio <code>addAttributes("A ");</code>
   * e non <code>addAttributes("A IMG B ");</code>.
   */
  public void addAttribute(String at) {
      boolean esiste = false; 
      if (attributes != null) {
      	StringTokenizer st = new StringTokenizer(attributes);
   		while (st.hasMoreTokens()) {
			if ( st.nextToken().equals(at.trim()) )
				esiste=true;
      	}
      }
      if (!esiste) { 	
		if (attributes == null) 
           		attributes = at; 
     		else 
           		attributes = attributes + at;  
	}
  }  

  /**
   * Restituisce gli attributi della parola
   */
  public String getAttributes() {
   return attributes;
  }  

  /**
   * Restituisce la parola
   */
  public String getText() {
   return text;
  }

  /**
   * Imposta il testo 
   */
  public void setText(String t) {
       text = t;
  }  
}