package uniba.core;

import java.util.StringTokenizer;
import java.util.Vector;
import java.util.Enumeration;
import java.util.Hashtable;
import java.awt.*;
import uniba.databanker.*;
import uniba.gui.*;

import java.sql.*;

/**
 * Questo metodo calcola la similarit fra la rappresentazione
 * di una intera pagina Web e la query.
 */
public class Idf extends Retriever {

    
	private String utente;     
      private String textQuery;
	private Databanker db;
		private Frame parent = null;
	private Viewer viewer = null;
      private Vector categoria = null;
      private double  SOGLIA_1 = 0.0;
      private final int K;
	private Hashtable dimensioniDocumenti = null;
	
	public Idf(Frame parent,
				  String utente,
				  Vector categoria,
			        String textQuery,
				  Databanker db,
				  Viewer viewer) throws SQLException {

		this.utente = utente;
            this.parent = parent;
		this.textQuery = textQuery;
            this.db = db;
            this.viewer = viewer;
            this.categoria = categoria;
            
		Vector conf = db.getConfiguration(utente);
		K = ((Integer)conf.elementAt(8)).intValue();
		esegui();
				
            
      }
      
      
      
      
      
      public void esegui() { 
		Time inizio = new Time(System.currentTimeMillis());
		Vector report = new Vector();
		
		try {
			viewer.waitCursor(true);
			QueryTokenizer qt = new QueryTokenizer(textQuery, 
						 	               db.getConfiguration(utente), 
						                     db.getStopword(utente));

			Vector token = qt.getTokenQuery();
			int N = db.getAllDocuments(utente, null).size();


			Vector listeDoc = new Vector();
			Vector idf = new Vector();
			for (int i=0; i<token.size(); i++) {
				String tok = ((HtmlWord)token.elementAt(i)).getText();
				int n = db.getDocumentsWith(tok, utente).size();
				//double temp = myLog((double)N/(double)n);
				double temp = Math.log((double)N/(double)n);

				if (n > 0) {
					idf.addElement(new Double(temp));
					listeDoc.addElement(db.getDocumentsWith(tok, utente));
				}
			}

			Hashtable candidati = new Hashtable();
			for (int i=0; i<listeDoc.size(); i++) {
				Vector lista = (Vector)listeDoc.elementAt(i);
				for (int j=0; j<lista.size(); j++) {
					String idDoc = (String)lista.elementAt(j);
					if (candidati.containsKey(idDoc)) {
						double old = ((Double)candidati.get(idDoc)).doubleValue();
						double nuovo = ((Double)idf.elementAt(i)).doubleValue();
						candidati.put(idDoc,  new Double(old + nuovo));
					} else
						candidati.put(idDoc, (Double)idf.elementAt(i));
				}
			}
			
			report.addElement("Soglia: " + SOGLIA_1);
						
			Vector documentiSelezionati = new Vector();
			Enumeration chiavi = candidati.keys();
			while (chiavi.hasMoreElements()) {
				String idDoc = (String)chiavi.nextElement();
				String cat = db.getCategory(new Integer(idDoc).intValue());
				if (categoria.contains(cat)) {
					double r = ((Double)candidati.get(idDoc)).doubleValue();
					String nome = idDoc + " " + db.getUrl(new Integer(idDoc).intValue());
					if (r > SOGLIA_1)
						documentiSelezionati.addElement(new Rank(nome, r));
				}
			}
			
			
			documentiSelezionati = quicksort(documentiSelezionati);
			if (documentiSelezionati.size() > K)
				documentiSelezionati.setSize(K);

			report.addElement("Documenti Ritrovati: " + documentiSelezionati.size());
			
			if (documentiSelezionati.size() == 0)
				viewer.printRetrievedDocument("No Match Found");
			else {
				for (int i=0; i<documentiSelezionati.size(); i++) {
					Rank r = (Rank)documentiSelezionati.elementAt(i);
					int k = i+1;
System.out.println(k + "  " + r.getName() + "  " + r.getDistanza());
					viewer.printRetrievedDocument( r.getName() );
					viewer.printReport( r.getDistanza() );
				}
			}
			Time fine = new Time(System.currentTimeMillis());
			report.addElement("Tempo: ");
			report.addElement("  inizio " + inizio.toString());
			report.addElement("  fine " + fine.toString());

			viewer.printTime(report.elements());

			
		} catch (Exception e) {
			new StampaErrore(parent, 
					     "Dice", 
					     "Exception:\n"+e.getMessage());
                  e.printStackTrace();
		} finally {
			viewer.waitCursor(false);
		}

		
	}
   		
}
                      
     	