package uniba.core;

import java.util.*;
import uniba.databanker.*;
import java.sql.SQLException;

public class RejectPagesManager {

  private Vector rejectPages;
  private int numPag = 0;
  private Databanker db = null;
  private String utente = null; 
  
  
  public RejectPagesManager(String utente, Databanker db) throws SQLException {
	rejectPages = db.getRejectPages(utente);	
	numPag = rejectPages.size();
      this.db = db;
      this.utente = utente;
  }  

  /**
   * Aggiorna l'insieme delle pagine di rigetto.
   * Questo metodo deve essere invocato quando
   * si inserisce e/o cancella una pagina di rigetto.   
   */		
  public void updateRejectPages()throws SQLException  {
	rejectPages.removeAllElements();
	rejectPages = db.getRejectPages(utente);	
	numPag = rejectPages.size();
  }  
	
  
  /**
   * Restituisce l'elenco delle pagine di rigetto.
   * Gli elementi del vettore restituito sono stringhe 	
   * del tipo <code>idDocumento</code>.
   */		
  public Enumeration listPages() {
	return rejectPages.elements();
  }  

  /**
   * Restituisce il numero di pagine di rigetto
   */
 public int getNumPages() {
	return numPag;
 }

 
}  // end class
