package uniba.core;

import java.util.*;
import uniba.databanker.*;

import uniba.gui.*;



/**
 * Raggruppa comportamenti comuni.
 */
abstract class Retriever {

     private static final int dim = 15;	
     
     /** 
      * 'Quicksort' a Vector made of Rank. 
	*  Recursive version - C.A.R.Hoare
      */
     static Vector quicksort(Vector v) {
           if (v.size() > 0)
	     		sort(v, 0, v.size()-1);
	     return v;
     }   

     /** 
      * Sorting recursive method.
      */ 
     private static void sort(Vector v, int s, int d) {
	  int i = s;
	  int j = d;
	  Rank temp;
	  Rank pivot = (Rank)v.elementAt((s+d) / 2);
	  
	  try {
		 do {
			while( ((Rank)v.elementAt(i)).getDistanza() > pivot.getDistanza() ) i++;
			while ( pivot.getDistanza() > ((Rank)v.elementAt(j)).getDistanza() ) j--;
			if(i <= j) {
			   temp = (Rank)v.elementAt(i);
			   v.setElementAt(v.elementAt(j), i);
			   v.setElementAt(temp, j);
			   i++;
			   j--;
			}
		 } while(i <= j); 
		 if(s < j) sort(v, s, j);
		 if(i < d) sort(v, i, d);
	  } catch(ArrayIndexOutOfBoundsException e) {
		 e.printStackTrace();
	  }
   }


   /*static double calcolaSoglia(Vector sims) {
	
		double media = 0;
		double sum = 0;
		if (sims.size() > 0) {
			sims = quicksort(sims);
			if (sims.size() > dim)
				sims.setSize(dim);
			for (int i=0; i<sims.size(); i++) 
				sum = sum + ((Rank)sims.elementAt(i)).getDistanza();
			media = sum/sims.size();
		}
		return media;

	}*/

	
	
	
	static double myLog(double x) {
		
		double base = 1.071773463;	//2^0.1
		
		return (Math.log(x)/Math.log(base));
	}

}  

          
                     
                     
