package uniba.core;

import java.util.StringTokenizer;
import java.util.Vector;
import java.util.Hashtable;
import java.util.Enumeration;
import java.awt.*;
import java.sql.*;
import uniba.databanker.*;

import uniba.gui.*;


/**
 * 
 */
public class SimpleMatching extends Retriever  {

    
	private String utente;     
      private String textQuery;
	private Databanker db;
	private Frame parent = null;
	private Viewer viewer = null;
      private Vector categoria = null;
      private int K;
		
	public SimpleMatching(Frame parent,
				  String utente,
				  Vector categoria,
			        String textQuery,
				  Databanker db,
				  Viewer viewer) throws SQLException {

		this.utente = utente;
            this.parent = parent;
		this.textQuery = textQuery;
            this.db = db;
            this.viewer = viewer;
            this.categoria = categoria;
		Vector conf = db.getConfiguration(utente);
		K = ((Integer)conf.elementAt(8)).intValue();
		esegui();
            
      }
      
      public void esegui() {  
		Time inizio = new Time(System.currentTimeMillis());
		
		try {
			viewer.waitCursor(true);
			QueryTokenizer qt = new QueryTokenizer(textQuery, 
						 	               db.getConfiguration(utente), 
						                     db.getStopword(utente));
			Vector token = qt.getTokenQuery();
			Vector listeDoc = new Vector();

			for (int i=0; i<token.size(); i++) {
				String tok = ((HtmlWord)token.elementAt(i)).getText();
				listeDoc.addElement(db.getDocumentsWith(tok, utente));
			}

			Hashtable candidati = new Hashtable();
			for (int i=0; i<listeDoc.size(); i++) {
				Vector lista = (Vector)listeDoc.elementAt(i);
				for (int j=0; j<lista.size(); j++) {
					String idDoc = (String)lista.elementAt(j);
					if (candidati.containsKey(idDoc))
						candidati.put(idDoc, new Integer(((Integer)candidati.get(idDoc)).intValue()+1));
					else
						candidati.put(idDoc, new Integer(1));
				}
			}

			
			Vector documentiSelezionati = new Vector();
			Enumeration chiavi = candidati.keys();
			while (chiavi.hasMoreElements()) {
				String idDoc = (String)chiavi.nextElement();
				String cat = db.getCategory(new Integer(idDoc).intValue());
				if (categoria.contains(cat))
					documentiSelezionati.addElement(new Rank(idDoc + " " + db.getUrl(new Integer(idDoc).intValue()), ((Integer)candidati.get(idDoc)).intValue()));
			}
			documentiSelezionati = quicksort(documentiSelezionati);

			if (documentiSelezionati.size() > K)
				documentiSelezionati.setSize(K);

			Vector report = new Vector();
			report.addElement("Documenti Ritrovati: " + documentiSelezionati.size());

			if (documentiSelezionati.size() == 0)
				viewer.printRetrievedDocument("No Match Found");
			else {
				for (int i=0; i<documentiSelezionati.size(); i++) {
					Rank r = (Rank)documentiSelezionati.elementAt(i);
					int k = i + 1;

					viewer.printRetrievedDocument( r.getName());
					viewer.printReport( r.getDistanza() );
				}
			}
			Time fine = new Time(System.currentTimeMillis());
			report.addElement("Tempo: ");
			report.addElement("  inizio " + inizio.toString());
			report.addElement("  fine " + fine.toString());

			viewer.printTime(report.elements());
		
		} catch (Exception e) {
			new StampaErrore(parent, 
					     "Simple Matching", 
					     "Exception:\n"+e.getMessage());
                  e.printStackTrace();
		} finally {
			viewer.waitCursor(false);
		}

		
	}

	

		
	
   		
}
                      
     	