package uniba.core;

import java.util.*;
import java.io.*;
import java.sql.SQLException;

import uniba.databanker.*;

/**
 * Conserva informazioni sulle pagine di testing.
 */
public class TestingPagesManager {

  private Vector testingPages;
  private int numPag = 0;
  private Databanker db = null;
  private String utente = null; 
  
  /**
   * Carica dal database le pagine di testing di un utente
   */
  public TestingPagesManager(Databanker db, String utente) throws SQLException {
      testingPages = new Vector();
      this.utente = utente;
      this.db = db;
	testingPages = db.getTestingPages(utente);
      numPag = testingPages.size();
  }

  /**
   * Da richiamare quando cambia l'insieme delle pagine di testing
   */	
  public void updateTestingPages() throws SQLException {
       testingPages.removeAllElements();
       testingPages = db.getTestingPages(utente);
       numPag = testingPages.size();
  }

  /**
   * Restituisce la lista della pagine di testing con relativa categoria.<br>
   * Gli elementi del vettore restituito sono del seguente tipo:<br>
   * <code>nome pagina</code> + <code>categoria pagina</code> + <code>url pagina</code>.
   */
  public Enumeration listPages() {
	return testingPages.elements();
  } 
 
}  // end class