package uniba.core;

public class URLParse {
   public String protocol;
   public String host;
   public String path;
   public int port;

   URLParse(String url) {
	  // Prepare to parse the data into useful information
	  int i,j;

	  // Strip out the protocol, or set it to the default

	  i = url.indexOf("://");
	  if(i==-1) {
		 i=0;
	  protocol = "HTTP://";
	  } else {
		 protocol = url.substring(0, i+=3);
	  }

	  // Now split the remaining information into host and path
	  //  default path is "/"

	  j = url.indexOf("/", i);
	  if(j==-1) {
		 host = url.substring(i, url.length());
		 path = "/";
	  } else {
		 host = url.substring(i, j);
		 path = url.substring(j, url.length());
	  }

	  // Search for port information on the host
	  //  default port 80

	  i = host.indexOf(":");
	  if(i==-1)
		 port = 80;
	  else {
		 Integer p = new Integer(host.substring(i+1, host.length()));
		 port = p.intValue();
		 host = host.substring(0, i);
	  }
   }   
   public String getHost() {
	  return host;
   }   
   public String getPath() {
	  return path;
   }   
   public int getPort() {
	  return port;
   }   
   public String getProtocol() {
	  return protocol;
   }   
   public String toString() {
	  String url = protocol + host + ":" + port + path;
	  return url;
   }   
}