package uniba.core;

/**
 * Questa classe mette a disposizione una serie di metodi
 * utili per trattare i vettori.
 */
public abstract class Vettori {
  
/**
* Cosine similarity: normalizza entrambi i vettori.
*/
  
public static synchronized double distanza(double v1[],double v2[]) {
    	if ( v1.length != v2.length )
           return 0;
	double sum  = 0;
	double sum1 = 0;
	double sum2 = 0;
	for(int i=0; i<v1.length; i++) { 
		sum  += v1[i]*v2[i];
		sum1 += v1[i]*v1[i];
		sum2 += v2[i]*v2[i];
	}  
	if( sum1==0 | sum2==0 )
		return 0;
	else {
		double d = sum / ( Math.sqrt(sum1) * Math.sqrt(sum2) );
		return d;
	}
}

/**
 * Per questa distanza viene normalizzato solo il vettore <code>v2</code>
 * che rappresenta la pagina HTML.
 * Il vettore <code>v1</code> che rappresenta la query non viene normalizzato.
 */
public static synchronized double distanzaQuery(double v1[], double v2[]) {
	
      //normalizza solo il vettore v2 della rapp. della pagina Web
	double sum = 0;
	for(int i = 0; i < v2.length; i++)  
		sum = sum + Math.pow(v2[i], 2);
	double denominatore = Math.sqrt(sum);
      if (denominatore == 0)
            return 0;
      for(int i = 0; i < v2.length; i++)  
		v2[i] = v2[i]/denominatore;

      //calcola la distanza dei due vettori
      sum = 0;
      for(int i = 0; i < v2.length; i++)  
		sum = sum + v1[i]*v2[i];
	return sum;
	
}


}
