package uniba.core;

/** The couple Double-Integer (one element) for kNN Vector.
   *@author Giorgio Vespucci 1998
*/
public class kNNVectorElement {
   Double value;  // The value of similarity with 'page'.
   Integer code;  // The code of 'page' category.
		 
   /** Default constructor.
   */
   public kNNVectorElement() {
	  value = new Double(0.0);   // No similarity.
	  code = new Integer(99);    // Max index of category.
   }   
   /** Parametrized constructor.
   */
   public kNNVectorElement(double value, int code) {
	  this.value = new Double(value);
	  this.code = new Integer(code);
   }   
   /** Return the int code of category.
   */
   public int getCategoryCode() {
	  return code.intValue();
   }   
   /** Return the similarity value.
   */
   public double getSimilarityValue() {
	  return value.doubleValue();
   }   
   /** Am I greater than you ?
   */
   public boolean greaterThan(kNNVectorElement e) {
	  return (value.doubleValue() > e.getSimilarityValue());
   }   
   /** Set private attributes.
   */
   public void setData(double value, int code) {
	  this.value = new Double(value);
	  this.code = new Integer(code);
   }   
   /** Overidden method for System.out.println().
   */
   public String toString() {
	  return ("\n( " + code.toString() + ", " + value.toString() + " )");
   }   
} //end class