package uniba.databanker;

import java.sql.*;
import java.io.*;
import java.util.Enumeration;
import java.util.Vector;
import java.util.StringTokenizer;

/**
* L'Automa implementato dalla seguente classe<br>
* ha il compito di segnalare all'utente<br> 
* eventuali operazioni non ammesse nel<br>
* particolare stato in cui il sistema pu trovarsi.<br>
* Generando in output dei messaggi opportuni,<br>
* l'utente  inmformato sulla prossima operazione<br>
* corretta da eseguire.
*/
public class Automa {
        int statoIn = 0;
        int statoOut = 0;
        int codiceMsg = 0;
        int nroSessione = 0;
        int nroTestPage = 0;
        int nroTrainPage = 0;
        int nroOperazione = 0;
	  int disp = 0; 	
	  boolean enable = true;
	  ControlloreTraining control;	
        Connection connect;
        String utente;
        String operazione;

        public Automa(Connection con, String login, boolean enable) throws SQLException {
                connect = con;
		    utente = login;	
		    if (enable){	
		    	enable();
		    } else {
		      disable();}	 
		    init();
        }

//------------------------------------------------------------------------

/**
* Il metodo abilita l'Automa ad eseguire i controlli sulla correttezza della<br>
* sequenze delle operazioni richieste dall'utente.
*/

public void enable(){
	enable = true;
}
//------------------------------------------------------------------------

/**
* Disabilita l'Automa: non vengono pi eseguiti i controlli sulle operazioni<br>
* richieste dall'utente.
*/

public void disable(){
	enable = false;
}
//---------------------------------------------------------------------------

private void init() throws SQLException {
	if (enable) {
	  control = new ControlloreTraining(); 	
        String query = "SELECT * FROM configurazione WHERE "+
              "configurazione.login = '"+utente+"'";
        Statement stmt = connect.createStatement();
        ResultSet rs = stmt.executeQuery(query);
        rs.next();
        statoOut = rs.getInt("stato");
	  statoIn = statoOut;
        nroSessione = rs.getInt("nroSessione");
        nroSessione++;
        rs.close();stmt.close();
        query = "UPDATE configurazione SET nroSessione = "+
                nroSessione+" WHERE login = '"+utente+"'";
        Statement stmt1 = connect.createStatement();
        stmt1.executeUpdate(query);
        stmt1.close();
        Enumeration categorie = getRowCateg();
	  while (categorie.hasMoreElements()) {
		String c = (String)categorie.nextElement();
		nroTestPage = getRowPage(c, "testing");
            nroTrainPage = getRowPage(c, "training");
	      control.addElement(c, nroTrainPage, nroTestPage);
	  }
	}
}

//---------------------------------------------------------------------------

private Enumeration getRowCateg() throws SQLException {
    String query = "SELECT * FROM categoria WHERE login = '"+utente+"'";
    Statement stmt = connect.createStatement();
    ResultSet rs = stmt.executeQuery(query);
    Vector cat = new Vector();
    while (rs.next()) 
        cat.addElement((String)rs.getString("nomeCategoria"));
    rs.close();stmt.close();
    return cat.elements();
}

//---------------------------------------------------------------------------

private int getRowPage(String categoria, String tipo) throws SQLException {
    String query = "SELECT * FROM appartenenza WHERE "+
        "appartenenza.login = '" + utente + "' and " +
	  "appartenenza.tipo = '"+tipo+"' and " +
	  "appartenenza.nomeCategoria = '"+categoria+"'";
    Statement stmt = connect.createStatement();
    ResultSet rs = stmt.executeQuery(query);
    int count = 0;
    while (rs.next()) 
        count++;
    rs.close();stmt.close();
    return count;
}

//---------------------------------------------------------------------------

private void AddRemFromSet(String categoria) {
    if (operazione.equalsIgnoreCase("rc")) 
        statoOut = control.remElement(categoria, statoOut);
    if (operazione.equalsIgnoreCase("rtp"))
	  statoOut = control.remDocTraining(categoria, statoOut);
    if (operazione.equalsIgnoreCase("rsp"))
        statoOut = control.remDocTesting(categoria, statoOut);
    if (operazione.equalsIgnoreCase("ac")) 
	  statoOut = control.addElement(categoria, statoOut);	
    if (operazione.equalsIgnoreCase("atp"))
	  statoOut = control.addDocTraining(categoria, statoOut);
    if (operazione.equalsIgnoreCase("asp"))
	  statoOut = control.addDocTesting(categoria, statoOut);
	System.out.println("stato corrente: "+statoOut);
}

//---------------------------------------------------------------------------

private void getState() throws SQLException, OperationException {
        String query = "SELECT * FROM configurazioneIstantanea WHERE "+
              "stato = "+statoIn+" and operazione = '"+operazione+"'";
        Statement stmt = connect.createStatement();
        ResultSet rs = stmt.executeQuery(query);
        if (rs.next()) {
                statoOut = rs.getInt("statoArrivo");
                codiceMsg = rs.getInt("codMessaggio");
        } else {
                String msg = "Operazione inesistente o codice operazione errato!";
                OperationException oex = new OperationException(msg);
                throw oex;}
        rs.close();
        stmt.close();
}

//---------------------------------------------------------------------------

private void commit() throws SQLException {
	if (enable){
        Date data = new Date(System.currentTimeMillis());
        Time ora = new Time(System.currentTimeMillis());
        nroOperazione++;
        String query1 = "INSERT INTO sessione VALUES ('"+utente+
                "',"+nroSessione+","+nroOperazione+",'"+data.toString()+
                "','"+ora.toString()+"',"+statoIn+",'"+operazione+"')";
        Statement stmt = connect.createStatement();
        stmt.executeUpdate(query1);
        stmt.close();
        if (statoIn != statoOut) {
            String query2 = "UPDATE configurazione SET stato = "+statoOut+
                " WHERE login = '"+utente+"'";
            Statement stmt1 = connect.createStatement();
            stmt1.executeUpdate(query2);
            stmt1.close();
        }
	}
}       

//---------------------------------------------------------------------------

/**
* L'Automa passa al nuovo stato determinato dallo stato precedente<br>
* e dalla operazione. Questo metodo viene usato quando l'operazione in causa<br>
* modifica gli insiemi di testing o di training di una categoria o l'insieme delle<br>
* categorie stesse.
*/

public void Transizione(String operazione, String categoria) throws SQLException,
                        OperationException{
	if (enable) {
        	statoIn = statoOut;
	  	String msg = "";	
        	this.operazione = operazione;
        	connect.setAutoCommit(false);
        	getState();
	  	AddRemFromSet(categoria);
        	commit();
        	if (codiceMsg!=0) {
			msg = getMessage();
	      	OperationException edonv = new OperationException(msg);
	      	throw edonv;
		}
        	//connect.setAutoCommit(true);
	}
}

//---------------------------------------------------------------------------

/**
* L'Automa passa al nuovo stato determinato dallo stato precedente<br>
* e dalla operazione.
*/

public void Transizione(String operazione) throws SQLException,
                        OperationException{
	if (enable) {
        	statoIn = statoOut;
		String msg = "";	
        	this.operazione = operazione;
        	connect.setAutoCommit(false);
        	getState();
        	commit();
        	if (codiceMsg!=0){ 
			msg = getMessage();
		      OperationException edonv = new OperationException(msg);
		      throw edonv;
		}
        	//connect.setAutoCommit(true);
	}
}

//---------------------------------------------------------------------------

/**
* Produce il report completo sulla transizione appena avvenuta.
*/

public String report() throws SQLException {
      String msg = getMessage();
      String spazi = ":.............................";
      String result = "";
      result += ("Login"+spazi).substring(0, 20) + utente + "\n\n";
      result += ("Nro Sessione"+spazi).substring(0, 20) + nroSessione + "\n\n";
      result += ("Nro Operazione"+spazi).substring(0, 20) + nroOperazione + "\n\n";
      result += ("Stato Partenza"+spazi).substring(0, 20) + statoIn + "\n";
      result += ("Descrizione"+spazi).substring(0, 20) + 
		formattaStringa(getDesStato(statoIn)) + "\n\n";
      result += ("Operazione"+spazi).substring(0, 20) + operazione + "\n";
      result += ("Descrizione"+spazi).substring(0, 20) + 
		formattaStringa(getDesOperazione(operazione)) + "\n\n";
      result += ("Stato Arrivo"+spazi).substring(0, 20) + statoOut + "\n";
      result += ("Descrizione"+spazi).substring(0, 20) + 
		formattaStringa(getDesStato(statoOut)) + "\n\n";
      result += ("Testo Messaggio"+spazi).substring(0, 20) + 
		formattaStringa(msg) + "\n\n";
	result += control.getReport();
	return result;
}
 
//---------------------------------------------------------------------------

private String getMessage() throws SQLException {
	String msg = "";
     	String query = "SELECT * FROM messaggio WHERE codMessaggio = " + codiceMsg;
      Statement stmt = connect.createStatement();
      ResultSet rs = stmt.executeQuery(query);
	if (rs.next())
	     	msg = rs.getString("testoMessaggio");
	else
		msg = "Situazione non gestita dal sistema";		
      rs.close();
      stmt.close();
	return msg;
}
	
//---------------------------------------------------------------------------

private String getDesStato(int st) throws SQLException {
	String result = "";
	String query = "SELECT descrizione FROM stato WHERE codStato = " + st;
	Statement stmt = connect.createStatement();
	ResultSet rs = stmt.executeQuery(query);
	if (rs.next()) 
		result = rs.getString(1);
	else
		result = "Nessuna descrizione";
	rs.close();
	stmt.close();
	return result;
}
		
//---------------------------------------------------------------------------

private String getDesOperazione(String op) throws SQLException {
	String result = "";
	String query = "SELECT descrizione FROM operazione WHERE codOperazione = '" + op + "'";
	Statement stmt = connect.createStatement();
	ResultSet rs = stmt.executeQuery(query);
	if (rs.next())
		result = rs.getString(1);
	else
		result = "Nessuna descrizione";
	rs.close();
	stmt.close();
	return result;
}

//---------------------------------------------------------------------------

	private String formattaStringa(String msg) {
		String fs = "";
		String line = "";
		StringTokenizer st = new StringTokenizer(msg);
		while (st.hasMoreTokens()) {
			String token = st.nextToken();
			if ((line+token).length() + 20 > 58){
				fs = fs + line + "\n" + "                    " ;
				line = token + " ";}
			else {
				line = line + token + " ";
			}
		}
		fs += line;
		return fs;
	}
		
//--------------------------------------------------------------------------- 
       
}

        
        
