package uniba.databanker;

/**
* Questa classe  la rappresentazione degli insiemi di testing<br>
* e di training: in ogni momento  possibile conoscere le cardinalit<br>
* degli insiemi di testing e di training.
*/
public class Categoria {
	
	String categoria;
	int training = 0;
	int testing = 0;

/**
* Inizializza gli insiemi di <i>testing</i> e di <i>training</i> della <i>categoria</i> 
* specificata.
*/

	public Categoria(String categoria, int training, int testing) {
		this.categoria = categoria;
		this.training = training;
		this.testing = testing;
	}

/**
* Inizializza a 0 la cardinalit degli insiemi di <i>testing</i> e di <i>training</i> della 
* <i>categoria</i> specificata.
*/

	public Categoria(String categoria) {
		this.categoria = categoria;
		this.training = 0;
		this.testing = 0;
	}
	

//-------------------------------------------------------------------

/** 
* Incrementa la cardinalit dell'insieme di training<br>
* della categoria corrente.
*/

	public void incTraining(){
		training++;
	}

//------------------------------------------------------------

/** 
* Incrementa la cardinalit dell'insiemedi testing.
* della categoria corrente.
*/

	public void incTesting(){
		testing++;
	}

//------------------------------------------------------------

/** 
* Decrementa la cardinalit dell'insieme di training.
* della categoria corrente.
*/

	public void decTraining(){
		training--;
	}

//-----------------------------------------------------------

/** 
* Decrementa la cardinalit dell'insieme di testing.
* della categoria corrente.
*/

	public void decTesting(){
		testing--;
	}

//----------------------------------------

/**
* Restituisce il nome della categoria corrente.
*/

	public String getCategory() {
		return categoria;
	}

//------------------------------------

/**
* Restituisce la cardinalit dell'insieme di<br>
* testing della categoria corrente.
*/

	public int getTesting() {
		return testing;
	}

//------------------------------------

/**
* Restituisce la cardinalit dell'insieme di<br>
* training della categoria corrente.
*/

	public int getTraining() {
		return training;
	}

//---------------------------------------------

/**
* Produce un report relativo alla categoria corrente<br>
* comprendente il nome della categoria il numero di<br>
* pagine di testing e il numero di pagine di training.
*/	

	public String reportCategoria() {
		String result = "Categoria: " + categoria + " n.ro Training: " + training +
			" n.ro Testing: " + testing + "\n";
		return result;
	}

//----------------------------------------------------------

}
