package uniba.databanker;

import java.util.Enumeration;
import java.util.Vector;

/**
 * Questa classe permette di monitorare i cambiamenti nell'insieme di
 * addestramento del sistema, in modo tale che l'automa sia sempre 
 * aggiornato.
 */

public class ControlloreTraining {
	
	Vector ct;

	public ControlloreTraining(){
		ct = new Vector();
	}

//---------------------------------

/**
* Acquisisce una categoria <i>cat</i> con le cardinalit dei<br>
* suoi insiemi di training <i>train</i> e di testing <i>test</i>.
*/

	public void addElement(String cat, int train, int test) {
		ct.addElement(new Categoria(cat, train, test));
	}

//-----------------------------------

/**
* Aggiunge all'insieme di monitoraggio una nuova<br>
* categoria inserita dall'utente attraverso il sisteme WebClass.
*/

	public int addElement(String cat, int stato) {
		int s = stato;
		ct.addElement(new Categoria(cat));
		return s;
	}

//---------------------------------

/**
* Se l'utente elimina dal sisteme WebClass una<br>
* categoria, questa viene eliminata anche<br>
* dall'insieme di monitoraggio.
*/

	public int remElement(String categoria, int stato) {
		int s = stato;
		ct.removeElementAt(indexOf(categoria));
		if (ct.size() == 0) {
			return 1;
		}else{
			if (getAllTesting() > 0){
				return 22;
			}else{
				return 2;}
		}
	}

//---------------------------------

/**
* Se un documento di training viene aggiunto da un utente<br>
* attraverso il sistema WebClass allora anche la cardinalit<br>
* dell'insieme di addestramento dell'unit di<br>
* monitoraggio viene incrementata.
*/

	public int addDocTraining(String categoria, int stato) {
		int s = stato;
		((Categoria)ct.elementAt(indexOf(categoria))).incTraining();
		return s;
	}

//---------------------------------

/**
* Se un documento di testing viene eliminato da un utente<br>
* attraverso il sistema WebClass allora anche la cardinalit<br>
* dell'insieme di testing dell'unit di<br>
* monitoraggio viene decrementata.
*/

	public int remDocTraining(String categoria, int stato) {
		int s = stato;
		((Categoria)ct.elementAt(indexOf(categoria))).decTraining();
		if (s > 20)
			s = 20;
		else
			s = 0;
		if (getAllTraining() == 0) {
			return (2 + s);
		}else{
			return (3 + s);}
	}

//--------------------------------------

/**
* Se un documento di testing viene aggiunto da un utente<br>
* attraverso il sistema WebClass allora anche la cardinalit<br>
* dell'insieme di testing dell'unit di<br>
* monitoraggio viene incrementata.
*/

	public int addDocTesting(String categoria, int stato) {
		int s = stato;
		((Categoria)ct.elementAt(indexOf(categoria))).incTesting();
		if (s < 20)
			{return (s + 20);}
		else
			{return s;}
	}

//--------------------------------------

/**
* Se un documento di testing viene eliminato da un utente<br>
* attraverso il sistema WebClass allora anche la cardinalit<br>
* dell'insieme di testing dell'unit di<br>
* monitoraggio viene decrementata.
*/

	public int remDocTesting(String categoria, int stato) {
		int s = stato;
		((Categoria)ct.elementAt(indexOf(categoria))).decTesting();
		if (getAllTesting() == 0)
			if (s > 20)
				{return (s - 20);}
			else
				{return s;}
		else
			{return s;}
	}

//--------------------------------------

	private int indexOf(String categoria) {
		boolean found = false;
		int i = 0;
		while ((i < ct.size()) && (!found)) {
			if (((String)((Categoria) ct.elementAt(i)).getCategory()).
				equalsIgnoreCase(categoria)) 
				found = true;
			else
				i++;
		}
		if (found) 
			return i;
		else
			return (ct.size() - 1);
	}

//--------------------------------------

	private int getAllTesting() {
		int tot = 0;
		for (int i = 0;i<ct.size();i++) {
			tot = tot + (int)((Categoria)ct.elementAt(i)).getTesting();
		}
		return tot;
	}

//--------------------------------------

	private int getAllTraining() {
		int tot = 0;
		for (int i = 0;i<ct.size();i++) {
			tot = tot + (int)((Categoria)ct.elementAt(i)).getTraining();
		}
		return tot;
	}

//--------------------------------------

/**
* Restituisce la dimensione dell'unit di monitoraggio<br>
* che  pari al numero di categoria da esso controllate.
*/

	public int size() {
		return ct.size();
	}

//--------------------------------------

/**
* Produce un report per ogni categoira<br>
* controllata dall'unit di monitoraggio.
*/

	public String getReport() {
		String result = "";
		for (int i = 0;i < ct.size();i++) {
			result += ((Categoria)ct.elementAt(i)).reportCategoria();
		}
		return result;
	}

//------------------------------------------------

}	