package uniba.gui;

import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;

/**
 * Mostra informazioni su WebClass
 */
public class AboutDialog extends Dialog implements FocusListener, KeyListener {

  private Button okButton;
  private Image logo;
  private TextArea info;

  public AboutDialog(Frame f) {
	super(f,"About",true);
	setBackground(new Color(0).lightGray);
	Toolkit t=getToolkit();
	logo=t.getImage("c:/giove/gifs/wbilogo.gif");
	okButton=new Button("Ok");
	Panel infoPanel = new Panel();

	info = new TextArea(15,35);
	info.setEditable(false);
	info.setText("     \n\nWebClass Workbench 1.0\n\n LACAM Universit di Bari\n\n        1998");
	infoPanel.add(info);
	Panel buttonPanel = new Panel();
	buttonPanel.add(okButton);
	add("Center",infoPanel);
	add("South",buttonPanel);
	resize(290,290);
      Toolkit tk = f.getToolkit();
      int scw   = tk.getScreenSize().width;
      int sch   = tk.getScreenSize().height;
      int w     = this.size().width;
      int h     = this.size().height;
      setLocation((scw/2)-(w/2), (sch/2)-(h/2));
	setResizable(false);
      addWindowListener(new WindowAdapter() {
					public void windowClosing(WindowEvent e) {
						setVisible(false);
					}
				});
      okButton.addKeyListener(this);
      okButton.addMouseListener(new MouseAdapter() {
					    public void mouseClicked(MouseEvent e) {
						  setVisible(false);
					    }	
                                 });
      info.addFocusListener(this);
      setVisible(true);
  }  

  public void focusGained(FocusEvent e) {
	if (e.getSource().equals(info))
		info.transferFocus();
  }

  public void focusLost(FocusEvent e) {}		

  public void keyPressed(KeyEvent ke) {
	if (ke.getKeyChar() == ke.VK_ENTER) 
		setVisible(false);
  }

  public void keyTyped(KeyEvent ke) {}

  public void keyReleased(KeyEvent ke) {}


  
  public void paint(Graphics g) {
	 g.drawImage(logo,40,20,this);
  }  
}