package uniba.gui;

import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.sql.SQLException;
import uniba.core.*;
import uniba.databanker.*;

/**
 * Permette di aggiungere pagine di training o di testing
 */
public class AddPageDialog extends Dialog implements ItemListener,
      								  MouseListener {
									  

	private Frame parent = null;
      private java.awt.List pagineDB = new java.awt.List(6, true);
      private Button add = new Button("Add"); 
      private Button annulla = new Button("Cancel");
      private Label pages = new Label("Pages of Database:");
      private Vector documents = null;
      private CheckboxGroup cbg = new CheckboxGroup();
	private Checkbox tr = new Checkbox("Training", cbg, true);
	private Checkbox ts = new Checkbox("Testing", cbg,  false);
      private String urlPages[] = null;
      private int idPages[] = null;
      private String tipo = null;
      Databanker db = null;
 

	public AddPageDialog(Frame parent, 
                           Vector documents,
				   Databanker db)  {

		    super(parent, "Add Training/Testing Page", true);
                this.parent = parent;
                this.documents  = documents;
		    this.db = db;	
                
                GridBagLayout gridbag = new GridBagLayout();
                GridBagConstraints constraints = new GridBagConstraints();
                setLayout(gridbag);
                                
		    buildConstraints(constraints, 0, 0, 1, 1, 50, 10, GridBagConstraints.NONE, GridBagConstraints.WEST);
                gridbag.setConstraints(pages, constraints);
                add(pages);
                pages.setBackground(Color.lightGray);

                buildConstraints(constraints, 0, 1, 1, 3, 50, 70, GridBagConstraints.BOTH, GridBagConstraints.NORTH);
                gridbag.setConstraints(pagineDB, constraints);
                add(pagineDB);
		    pagineDB.addItemListener(this);	

                buildConstraints(constraints, 0, 4, 1, 1, 50, 20, GridBagConstraints.NONE, GridBagConstraints.SOUTH);
                gridbag.setConstraints(add,constraints);
                add(add);
                add.addMouseListener(this);
                add.setEnabled(false);

		    buildConstraints(constraints, 1, 4, 1, 1, 50, 20, GridBagConstraints.NONE, GridBagConstraints.SOUTH);
                gridbag.setConstraints(annulla,constraints);
                add(annulla);
                annulla.addMouseListener(this);
                               
		    
                buildConstraints(constraints, 1, 1, 1, 1, 50, 35, GridBagConstraints.NONE, GridBagConstraints.CENTER);
                gridbag.setConstraints(tr, constraints);
                add(tr);
		    tr.setBackground(Color.lightGray);	
                
                
		    buildConstraints(constraints, 1, 2, 1, 1, 50, 35, GridBagConstraints.NONE, GridBagConstraints.CENTER);
                gridbag.setConstraints(ts, constraints);
                add(ts);
		    ts.setBackground(Color.lightGray);	
                addWindowListener( new WindowAdapter() {
                                     public void windowClosing(WindowEvent e) {
                                          setVisible(false);
						 }
                                   } );

		    if (documents.size() > 0) {
				Enumeration d = documents.elements();
                		while (d.hasMoreElements()) 
					pagineDB.add((String)d.nextElement());
		    } else
				pages.setText("No Documents");	
                

                
		    setSize(350, 200); 
                Toolkit t = parent.getToolkit();
	          int scw   = t.getScreenSize().width;
	          int sch   = t.getScreenSize().height;
	          int w     = this.size().width;
	          int h     = this.size().height;
	          setLocation((scw/2)-(w/2), (sch/2)-(h/2));	
                setResizable(false);
                setVisible(true);
                

        }

        public void itemStateChanged(ItemEvent ie) {
		
			String items[] = pagineDB.getSelectedItems();
                  if (items.length > 0) {
				add.setEnabled(true);
                  	idPages = new int[items.length];
                  	urlPages = new String[items.length];
                  	for (int i=0; i<items.length; i++) {
					StringTokenizer st = new StringTokenizer(items[i]);
					idPages[i] = new Integer(st.nextToken()).intValue();
					urlPages[i] = st.nextToken();
                  	}
			} else
				add.setEnabled(false);   
	  }

	  /**
         * Restituisce il tipo di dicumento scelto (Training o Testing)
         */
        public String getType() {
		return cbg.getSelectedCheckbox().getLabel().toUpperCase();
	  }

	  public int[] getIdDoc() {
		return idPages;
	  }
         
	  public String[] getUrlDoc() {
		return urlPages;
	  }
	  
        private void buildConstraints(GridBagConstraints gbc, int gx,
           int gy, int gw, int gh, int wx, int wy,
           int fill, int anchor) {
             
             gbc.gridx = gx;
             gbc.gridy = gy;
             gbc.gridwidth = gw;
             gbc.gridheight = gh;
             gbc.weightx = wx;
             gbc.weighty = wy;
             gbc.fill = fill;
             gbc.anchor = anchor;
        }

	  public void mouseClicked(MouseEvent e) {
 		Button source = (Button)e.getSource();
		if (source.equals(annulla)) {
			urlPages = null;
                  idPages = null;
                  tipo = null;
			setVisible(false);
            } else if (source.equals(add)) {
			setCursor(new Cursor(Cursor.WAIT_CURSOR));
			add.setEnabled(false);
			setVisible(false);
		}
        } 

        public void mousePressed(MouseEvent e) {}

        public void mouseReleased(MouseEvent e) {}

        public void mouseEntered(MouseEvent e) {}
 
        public void mouseExited(MouseEvent e) {}

        
	

}