package uniba.gui;

/* file      : ProgressPanel.java
 */

import java.util.*;
import java.awt.*;

class BarProgress extends Panel implements Cloneable,Runnable{
  Image offscreen = null; // offscreen surface to write to
  Dimension offscreensize = null;
  Graphics offgraphics = null;
  String message="";
  // some layout constants
  private int maxValue = 100;
  private int currValue = 0;
  private boolean directionLtoR=true;
  public Color line_color = Color.black;
  public Color background_color =  Color.blue;//new Color (118,255,212);  // prima era (189,255,255)
  public Color foreground_color =  Color.yellow;//new Color (118,255,212);  // prima era (189,255,255)
  public Thread workInProgress;

 public BarProgress(int wid,int hei,String messagePar) {
	message=messagePar;
	workInProgress = new Thread(this);
	workInProgress.setPriority(workInProgress.getThreadGroup().getMaxPriority());
	workInProgress.start();
	repaint();
 }    
  public  boolean handleEvent( Event evt )    {
// Check for a window destroy event.
	if( evt.id == Event.WINDOW_DESTROY ) {
	  //dispose();
	  System.exit(0);
	  return true;
	  }
	if( evt.id == Event.WINDOW_EXPOSE ) {
	  System.out.println("E mo'");
	  return true;
	  }
	if( evt.id == Event.WINDOW_DEICONIFY ) {
	  show();
	  return true;
	  }
	if( evt.id == Event.WINDOW_ICONIFY ) {
	  hide();
	  return true;
	  }
	return super.handleEvent(evt);
	}
 public void hide()  {
	workInProgress.stop();
	super.hide();
	}
 public void increaseValue( int inc )  {
	currValue += inc;
//    if( currValue > maxValue ) currValue = maxValue;
	if( currValue > maxValue ) {
		currValue = 0;
		if (directionLtoR) directionLtoR=false;
		else directionLtoR=true;
	}
	repaint();
	}
  public boolean mouseDown(Event evt,int x,int y) {
//	  increaseValue(1);
	return false;
  }  
  public void paint(Graphics g) {
	// System.out.println("TreeViewPanel::paint()");
	// draws into offscreen Graphics
	Dimension d = size();
	int barWidth;
	if ((offscreen == null) || (d.width != offscreensize.width) || (d.height != offscreensize.height)) {
//		System.out.println("Creo Immagine "+offscreen+d.width+" "+d.height);
		try { offscreen = createImage(d.width, d.height);}
		catch (java.lang.IllegalArgumentException e ){}
	  offscreensize = d;
	  offgraphics = offscreen.getGraphics();
	  offgraphics.setFont(getFont());
	  //     offgraphics.setColor(getBackground());
	  offgraphics.setColor(background_color);
	  offgraphics.fillRect(0, 0, d.width, d.height);
	}
	g.drawImage(offscreen, 0, 0, null);
		barWidth = (d.width*currValue)/maxValue;
	    g.setColor(foreground_color);
		if (directionLtoR) g.fillRect(barWidth,0,size().width-barWidth,size().height);
		else g.fillRect(0,0,size().width-barWidth,size().height);
	    g.setColor(Color.black);
		g.drawString(message,0,size().height-1);

//        g.fillRect(0,0,size().width-barWidth,size().height);
  }  
 public void run() {
	while (true){
		try {
		workInProgress.sleep(30);
		increaseValue(1);
		} catch (Exception e) {}
	}
 } 
 public void show()  {

	workInProgress = new Thread(this);
	workInProgress.start();
	repaint();
//	System.out.println("SHOW");
	super.show();
 }    
  public void update(Graphics g) {
	// force redraw :
//    offscreen = null;
	paint(g);
  }  
}
