package uniba.gui;

import java.awt.*;
import java.awt.event.*;
import java.util.Vector;

/**
 * Permette la cancellazione di una categoria
 */
public class CancellazioneCategoria extends Dialog {

	private Choice categorie = new Choice();
	private Label l = new Label("Category:");
	private Vector categories = null;
	private Button cancella = new Button("Delete Category");
	private Button annulla = new Button("Cancel");
	private String categoriaDaCancellare = null;

	public CancellazioneCategoria(Frame parent, Vector categories) {

		super(parent, "Delete Category", true);
		this.categories = categories;
		GridBagLayout gridbag = new GridBagLayout();
            GridBagConstraints constraints = new GridBagConstraints();
            setLayout(gridbag);
		setBackground(Color.lightGray);
		
		addWindowListener( new WindowAdapter() {
						public void windowClosing(WindowEvent we) {
                                          categoriaDaCancellare = null;
							setVisible(false);
						}
					 });
		l.setBackground(Color.lightGray);
		buildConstraints(constraints, 0, 0, 1, 1, 50, 50, GridBagConstraints.NONE, GridBagConstraints.CENTER);
            gridbag.setConstraints(l, constraints);
		add(l);
			
            int i;	
		for (i = 0; i<categories.size(); i++)
			categorie.addItem((String)categories.elementAt(i));
            cancella.setEnabled((i != 0));
		buildConstraints(constraints, 1, 0, 1, 1, 50, 50, GridBagConstraints.NONE, GridBagConstraints.CENTER);
            gridbag.setConstraints(categorie, constraints);
		add(categorie);

		annulla.addMouseListener(new MouseAdapter() {
							public void mouseClicked(MouseEvent me) {
								categoriaDaCancellare = null; 
								setVisible(false);
							}
						 });
		buildConstraints(constraints, 0, 1, 1, 1, 50, 50, GridBagConstraints.NONE, GridBagConstraints.CENTER);
            gridbag.setConstraints(annulla, constraints);
		add(annulla); 

		cancella.addMouseListener(new MouseAdapter() {
							public void mouseClicked(MouseEvent me) {
							   categoriaDaCancellare = categorie.getSelectedItem();
                                             setVisible(false);
							}
						  });
		buildConstraints(constraints, 1, 1, 1, 1, 50, 50, GridBagConstraints.NONE, GridBagConstraints.CENTER);
            gridbag.setConstraints(cancella, constraints);
		add(cancella);
		setSize(250, 150);
            Toolkit t = parent.getToolkit();
            int scw   = t.getScreenSize().width;
	      int sch   = t.getScreenSize().height;
	      int w     = this.size().width;
	      int h     = this.size().height;
	      setLocation((scw/2)-(w/2), (sch/2)-(h/2));	
            setResizable(false);
            setVisible(true);

	}

	private void buildConstraints(GridBagConstraints gbc, int gx,
           int gy, int gw, int gh, int wx, int wy,
           int fill, int anchor) {
             
             gbc.gridx = gx;
             gbc.gridy = gy;
             gbc.gridwidth = gw;
             gbc.gridheight = gh;
             gbc.weightx = wx;
             gbc.weighty = wy;
             gbc.fill = fill;
             gbc.anchor = anchor;
        }

	  /**
         * Restituisce la categoria da cancellare
         */
	  public String getCategory() {
		return categoriaDaCancellare;
	  }	


}
		
		
		

	