package uniba.gui;

import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.sql.SQLException;
import uniba.core.*;
import uniba.databanker.*;


/**
 * Mostra un riassunto delle categorie e delle pagine di testing
 * e di training
 */
public class CategoriesDialog extends Dialog implements ItemListener,
      								  MouseListener {
									  

	private Frame parent = null;
      private CategoriesManager cgm = null;
      private TrainingPagesManager trpm = null;
	private TestingPagesManager tspm = null;
      private java.awt.List categorie = new java.awt.List(6, false);
      private java.awt.List trainingPages = new java.awt.List(6, true);
      private java.awt.List testingPages = new java.awt.List(6, true);
      private Button addPage = new Button("Add Training/Testing Page"); 
      private Button view = new Button("View HTML Page");
      private Button remove = new Button("Remove");
      private Button trToTs = new Button("From Training to Testing");
      private Button tsToTr = new Button("From Testing to Training");
      private Label cat = new Label("Categories:");
      private Label testing = new Label("Testing Pages:");
      private Label training = new Label("Training Pages:");
      private boolean viewTraining = false;
      private boolean viewTesting = false;
      private Databanker db = null;
      private String utente = "";
	private String categoriaCorrente;

	public CategoriesDialog(Frame parent, 
                              CategoriesManager cgm,
					TrainingPagesManager trpm,
					TestingPagesManager tspm,
                              Databanker db,
                              String utente) {

		    super(parent, "Categories Manager", true);
                this.parent = parent;
                this.cgm  = cgm;
                this.trpm = trpm;
                this.tspm =tspm; 
                this.db = db;
                this.utente = utente;
                GridBagLayout gridbag = new GridBagLayout();
                GridBagConstraints constraints = new GridBagConstraints();
                setLayout(gridbag);
                                
		    buildConstraints(constraints, 0, 0, 1, 1, 50, 10, GridBagConstraints.NONE, GridBagConstraints.WEST);
                gridbag.setConstraints(cat, constraints);
                add(cat);
                cat.setBackground(Color.lightGray);

                buildConstraints(constraints, 1, 0, 1, 1, 50, 10, GridBagConstraints.NONE, GridBagConstraints.WEST);
                gridbag.setConstraints(training, constraints);
                add(training);
                training.setBackground(Color.lightGray);
                
                categorie.addItemListener(this);
                buildConstraints(constraints, 0, 1, 1, 1, 50, 30, GridBagConstraints.BOTH, GridBagConstraints.CENTER);
                gridbag.setConstraints(categorie, constraints);
                add(categorie);

		    trainingPages.addItemListener(this);	
                buildConstraints(constraints, 1, 1, 1, 1, 50, 30, GridBagConstraints.BOTH, GridBagConstraints.CENTER);
                gridbag.setConstraints(trainingPages, constraints);
                add(trainingPages);
                

                buildConstraints(constraints, 1, 2, 1, 1, 50, 10, GridBagConstraints.NONE, GridBagConstraints.WEST);
                gridbag.setConstraints(testing, constraints);
                add(testing);
                testing.setBackground(Color.lightGray);

		    testingPages.addItemListener(this);
                buildConstraints(constraints, 1, 3, 1, 3, 50, 30, GridBagConstraints.BOTH, GridBagConstraints.CENTER);
                gridbag.setConstraints(testingPages, constraints);
                add(testingPages);

                addPage.addMouseListener(this);  
		    buildConstraints(constraints, 0, 6, 1, 1, 50, 20, GridBagConstraints.NONE, GridBagConstraints.CENTER);
                gridbag.setConstraints(addPage, constraints);
                add(addPage);
                addPage.setEnabled(false);

                buildConstraints(constraints, 0, 3, 1, 1, 50, 10, GridBagConstraints.NONE, GridBagConstraints.CENTER);
                gridbag.setConstraints(remove, constraints);
                add(remove);
                remove.addMouseListener(this);

                buildConstraints(constraints, 0, 4, 1, 1, 50, 10, GridBagConstraints.NONE, GridBagConstraints.CENTER);
                gridbag.setConstraints(trToTs, constraints);
                add(trToTs);
                trToTs.addMouseListener(this);

                buildConstraints(constraints, 0, 5, 1, 1, 50, 10, GridBagConstraints.NONE, GridBagConstraints.CENTER);
                gridbag.setConstraints(tsToTr, constraints);
                add(tsToTr);
                tsToTr.addMouseListener(this);


		    view.setEnabled(false);	 
                view.addMouseListener(this);
	          buildConstraints(constraints, 1, 6, 1, 1, 50, 20, GridBagConstraints.NONE, GridBagConstraints.CENTER);
                gridbag.setConstraints(view, constraints);
                add(view);
                                                                                
                addWindowListener( new WindowAdapter() {
                                     public void windowClosing(WindowEvent e) {
                                          setVisible(false);
						 }
                                   } );

		    Enumeration c = cgm.listCategories();
                while (c.hasMoreElements()) 
                    categorie.add((String)c.nextElement());
                

                remove.setEnabled(false);
                trToTs.setEnabled(false);
                tsToTr.setEnabled(false);
		    setSize(750, 400); 
                Toolkit t = parent.getToolkit();
	          int scw   = t.getScreenSize().width;
	          int sch   = t.getScreenSize().height;
	          int w     = this.size().width;
	          int h     = this.size().height;
	          setLocation((scw/2)-(w/2), (sch/2)-(h/2));	
                setResizable(false);
                setVisible(true);
                

        }

        public void itemStateChanged(ItemEvent ie) {
            if (ie.getSource().equals(categorie)) {
                remove.setEnabled(false);
                tsToTr.setEnabled(false);
                trToTs.setEnabled(false);
                view.setEnabled(false);  
                addPage.setEnabled(true);
		    String cat = categorie.getSelectedItem();
                trainingPages.removeAll();
                testingPages.removeAll();
		    if (cat != null) {
			 categoriaCorrente = cat;	
                   Enumeration tr = trpm.listPages();
                   while (tr.hasMoreElements()) {
		     		StringTokenizer st = new StringTokenizer((String)tr.nextElement());	
                        int idDoc = (new Integer(st.nextToken())).intValue();
				String categ = st.nextToken();
				String urlDoc = st.nextToken();
				if (cat.equalsIgnoreCase(categ))
					trainingPages.add(idDoc + " " + urlDoc);
		       }
                   Enumeration ts = tspm.listPages();
                   while (ts.hasMoreElements()) {
		     		StringTokenizer st = new StringTokenizer((String)ts.nextElement());	
				int idDoc = (new Integer(st.nextToken())).intValue();
				String categ = st.nextToken();
				String urlDoc = st.nextToken();
				                       
                        if (cat.equalsIgnoreCase(categ))
					testingPages.add(idDoc + " " + urlDoc);
		       }
                }
            } else if (ie.getSource().equals(trainingPages)) {
                      int indici[] = testingPages.getSelectedIndexes();
                      for (int i = 0; i<indici.length; i++)
                      		testingPages.deselect(indici[i]);
                      viewTraining = true;
                      viewTesting = false;
                      int ind[] = trainingPages.getSelectedIndexes();
                      if (ind.length == 1)
                      		view.setEnabled(true);
                      else
					view.setEnabled(false);
                      remove.setEnabled(true);
                      trToTs.setEnabled(true); 
                      tsToTr.setEnabled(false);
            } else {
                      int indici[] = trainingPages.getSelectedIndexes(); 
                      for (int i = 0; i<indici.length; i++)
                               trainingPages.deselect(indici[i]);
                      viewTraining = false;
                      viewTesting = true;
                      int ind[] = testingPages.getSelectedIndexes();
                      if (ind.length == 1)
                      		view.setEnabled(true);
                      else
					view.setEnabled(false); 
                      remove.setEnabled(true);
                      tsToTr.setEnabled(true);
                      trToTs.setEnabled(false);
            } 
          }

			




        private void buildConstraints(GridBagConstraints gbc, int gx,
           int gy, int gw, int gh, int wx, int wy,
           int fill, int anchor) {
             
             gbc.gridx = gx;
             gbc.gridy = gy;
             gbc.gridwidth = gw;
             gbc.gridheight = gh;
             gbc.weightx = wx;
             gbc.weighty = wy;
             gbc.fill = fill;
             gbc.anchor = anchor;
        }

	  public void mouseClicked(MouseEvent e) {
            if ( e.getSource().equals(view) ) {
			String host = null;
		     	String porta = null;		
		     	String url = null;	
		     	try {	
		     		host = (String)db.getConfiguration(utente).elementAt(12);	
		     		porta = (String)db.getConfiguration(utente).elementAt(13);	
				url = "http://" + host + ":" + porta + "/";
		     	} catch (Exception se) {
				new StampaErrore(parent, "Categories Dialog", se.getMessage());
		     	}	
                 	if (url != null) {
                 		if (viewTraining)
		         		url = url + trainingPages.getSelectedItem();
                 		else
                     		url = url + testingPages.getSelectedItem();
                 		try {
                     		new Explorer(url, 4);
                 		} catch (UnsatisfiedLinkError ule) {
                     		new StampaErrore(parent, "CategoriesDialog", "Impossibile aprire Internet Explorer:\n" +
                           						      "per utilizzare questa funzione, compilare\n" +
                           							"ed eseguire WebClass con i tools\n" +
                           							"della Microsoft per Java.");

                 		}
			}
            } else if ( e.getSource().equals(tsToTr) ) {
		    setCursor(new Cursor(Cursor.WAIT_CURSOR));	
                try {
                  String item[] = testingPages.getSelectedItems();
                  for (int i = 0; i < item.length; i++) {
				StringTokenizer st = new StringTokenizer(item[i]);
				int idDoc = (new Integer(st.nextToken())).intValue();
				db.getAutoma().Transizione("rsp",categoriaCorrente);
				db.getAutoma().Transizione("atp",categoriaCorrente);
				db.updateType(utente, categorie.getSelectedItem(), idDoc, "TRAINING");
				
			}
                  trpm.updateTrainingPages();
                  tspm.updateTestingPages();
                  trainingPages.removeAll();
                  testingPages.removeAll(); 
                  remove.setEnabled(false);
                  tsToTr.setEnabled(false);
                  trToTs.setEnabled(false);
                  view.setEnabled(false);
                } catch (Exception ex) {
                        new StampaErrore(parent, "CategoriesDialog", "Exception:\n"+ex.getMessage());
                  } 
			finally{
		     		setCursor(new Cursor(Cursor.DEFAULT_CURSOR));}	
            } else if ( e.getSource().equals(addPage) ) {
			String category = categorie.getSelectedItem();
                  if ( !category.equals("UNKNOWN") ) {
                    try {
				addPage.setEnabled(false);
				AddPageDialog ap = new AddPageDialog(parent,
                                                             db.getOrdinaryPages(utente), db);
				addPage.setEnabled(true);
                        if (ap.getIdDoc() != null) { 
                        	int idDoc[] = ap.getIdDoc();
                        	String urlDoc[] = ap.getUrlDoc();
					String tipo = ap.getType();
					String op = "";
					if (tipo.equalsIgnoreCase("TRAINING")){
						op = "atp";}
					else
					if (tipo.equalsIgnoreCase("TESTING")){
						op = "asp";}
                        	for (int i=0; i<idDoc.length; i++){
						db.getAutoma().Transizione(op, category);
						db.updateType(utente, category, idDoc[i], tipo);
					}
					tspm.updateTestingPages();
                    		trpm.updateTrainingPages();
                    		trainingPages.removeAll();
                    		testingPages.removeAll(); 
                        }
                    } catch(Exception ex) {
                         new StampaErrore(parent, "CategoriesDialog", "Exception:\n"+ex.getMessage());
                    } 
			}

            } else if ( e.getSource().equals(trToTs) ) {
   		     setCursor(new Cursor(Cursor.WAIT_CURSOR));	
                 try {
                    String item[] = trainingPages.getSelectedItems();
                    for (int i = 0; i < item.length; i++){
				StringTokenizer st = new StringTokenizer(item[i]);
				int idDoc = (new Integer(st.nextToken())).intValue();
				db.getAutoma().Transizione("rtp",categoriaCorrente);
				db.getAutoma().Transizione("asp",categoriaCorrente);
				db.updateType(utente, categorie.getSelectedItem(), idDoc, "TESTING");
			  }	
                    tspm.updateTestingPages();
                    trpm.updateTrainingPages();
                    trainingPages.removeAll();
                    testingPages.removeAll(); 
                    remove.setEnabled(false);
                    tsToTr.setEnabled(false);
                    trToTs.setEnabled(false);
                    view.setEnabled(false);
                 } catch (Exception ex) {
                        new StampaErrore(parent, "CategoriesDialog", "Exception:\n"+ex.getMessage());
                   } 
			finally{
		     		setCursor(new Cursor(Cursor.DEFAULT_CURSOR));}	
            } else if ( e.getSource().equals(remove) ) {
		     setCursor(new Cursor(Cursor.WAIT_CURSOR));	
                 try {
                     if (viewTraining){
                            String item[] = trainingPages.getSelectedItems();
                            for (int i = 0; i < item.length; i++)	 {
                                   StringTokenizer st = new StringTokenizer(item[i]);
                                   int idDoc = (new Integer(st.nextToken())).intValue();
					     db.getAutoma().Transizione("rtp",categoriaCorrente);  	
					     db.updateType(utente, categorie.getSelectedItem(), idDoc, "");
					     
				    }
			   }else{
                            String item[] = testingPages.getSelectedItems();
                            for (int i = 0; i < item.length; i++)	{
					     StringTokenizer st = new StringTokenizer(item[i]);
                                   int idDoc = (new Integer(st.nextToken())).intValue();
					     db.getAutoma().Transizione("rsp",categoriaCorrente);
					     db.updateType(utente, categorie.getSelectedItem(), idDoc, "");  
					     
                            }       
			   }
                     tspm.updateTestingPages();
                     trpm.updateTrainingPages();
                     trainingPages.removeAll();
                     testingPages.removeAll(); 
                     remove.setEnabled(false);
                     tsToTr.setEnabled(false);
                     trToTs.setEnabled(false); 
                 } catch (Exception ex) {
                      new StampaErrore(parent, "CategoriesDialog", "Exception:\n"+ex.getMessage());
                 }
			finally{
		     		setCursor(new Cursor(Cursor.DEFAULT_CURSOR));}	
            }

        } 

        public void mousePressed(MouseEvent e) {}

        public void mouseReleased(MouseEvent e) {}

        public void mouseEntered(MouseEvent e) {}
 
        public void mouseExited(MouseEvent e) {}

        
	

}