package uniba.gui;

import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.sql.SQLException;
import uniba.databanker.*;
import uniba.core.*;

/**
* Attraverso la finestra di dialogo generata dalla<br>
* seguente classe  possibile eliminare un utente e<br>
* l'insieme degli oggetti ad esso correlati.
*/

public class ChangeUserDialog extends Dialog implements MouseListener {

	Frame parent = null;
	Label lUser;
	Choice cLogin;
	Button changeBut, closeBut;
	String utente;
	Databanker db;
	

	public ChangeUserDialog(Frame parent, String utente, Databanker db)
							throws SQLException {
		super(parent, "WebClass - Change User -", true);
	 	this.parent = parent;
		this.db = db;
		this.utente = utente;
		init();
	}

//---------------------------------------------------------------------------------------
		
private void init() throws SQLException {
	GridBagLayout gridbag = new GridBagLayout();
	GridBagConstraints constraints = new GridBagConstraints();
	constraints.insets = new Insets(0,0,0,0);
	setLayout(gridbag);

	// Etichetta lUser
	buildConstraints(constraints, 0, 0, 2, 1, 0, 20);
	constraints.fill = GridBagConstraints.NONE;
	constraints.anchor = GridBagConstraints.SOUTHWEST;
	lUser = new Label("User List:", Label.LEFT);
	gridbag.setConstraints(lUser, constraints);
	add(lUser);
	lUser.setBackground(Color.lightGray);

	// Scelta cLogin
	buildConstraints(constraints, 0, 1, 2, 1, 0, 40);
	constraints.fill = GridBagConstraints.HORIZONTAL;
	constraints.anchor = GridBagConstraints.NORTH;
	cLogin = new Choice();
	gridbag.setConstraints(cLogin, constraints);
	Vector log = new Vector();
	log = db.getLogin();
	String candidato = "";
	for (int i = 0;i < log.size();i++){ 
		candidato = (String)log.elementAt(i);
		if (!candidato.equalsIgnoreCase(utente)) 
			cLogin.add(candidato);
	}
	add(cLogin);

	// Pulsante changeBut
	buildConstraints(constraints, 0, 2, 1, 1, 50, 20);
	constraints.fill = GridBagConstraints.NONE;
	constraints.anchor = GridBagConstraints.EAST;
	changeBut = new Button("Change");
	gridbag.setConstraints(changeBut, constraints);
	changeBut.addMouseListener(this);
	add(changeBut);
		
	// Pulsante closeBut
	buildConstraints(constraints, 1, 2, 1, 1, 50, 0);
	constraints.fill = GridBagConstraints.NONE;
	constraints.anchor = GridBagConstraints.WEST;
	closeBut = new Button("Close");
	gridbag.setConstraints(closeBut, constraints);
	closeBut.addMouseListener(this);
	add(closeBut);

	this.addWindowListener(new WindowAdapter() {
		public void windowClosing(WindowEvent e) {
			setVisible(false);}
		});

	setSize(200, 100); 
      Toolkit t = parent.getToolkit();
      int scw   = t.getScreenSize().width;
      int sch   = t.getScreenSize().height;
      int w     = this.size().width;
      int h     = this.size().height;
      setLocation((scw/2)-(w/2), (sch/2)-(h/2));	
      setResizable(false);
      setVisible(true);
}

//-----------------------------------------------------------------------------
		
private void buildConstraints(GridBagConstraints gbc, int gx, int gy, int gw, int gh,
	int wx, int wy) {
           
      gbc.gridx = gx;
      gbc.gridy = gy;
      gbc.gridwidth = gw;
      gbc.gridheight = gh;
      gbc.weightx = wx;
      gbc.weighty = wy;
}

//-----------------------------------------------------------------

public void mousePressed(MouseEvent e) {}

public void mouseReleased(MouseEvent e) {}

public void mouseEntered(MouseEvent e) {}

public void mouseExited(MouseEvent e) {}

public void mouseClicked(MouseEvent e) {

	if (((Button)e.getSource()).getLabel().equals("Close")) {
		setVisible(false);
	} else
	if (((Button)e.getSource()).getLabel().equals("Change")) {
		utente = null;
		utente = cLogin.getSelectedItem();
		setVisible(false);
	}
}		

//--------------------------------------------------------------

public String getUser() {
	return utente;
}

//------------------------------------------------------------

}
 

