package uniba.gui;

import java.awt.*;
import java.io.*;
import java.applet.Applet;
import java.awt.event.*;
import java.sql.SQLException;
import java.sql.Time;
import java.sql.Date;
import uniba.databanker.*;

/**
* La classe implementa l'interfaccia per l'utente<br>
* che presenta il report relativo all'ultima<br>
* operazione esguita.
*/

public class ControlDialog extends Dialog implements MouseListener, Runnable{

	Frame parent = null;
	TextArea reportLabel;
	Label oraGiorno;
	Button ok;
	String report;
	String utente;
	Databanker db;
	Thread tr = null;
	
	public ControlDialog(Frame parent, String utente, Databanker db) 
					throws SQLException {
		
		super(parent, "Control Report", true);
		this.parent = parent;
		this.db = db;
		this.utente = utente;
		GridBagLayout gridbag = new GridBagLayout();
		GridBagConstraints constraints = new GridBagConstraints();
		constraints.insets = new Insets(0,0,0,0);
		setLayout(gridbag);

		// Area di teso report
		buildConstraints(constraints, 0, 0, 1, 1, 100, 80);
		constraints.fill = GridBagConstraints.BOTH;
		constraints.anchor = GridBagConstraints.NORTH;
		reportLabel = new TextArea(db.getAutoma().report(), 31, 50);
		reportLabel.setFont(new Font("Courier",0,12));
		reportLabel.setForeground(Color.blue);
		reportLabel.setBackground(Color.lightGray);
		reportLabel.setEditable(false);
		gridbag.setConstraints(reportLabel, constraints);
		add(reportLabel);

		// Etichetta orario
		buildConstraints(constraints, 0, 1, 1, 1, 0, 10);
		constraints.fill = GridBagConstraints.BOTH;
		constraints.anchor = GridBagConstraints.CENTER;
		oraGiorno = new Label();
		oraGiorno.setFont(new Font("Courier",0,12));
		oraGiorno.setBackground(Color.lightGray);
		gridbag.setConstraints(oraGiorno, constraints);
		add(oraGiorno);

		// Pulsante ok
		buildConstraints(constraints, 0, 2, 1, 1, 0, 10);
		constraints.fill = GridBagConstraints.NONE;
		constraints.anchor = GridBagConstraints.CENTER;
		ok = new Button("Ok");
		gridbag.setConstraints(ok, constraints);
		ok.addMouseListener(this);
		add(ok);

		this.addWindowListener(new WindowAdapter() {
				public void windowClosing(WindowEvent e) {
					hide();}
				});

		
		setSize(420, 540); 
            Toolkit t = parent.getToolkit();
	      int scw   = t.getScreenSize().width;
	      int sch   = t.getScreenSize().height;
	      int w     = this.size().width;
	      int h     = this.size().height;
	      setLocation((scw/2)-(w/2), (sch/2)-(h/2));	
            setResizable(false);
		tr = new Thread(this);
		tr.start();
		setVisible(true);
	
	}

//-----------------------------------------------------------------------------
		
private void buildConstraints(GridBagConstraints gbc, int gx, int gy, int gw, int gh,
	int wx, int wy) {
           
      gbc.gridx = gx;
      gbc.gridy = gy;
      gbc.gridwidth = gw;
      gbc.gridheight = gh;
      gbc.weightx = wx;
      gbc.weighty = wy;
}

//----------------------------------------------------------------------------

public void mousePressed(MouseEvent e) {}

public void mouseReleased(MouseEvent e) {}

public void mouseEntered(MouseEvent e) {}

public void mouseExited(MouseEvent e) {}

public void mouseClicked(MouseEvent e) {
	if (((Button)e.getSource()).getLabel().equals("Ok")) {
		setVisible(false);
		tr.stop(); 
	}
}

//-----------------------------------------------------

public void run() {
	while (true){
		Date d = new Date(System.currentTimeMillis());
	      Time hour = new Time(System.currentTimeMillis());
		oraGiorno.setText(d.toString() + " " + hour.toString());
		try {Thread.sleep(500);}
		catch(InterruptedException e) {}
	}
}

//---------------------------------------------

}

