package uniba.gui;

import java.awt.*;
import java.io.*;
import java.awt.event.*;
import java.util.StringTokenizer;
import java.util.Vector;
import java.sql.SQLException;
import uniba.databanker.*;
import uniba.core.*;

/**
* La classe implementa una finestra di dialogo<br>
* che visualizza il risultato della ricerca<br>
* avviata dall'utente.
*/

public class DocumentSignificanceDialog extends Dialog implements MouseListener,
											ItemListener {

	Frame parent = null;
	List DocumentList;
	Label resultLabel;
	Label sigLabel; 
	Button viewBut, closeBut;
	String nomeQuery = null;
	String utente = null;
	Vector documents = new Vector();
	Vector categories = new Vector();
	Databanker db;
	int idDoc = 0;
	String URLDoc = null;
	
	public DocumentSignificanceDialog(Frame parent, String utente, String nomeQuery, 							Vector categories, Databanker db) throws SQLException {
		
		super(parent, "WebClass - Qtf^2-Tf*Idf - Execute", true);
		this.parent = parent;
		this.db = db;
		this.documents = documents;
		this.categories = categories;
		this.nomeQuery = nomeQuery;
		this.utente = utente;
		GridBagLayout gridbag = new GridBagLayout();
		GridBagConstraints constraints = new GridBagConstraints();
		constraints.insets = new Insets(0,0,0,15);
		setLayout(gridbag);

		// Etichetta di risultato
		buildConstraints(constraints, 0, 0, 2, 1, 0, 15);
		constraints.fill = GridBagConstraints.NONE;
		constraints.anchor = GridBagConstraints.WEST;
		resultLabel = new Label("Result :", Label.LEFT);
		gridbag.setConstraints(resultLabel, constraints);
		add(resultLabel);
		resultLabel.setBackground(Color.lightGray);

		// Etichetta vuota
		buildConstraints(constraints, 0, 1, 2, 1, 0, 15);
		constraints.fill = GridBagConstraints.BOTH;
		sigLabel = new Label(" ");
		gridbag.setConstraints(sigLabel, constraints);
		add(sigLabel);
		sigLabel.setBackground(Color.lightGray);

		// Lista dei documenti ritrovati
		buildConstraints(constraints, 0, 2, 1, 2, 85, 0);
		constraints.fill = GridBagConstraints.BOTH;
		DocumentList = new List(10, false);
		DocumentList.setFont(new Font("Monospaced",0,12));
		gridbag.setConstraints(DocumentList, constraints);
		String idDoc = "";
		String urlDoc = "";
		String sign = "";
		try {
			String indice = "";
			documents = db.getSignificance(utente, nomeQuery, categories);
			System.out.println(nomeQuery);
			for (int i = 0;i < documents.size();i++){
				String riga = (String)documents.elementAt(i);
				StringTokenizer st = new StringTokenizer(riga);
				int id = (new Integer(st.nextToken())).intValue();
				String url = st.nextToken();
				double sig = (new Double(st.nextToken())).doubleValue();
				String cat = st.nextToken();
				String stringaRisultato = ((i+1) + "             ").substring(0, 5) + 
						(" " + id + "              ").substring(0, 8) +
						" " + url + "   " + sig;
				url = url.substring(url.lastIndexOf('/'), url.length());
				DocumentList.add(((i+1) + " -            ").substring(0, 5) + 
						(" " + id + "              ").substring(0, 7) +
						(" " + db.getTitle(id) + 
						"                                                                  ").
						substring(0,20)  +
						("... " + url + " " + sig + "                    ").substring(0, 30) +
						(" " + cat + "                 ").substring(0, 20));
				System.out.println(stringaRisultato);
			}
		} catch(Exception ex) {new StampaErrore(parent, 
			"DocumentSignificanceDialog", "Exception:\n" + ex.getMessage());}
            DocumentList.addItemListener(this);
		add(DocumentList);

		sigLabel.setFont(new Font("Monospaced",0,12));
		sigLabel.setText(DocumentList.getItemCount() + " documents found"); 
		
		// Pulsante viewBut
		buildConstraints(constraints, 1, 2, 1, 1, 15, 15);
		constraints.fill = GridBagConstraints.HORIZONTAL;
		constraints.anchor = GridBagConstraints.NORTH;
		viewBut = new Button("View");
		gridbag.setConstraints(viewBut, constraints);
		viewBut.addMouseListener(this);
		add(viewBut);
		viewBut.disable();
		
		// Pulsante closeBut
		buildConstraints(constraints, 1, 3, 1, 1, 0, 55);
		constraints.fill = GridBagConstraints.HORIZONTAL;
		constraints.anchor = GridBagConstraints.NORTH;
		closeBut = new Button("Close");
		gridbag.setConstraints(closeBut, constraints);
		closeBut.addMouseListener(new MouseAdapter() {
			public void mouseClicked(MouseEvent e) {
				setVisible(false);}
			});
		add(closeBut);

		this.addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent e) {
				hide();}
			});

		
		setSize(700, 250); 
            Toolkit t = parent.getToolkit();
	      int scw   = t.getScreenSize().width;
	      int sch   = t.getScreenSize().height;
	      int w     = this.size().width;
	      int h     = this.size().height;
	      setLocation((scw/2)-(w/2), (sch/2)-(h/2)+48);	
            setResizable(false);
		setVisible(true);
	}

//-----------------------------------------------------------------------------
		

private void buildConstraints(GridBagConstraints gbc, int gx, int gy, int gw, int gh,
	int wx, int wy) {
           
      gbc.gridx = gx;
      gbc.gridy = gy;
      gbc.gridwidth = gw;
      gbc.gridheight = gh;
      gbc.weightx = wx;
      gbc.weighty = wy;
}

//----------------------------------------------------------------------------

public void mousePressed(MouseEvent e) {}

public void mouseReleased(MouseEvent e) {}

public void mouseEntered(MouseEvent e) {}

public void mouseExited(MouseEvent e) {}

public void mouseClicked(MouseEvent e) {
	if (((Button)e.getSource()).getLabel().equals("View")) {
		String host = null;
		String porta = null;		
		String url = null;	
		try {	
			host = (String)db.getConfiguration(utente).elementAt(12);	
		     	porta = (String)db.getConfiguration(utente).elementAt(13);	
			url = "http://" + host + ":" + porta + "/";
		} catch (Exception se) {
				new StampaErrore(parent, "Query Dialog", se.getMessage());
		}
		if (url != null) {		
			new Explorer(url + idDoc + " " + URLDoc, 4);
		}
	}
}
	
//--------------------------------------------------------------

public void itemStateChanged(ItemEvent e) {
	if (e.getStateChange() == ItemEvent.SELECTED){
		String item = DocumentList.getSelectedItem();
		StringTokenizer st = new StringTokenizer(item);
		st.nextToken();
		st.nextToken();
		idDoc = new Integer(st.nextToken()).intValue();
		try {
			URLDoc = db.getUrl(idDoc);
		} catch (SQLException ex) {
			new StampaErrore(parent, "Document Dialog", ex.getMessage());
		}
		viewBut.enable();
	}
}

//-----------------------------------------------------

}
