package uniba.gui;

import java.awt.*;
import java.awt.event.*;

/**
 * Permette l'inserimento di una categoria
 */
public class InserimentoCategoria extends Dialog implements TextListener {
									     

	private Label categoriaLbl = new Label("Insert new Category:"); 
	private Button ok = new Button("OK");
	private Button annulla = new Button("Cancel");
	private TextField categoriaTxf = new TextField(30);
	private Frame parent = null;
      private String categoriaDaInserire = null;

	public InserimentoCategoria(Frame parent) {
		super (parent, "Insert Category", true);
		this.parent = parent;		
		GridBagLayout gridbag = new GridBagLayout();
            GridBagConstraints constraints = new GridBagConstraints();
            setLayout(gridbag);
		setBackground(Color.lightGray);
		
		addWindowListener( new WindowAdapter() {
						public void windowClosing(WindowEvent we) {
						      categoriaDaInserire = null;
							setVisible(false);
						}
					 });
		categoriaLbl.setBackground(Color.lightGray);
		buildConstraints(constraints, 0, 0, 1, 1, 50, 50, GridBagConstraints.NONE, GridBagConstraints.CENTER);
            gridbag.setConstraints(categoriaLbl, constraints);
		add(categoriaLbl);
				
            categoriaTxf.addTextListener(this);
		buildConstraints(constraints, 1, 0, 1, 1, 50, 50, GridBagConstraints.NONE, GridBagConstraints.CENTER);
            gridbag.setConstraints(categoriaTxf, constraints);
		add(categoriaTxf);

		annulla.addMouseListener(new MouseAdapter() {
							public void mouseClicked(MouseEvent me) {
								categoriaDaInserire = null; 
								setVisible(false);
							}
						 });
		buildConstraints(constraints, 0, 1, 1, 1, 50, 50, GridBagConstraints.NONE, GridBagConstraints.CENTER);
            gridbag.setConstraints(annulla, constraints);
		add(annulla); 

		ok.addMouseListener(new MouseAdapter() {
							public void mouseClicked(MouseEvent me) {
							   categoriaDaInserire = categoriaTxf.getText();
							   setVisible(false);
							}
						  });
            ok.setEnabled(false);
		buildConstraints(constraints, 1, 1, 1, 1, 50, 50, GridBagConstraints.NONE, GridBagConstraints.CENTER);
            gridbag.setConstraints(ok, constraints);
		add(ok);
		setSize(400, 150);
            Toolkit t = parent.getToolkit();
            int scw   = t.getScreenSize().width;
	      int sch   = t.getScreenSize().height;
	      int w     = this.size().width;
	      int h     = this.size().height;
	      setLocation((scw/2)-(w/2), (sch/2)-(h/2));	
            setResizable(false);
            setVisible(true);

	}


	private void buildConstraints(GridBagConstraints gbc, int gx,
           int gy, int gw, int gh, int wx, int wy,
           int fill, int anchor) {
             
             gbc.gridx = gx;
             gbc.gridy = gy;
             gbc.gridwidth = gw;
             gbc.gridheight = gh;
             gbc.weightx = wx;
             gbc.weighty = wy;
             gbc.fill = fill;
             gbc.anchor = anchor;
        }

        public void textValueChanged(TextEvent te) {
             String cat = categoriaTxf.getText();
             ok.setEnabled(cat.length() > 0);
        }        


	/**
       * Restituisce la categoria da inserire. Se l'utente clicca su <i>Annulla</i> allora
       * viene restituito <i>null</i>.
       */ 
       public String getCategory() {
		return categoriaDaInserire;
	 }
  
}      