package uniba.gui;

import java.awt.*;
import java.awt.event.*;
import java.util.Vector;

/**
 * Permette l'inserimento di una pagina di testing o di training recuperata
 * da Internet o da disco
 */
public class InserimentoDocumentoTT extends Dialog implements MouseListener {

        boolean categoria = false;
        boolean internet = false;
        boolean file = false;
        boolean alias = true;
        private PannelloTipo pt = new PannelloTipo(this);
        PannelloCategoria pc = null;
        private PannelloDocumento pd;
        private PannelloAlias pa = new PannelloAlias(this);
        private Button memorizza = new Button("Store");
        private Button annulla = new Button("Cancel");
        private Frame parent = null;	
        private String category = null;
        private String tipo = null;
        private String path = null;
        private Vector categories = null;

       

        public InserimentoDocumentoTT(Frame parent, Vector categories) {
                super(parent, "Insert Training\\Testing\\Reject", true);
                pd = new PannelloDocumento(this, parent);
                this.parent = parent;
                this.categories = categories;
                GridBagLayout gridbag = new GridBagLayout();
                GridBagConstraints constraints = new GridBagConstraints();
                setLayout(gridbag);
                                
		    pc = new PannelloCategoria(this);
                buildConstraints(constraints, 0, 0, 1, 1, 50, 25, GridBagConstraints.NONE, GridBagConstraints.WEST);
                gridbag.setConstraints(pc, constraints);
                add(pc);

                buildConstraints(constraints, 1, 0, 1, 1, 50, 25, GridBagConstraints.NONE, GridBagConstraints.WEST);
                gridbag.setConstraints(pa, constraints);
                add(pa);
		    pa.setVisible(false);	
                
                buildConstraints(constraints, 0, 1, 2, 1, 100, 25, GridBagConstraints.NONE, GridBagConstraints.WEST);
                gridbag.setConstraints(pt, constraints);
                add(pt);

                buildConstraints(constraints, 0, 2, 2, 1, 100, 25, GridBagConstraints.NONE, GridBagConstraints.WEST);
                gridbag.setConstraints(pd, constraints);
                add(pd);

                buildConstraints(constraints, 0, 3, 1, 1, 50, 25, GridBagConstraints.NONE, GridBagConstraints.CENTER);
                gridbag.setConstraints(annulla, constraints);
                annulla.addMouseListener( new MouseAdapter() {
                                                public void mouseClicked(MouseEvent e) {
									setChoices(null, null, null);	
 									setVisible(false);
								}
                                          } );  
                
                add(annulla);

                buildConstraints(constraints, 1, 3, 1, 1, 50, 25, GridBagConstraints.NONE, GridBagConstraints.CENTER);
                gridbag.setConstraints(memorizza, constraints);
                memorizza.setEnabled(false);
                memorizza.addMouseListener(this); 
                add(memorizza);
                                                                                
                addWindowListener( new WindowAdapter() {
                                     public void windowClosing(WindowEvent e) {
                                          setChoices(null, null, null);
                                          setVisible(false);
						 }
                                   } );


                pack(); 
                Toolkit t = parent.getToolkit();
	          int scw   = t.getScreenSize().width;
	          int sch   = t.getScreenSize().height;
	          int w     = this.size().width;
	          int h     = this.size().height;
	          setLocation((scw/2)-(w/2), (sch/2)-(h/2));	
                setResizable(false);
                setVisible(true);

        }

        public Insets getInsets() {
                return new Insets(20, 20, 20, 20);
        }


        public void memorizza(boolean val) {
                memorizza.setEnabled(val);
        }

        private void buildConstraints(GridBagConstraints gbc, int gx,
           int gy, int gw, int gh, int wx, int wy,
           int fill, int anchor) {
             
             gbc.gridx = gx;
             gbc.gridy = gy;
             gbc.gridwidth = gw;
             gbc.gridheight = gh;
             gbc.weightx = wx;
             gbc.weighty = wy;
             gbc.fill = fill;
             gbc.anchor = anchor;
        }

        public void mouseClicked(MouseEvent e) {
		setChoices(pc.getCategory(), pt.getOption(), pd.getOption());
		setVisible(false);
        }

	  private void setChoices(String cat, String type, String indirizzo) {
		 if (type != null) {
		 	if (type.equalsIgnoreCase("REJECT"))
				category = "Reject";
		 	else
		 		category = cat;
		 } else
			category = null;
             tipo = type;
		 if (indirizzo != null) {
		 	if (indirizzo.indexOf(" ") != -1) {
				new StampaErrore(parent, 
                                   "Insert Document", 
                                   "L'indirizzo del documento\n" +
                                   "non pu contenere spazi.");
				return;
		 	}
		 }	
             path = indirizzo;
        }

        public void mouseEntered(MouseEvent e) {}

        public void mouseExited(MouseEvent e) {}

        public void mousePressed(MouseEvent e) {}

        public void mouseReleased(MouseEvent e) {}

	  /**
         * Restituisce la categoria scelta dall'utente
         */
	  public String getCategory() {
		return category;
        }	

        /**
         * Restituisce l'indirizzo della pagina Web scelta
         */
	  public String getPath() {
		return path;
	  }

        

	  /**
         * Restituisce il tipo del documento: <b>Training</b> o <b>Testing</b>.
         */	
	  public String getType() {
		return tipo;
        } 	

        /**
         * Restituisce la lista della categorie
         */
	  public Vector getCategories() {
		return categories;
        }
                                                
}
