package uniba.gui;

import java.awt.*;
import java.awt.event.*;
import java.util.Enumeration;
import java.util.Vector;
import  uniba.databanker.*;

/**
 * Permette di leggere una query dal database.
 */
public class LoadQuery extends Dialog implements MouseListener {

	private Choice nomeQuery = new Choice();
	private Label l = new Label("Query:");
	private Enumeration query = null;
	private Button ok = new Button("OK");
	private Button annulla = new Button("Delete Query");
	private String nome = "";	
	private String testo = "";
	private Vector categorie = null;
	private String utente = null;
	private Databanker db = null;
	private Frame parent = null;
	
	public LoadQuery(Frame parent, Enumeration query, String utente, Databanker db) {

		super(parent, "Load Query", true);
		this.utente = utente;
		this.db = db;
		this.parent = parent;
		GridBagLayout gridbag = new GridBagLayout();
            GridBagConstraints constraints = new GridBagConstraints();
            setLayout(gridbag);
		setBackground(Color.lightGray);
		
		addWindowListener( new WindowAdapter() {
						public void windowClosing(WindowEvent we) {
                                          setVisible(false);
						}
					 });
		l.setBackground(Color.lightGray);
		buildConstraints(constraints, 0, 0, 1, 1, 50, 50, GridBagConstraints.NONE, GridBagConstraints.CENTER);
            gridbag.setConstraints(l, constraints);
		add(l);
			
            while (query.hasMoreElements())
			nomeQuery.addItem((String)query.nextElement());
            
		buildConstraints(constraints, 1, 0, 1, 1, 50, 50, GridBagConstraints.NONE, GridBagConstraints.CENTER);
            gridbag.setConstraints(nomeQuery, constraints);
		add(nomeQuery);

		
		buildConstraints(constraints, 0, 1, 1, 1, 50, 50, GridBagConstraints.NONE, GridBagConstraints.CENTER);
            gridbag.setConstraints(annulla, constraints);
		add(annulla); 
		annulla.addMouseListener(this);

		buildConstraints(constraints, 1, 1, 1, 1, 50, 50, GridBagConstraints.NONE, GridBagConstraints.CENTER);
            gridbag.setConstraints(ok, constraints);
		add(ok); 
		ok.addMouseListener(this);

		setSize(250, 150);
            Toolkit t = parent.getToolkit();
            int scw   = t.getScreenSize().width;
	      int sch   = t.getScreenSize().height;
	      int w     = this.size().width;
	      int h     = this.size().height;
	      setLocation((scw/2)-(w/2), (sch/2)-(h/2));	
            setResizable(false);
            setVisible(true);

	}

	private void buildConstraints(GridBagConstraints gbc, int gx,
           int gy, int gw, int gh, int wx, int wy,
           int fill, int anchor) {
             
             gbc.gridx = gx;
             gbc.gridy = gy;
             gbc.gridwidth = gw;
             gbc.gridheight = gh;
             gbc.weightx = wx;
             gbc.weighty = wy;
             gbc.fill = fill;
             gbc.anchor = anchor;
        }

	public void mouseClicked(MouseEvent me) {
		Button source = (Button)me.getSource();
		if (source.equals(ok)) {
			try {
				int j = nomeQuery.getItemCount();
				if (j > 0) {
					nome = nomeQuery.getSelectedItem();
					testo = db.getQueryText(utente, nome);
					categorie = db.getQueryCategories(utente, nome);
				}
			} catch (Exception e) {
				new StampaErrore(parent,
						     "Load Query",
						     e.getMessage());
				e.printStackTrace();
			}		
			setVisible(false);
		} else if (source.equals(annulla)) {
			try {
				int j = nomeQuery.getItemCount();
				if (j > 0) {
					nome = nomeQuery.getSelectedItem();
					db.eraseQuery(utente, nome);
					nome = "";
					testo = "";
				}
			} catch (Exception e) {
				new StampaErrore(parent,
						     "Load Query",
						     e.getMessage());
				e.printStackTrace();
			}		
			setVisible(false);
		}
	}

	public void mousePressed(MouseEvent me) {}
	
      public void mouseReleased(MouseEvent me) {}

	public void mouseEntered(MouseEvent me) {}

      public void mouseExited(MouseEvent me) {}

	String getQueryName() {
		return nome;
	}

	String getQueryText() {
		return testo;
	}

	Vector getQueryCategories() {
		return categorie;
	}


	  

}
		
		
		

	