package uniba.gui;

import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.sql.SQLException;
import uniba.databanker.*;

/**
 * Presenta la schermata che permette l'immissione
 * della <i>login</i> e della <i>password</i>. 
 */
public class Login extends Dialog implements MouseListener, KeyListener {

	private Choice categorie = new Choice();
      private Choice user = new Choice();
	private Label login = new Label("Login:");
	private Label password = new Label("Password:");
      private Label sceltaUtente = new Label("Scelta utente:");
	private TextField log = new TextField("", 15);
	private TextField pas = new TextField("", 15);
	private Vector elencoLogin = null;
	private String utente = null;
	private Button ok = new Button("OK");
	private boolean valido = false;
	private Databanker db = null;
	
	public Login(Frame parent, String title, Vector elencoLogin, Databanker db) {

		super(parent, title, true);
		this.elencoLogin = elencoLogin;
            this.db = db;
		GridBagLayout gridbag = new GridBagLayout();
            GridBagConstraints constraints = new GridBagConstraints();
            setLayout(gridbag);
		setBackground(Color.lightGray);
		setResizable(false);
		addWindowListener( new WindowAdapter() {
						public void windowClosing(WindowEvent we) {
							System.exit(0);
						}
					 });
		login.setBackground(Color.lightGray);
		buildConstraints(constraints, 0, 0, 1, 1, 10, 25, GridBagConstraints.NONE, GridBagConstraints.CENTER);
            gridbag.setConstraints(login, constraints);
		add(login);

		buildConstraints(constraints, 1, 0, 1, 1, 90, 0, GridBagConstraints.NONE, GridBagConstraints.CENTER);
            gridbag.setConstraints(log, constraints);
		add(log);

		password.setBackground(Color.lightGray);
		buildConstraints(constraints, 0, 1, 1, 1, 0, 25, GridBagConstraints.NONE, GridBagConstraints.CENTER);
            gridbag.setConstraints(password, constraints);
		add(password);

		pas.setEchoChar('*');
		buildConstraints(constraints, 1, 1, 1, 1, 0, 0, GridBagConstraints.NONE, GridBagConstraints.CENTER);
            gridbag.setConstraints(pas, constraints);
		add(pas);

		buildConstraints(constraints, 0, 2, 1, 1, 0, 25, GridBagConstraints.NONE, GridBagConstraints.CENTER);
            gridbag.setConstraints(sceltaUtente, constraints);
		add(sceltaUtente);

            buildConstraints(constraints, 1, 2, 1, 1, 0, 0, GridBagConstraints.NONE, GridBagConstraints.CENTER);
            gridbag.setConstraints(user, constraints);
		add(user);
		user.setEnabled(false);

		ok.addMouseListener(this);
            ok.addKeyListener(this);
		buildConstraints(constraints, 0, 3, 2, 1, 0, 25, GridBagConstraints.NONE, GridBagConstraints.CENTER);
            gridbag.setConstraints(ok, constraints);
		add(ok); 

		user.addItem("Choose user");
            Enumeration e = elencoLogin.elements();
            while (e.hasMoreElements())
                user.addItem((String)e.nextElement());

		setSize(250, 150);
		Toolkit t = parent.getToolkit();
	      int scw   = t.getScreenSize().width;
	      int sch   = t.getScreenSize().height;
	      int w     = this.size().width;
	      int h     = this.size().height;
            setLocation((scw/2)-(w/2), (sch/2)-(h/2));
	}

	private void buildConstraints(GridBagConstraints gbc, int gx,
           int gy, int gw, int gh, int wx, int wy,
           int fill, int anchor) {
             
             gbc.gridx = gx;
             gbc.gridy = gy;
             gbc.gridwidth = gw;
             gbc.gridheight = gh;
             gbc.weightx = wx;
             gbc.weighty = wy;
             gbc.fill = fill;
             gbc.anchor = anchor;
      }

	public void mouseClicked(MouseEvent me) {
	   try {	
		if (!user.isEnabled()) {
		    if ( db.getUserType(log.getText(), pas.getText()).equalsIgnoreCase("amministratore")) {
			valido = true;
			pas.setEnabled(false);
			log.setEnabled(false);
			user.setEnabled(true);
		    }
		    if (!valido)	
		       setVisible(false);	
            } else 
			setVisible(false);
	   } catch (SQLException s) {
		System.out.println(s.getMessage());
	   }	

	}	

	public void mousePressed(MouseEvent me) {}

	public void mouseReleased(MouseEvent me) {}

	public void mouseEntered(MouseEvent me) {}

	public void mouseExited(MouseEvent me) {}

	public String getUser() throws Exception {
	   if (valido) {
		if (user.getSelectedIndex() == 0) {	
			user.select(1);
		}
		return user.getSelectedItem();
	   } else	
		return null;
	}

	public void keyPressed(KeyEvent ke) {
	   try {	
		if (ke.getKeyChar() == ke.VK_ENTER) {
			if (!user.isEnabled()) {
		    		if ( db.getUserType(log.getText(), pas.getText()).equalsIgnoreCase("amministratore")) {
					valido = true;
					pas.setEnabled(false);
					log.setEnabled(false);
					user.setEnabled(true);
		    		}
				if (!valido)
					setVisible(false);
            	} else 
				setVisible(false);
		}
	   } catch (SQLException s) {
		System.out.println(s.getMessage());
	   }	
	}

	public void keyTyped(KeyEvent ke) {}

	public void keyReleased(KeyEvent ke) {}



}
		
		
		

	