package uniba.gui;

import java.awt.*;
import java.io.*;
import java.util.*;
import java.sql.SQLException;
import java.sql.Time;
import uniba.core.*;
import uniba.databanker.*;

/**
 * Mostra una finestra che permette la costruzione
 * delle probabilit bayesiane.
 */
public class MakeBayesianProbabilitiesDialog extends Dialog {

   Frame parent;  
   TextArea result;
   boolean bayesianProbabilitiesMade;   
   CategoriesManager cgm;
   FeaturesManager ftm;
   TrainingPagesManager trpm;
   Vector vectOfPageDictionaries;
   Vector vectOfTermFrequency;
   String utente = null;
   Databanker db = null;
   private Time inizio, fine;
   private String report;	


  public MakeBayesianProbabilitiesDialog(Frame parent,
					           CategoriesManager cgm, 
                  			     FeaturesManager ftm,
						     TrainingPagesManager trpm,
     						     String utente,
						     Databanker db) {

	super(parent,"Make Bayesian Probabilities",true);
	this.parent = parent;
	setBackground(new Color(0).lightGray);
	Button makeButton = new Button("Make");
	Button cancelButton = new Button("Cancel");
	Panel buttonPanel = new Panel();
	buttonPanel.add(makeButton);
	buttonPanel.add(cancelButton);
	result = new TextArea(20,40); 
	result.setBackground(new Color(0).white);
	result.setForeground(new Color(0).blue);
	result.setFont(new Font("Courier",0,12));
	result.setText(" ");
	Panel centerPanel = new Panel();
	centerPanel.setLayout(new GridLayout(1,1));
	centerPanel.add(result);
	add("Center",centerPanel);
	add("South",buttonPanel);
	resize(600,400);
	setResizable(false);
	this.cgm=cgm;
	this.ftm=ftm;
	this.trpm=trpm;
      this.utente = utente;
      this.db = db;
	bayesianProbabilitiesMade = false;
  }  


  public boolean handleEvent(Event evt) {
	if (evt.id==evt.WINDOW_DESTROY) {
	  hide();
	  return true;
	}
	else
	if (evt.id==evt.ACTION_EVENT) {
	  if (evt.target instanceof Button) {
		if (evt.arg.equals("Make")) {
		  setCursor(new Cursor(Cursor.WAIT_CURSOR));
		  result.setText("Make Bayesian Probabilities...\n\n");	
              try { 
			db.getAutoma().Transizione("mb");
			inizio = new Time(System.currentTimeMillis());
		      makeBayesianProbabilities();
              } catch (Exception e) {new StampaErrore(parent,"MakeBayesianProbabilitiesDialog", 
			     "Exception:\n" + e.getMessage());setVisible(false);e.printStackTrace();
              } finally {
			  setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
			  fine = new Time(System.currentTimeMillis());
			  report = "Make Bayesian Probalities\n\tinizio: " + 
				inizio.toString() + " fine: " + fine.toString();
			  System.out.println(report);	
		  }	
		  return true;
		}
		else
		if (evt.arg.equals("Cancel")) {
		  result.setText(" ");
		  hide();
		  return true;
		}
	  }
	}
	return false;
  }

//-------------------------------------------------------------------------------------------

/**
* costruisce le probabilit bayesiane.
*/

private void makeBayesianProbabilities() throws SQLException, OperationException {
	result.setText(db.makeBayesianProbabilities(utente));
}

//---------------------------------------------------------------------------------------

}
