package uniba.gui;

import java.awt.*;
import java.io.*;
import java.util.*;
import java.sql.SQLException;
import java.sql.Time;
import java.util.StringTokenizer;
import uniba.core.*;
import uniba.databanker.*;

/** 
 * Calculate centroids for all categories.
 * @author Giulio DeLuise 1997
 * @author Giorgio Vespucci (GV) 1998
 */
public class MakeClusterDialog extends Dialog {

   private Frame parent;  
   private TextArea result;
   private boolean clustersMade;   
   private CategoriesManager cgm;
   private FeaturesManager ftm;
   private TrainingPagesManager trpm;
   private Databanker db = null;
   private String utente = null;
   private Time inizio, fine;
   private String report;
      
  public MakeClusterDialog(Frame parent, 
				   CategoriesManager cgm, 
                           FeaturesManager ftm,
                           TrainingPagesManager trpm,
                           String utente,
                           Databanker db)throws SQLException, OperationException {

	super(parent,"Make Clusters",true);
	this.parent = parent;
	setBackground(new Color(0).lightGray);
	Button makeButton = new Button("Make");
	Button cancelButton = new Button("Cancel");
	Panel buttonPanel = new Panel();
	 buttonPanel.add(makeButton);
	 buttonPanel.add(cancelButton);
	result = new TextArea(20,40); 
	result.setBackground(new Color(0).white);
	result.setForeground(new Color(0).blue);
	result.setFont(new Font("Courier",0,12));
	result.setText(" ");
	Panel centerPanel = new Panel();
	centerPanel.setLayout(new GridLayout(1,1));
	centerPanel.add(result);
	add("Center",centerPanel);
	add("South",buttonPanel);
	resize(600,400);
	// pack();
	setResizable(false);
	this.cgm=cgm;
	this.ftm=ftm;
      this.trpm = trpm;
      this.utente = utente;
      this.db = db;
	clustersMade = false;
  }  


  public boolean handleEvent(Event evt) {
	if (evt.id==evt.WINDOW_DESTROY) {
	  hide();
	  return true;
	}
	else
	if (evt.id==evt.ACTION_EVENT) {
	  if (evt.target instanceof Button) {
		if (evt.arg.equals("Make")) {
		  setCursor(new Cursor(Cursor.WAIT_CURSOR));	
		  try {
			  db.getAutoma().Transizione("mc");	
			  inizio = new Time(System.currentTimeMillis());	
		        makeClusters();
		  }catch (Exception e) {
		      new StampaErrore(parent, "MakeClusterDialog", "Exception:\n" + 
				e.getMessage());setVisible(false);e.printStackTrace();
		  } finally { 
			  setCursor(new Cursor(Cursor.DEFAULT_CURSOR));	
			  fine  = new Time(System.currentTimeMillis());
			  report = "Make Clusters\n\tinizio: " + 
				inizio.toString() + " fine: " + fine.toString();
			  System.out.println(report);	
		  }
		  return true;
		}

		else
		if (evt.arg.equals("Cancel")) {
		  result.setText(" ");
		  hide();
		  return true;
		}
	  }
	}
	return false;
  }  

  private void makeClusters() throws SQLException, OperationException, Exception {
	result.setText(db.makeCentroids(utente, cgm));
  }

}