package uniba.gui;

import java.awt.*;
import java.awt.event.*;
import java.util.Vector;

import uniba.core.*;
import uniba.databanker.Databanker;

/**
 * Permette la cancellazione di una categoria
 */
public class ModifyCategoryDialog extends Dialog implements ItemListener, MouseListener{

	private Choice categorie = new Choice();
	private Label l1 = new Label("Selected Category:");
	private Label l2 = new Label("New Category Name:");
	private TextField tf = new TextField(15);		
	private Vector categories = null;
	private Button modifica = new Button("Modify");
	private Button annulla = new Button("Cancel");
	private String categoriaDaCancellare = null;
	private String utente;
	private Frame parent;
	private Databanker db;
	private CategoriesManager cgm;
	private TrainingPagesManager trpm;
	private TestingPagesManager tspm;	

	public ModifyCategoryDialog(Frame parent, String utente, Vector categories,Databanker db, 		CategoriesManager cgm, TrainingPagesManager trpm, TestingPagesManager tspm) {

		super(parent, "Modify Category", true);
		this.categories = categories;
		this.utente = utente;
		this.parent = parent;
		this.db = db;
		this.cgm = cgm;
		this.trpm = trpm;
		this.tspm = tspm;
		GridBagLayout gridbag = new GridBagLayout();
            GridBagConstraints constraints = new GridBagConstraints();
            setLayout(gridbag);
		setBackground(Color.lightGray);
		
		addWindowListener( new WindowAdapter() {
						public void windowClosing(WindowEvent we) {
                                          categoriaDaCancellare = null;
							setVisible(false);
						}
					 });
		l1.setBackground(Color.lightGray);
		buildConstraints(constraints, 0, 0, 1, 1, 50, 30, GridBagConstraints.NONE, GridBagConstraints.CENTER);
            gridbag.setConstraints(l1, constraints);
		add(l1);
			
            int i;	
		for (i = 0; i<categories.size(); i++)
			categorie.addItem((String)categories.elementAt(i));
            modifica.setEnabled((i != 0));
		buildConstraints(constraints, 1, 0, 1, 1, 50, 0, GridBagConstraints.NONE, GridBagConstraints.CENTER);
            gridbag.setConstraints(categorie, constraints);
		categorie.addItemListener(this);
		add(categorie);

		l2.setBackground(Color.lightGray);
		buildConstraints(constraints, 0, 1, 1, 1, 0, 30, GridBagConstraints.NONE, GridBagConstraints.CENTER);
            gridbag.setConstraints(l2, constraints);
		add(l2);

		buildConstraints(constraints, 1, 1, 1, 1, 0, 0, GridBagConstraints.NONE, GridBagConstraints.CENTER);
            gridbag.setConstraints(tf, constraints);
		tf.setText(categorie.getSelectedItem());
		add(tf);

		buildConstraints(constraints, 0, 2, 1, 1, 0, 40, GridBagConstraints.NONE, GridBagConstraints.CENTER);
            gridbag.setConstraints(annulla, constraints);
		annulla.addMouseListener(this);
		add(annulla); 

		buildConstraints(constraints, 1, 2, 1, 1, 0, 0, GridBagConstraints.NONE, GridBagConstraints.CENTER);
            gridbag.setConstraints(modifica, constraints);
		modifica.addMouseListener(this);
		add(modifica);

		setSize(250, 150);
            Toolkit t = parent.getToolkit();
            int scw   = t.getScreenSize().width;
	      int sch   = t.getScreenSize().height;
	      int w     = this.size().width;
	      int h     = this.size().height;
	      setLocation((scw/2)-(w/2), (sch/2)-(h/2));	
            setResizable(false);
            setVisible(true);

	}

//-----------------------------------------------------------

	private void buildConstraints(GridBagConstraints gbc, int gx,
           int gy, int gw, int gh, int wx, int wy,
           int fill, int anchor) {
             
             gbc.gridx = gx;
             gbc.gridy = gy;
             gbc.gridwidth = gw;
             gbc.gridheight = gh;
             gbc.weightx = wx;
             gbc.weighty = wy;
             gbc.fill = fill;
             gbc.anchor = anchor;
        }

//------------------------------------------------------------

	  public void itemStateChanged(ItemEvent e) {
		tf.setText(categorie.getSelectedItem());
	  }

//-----------------------------------------------------------------

public void mousePressed(MouseEvent e) {}

public void mouseReleased(MouseEvent e) {}

public void mouseEntered(MouseEvent e) {}

public void mouseExited(MouseEvent e) {}

public void mouseClicked(MouseEvent e) {
	if (((Button)e.getSource()).equals(annulla)) {
		setVisible(false);
	} else
	if (((Button)e.getSource()).equals(modifica)) {
		setCursor(new Cursor(Cursor.WAIT_CURSOR));
		try {
			db.replaceCategory(utente, categorie.getSelectedItem(), tf.getText());
			categories = db.getCategories(utente);
			categorie.removeAll();
			for (int i = 0;i < categories.size();i++) 
				categorie.add((String)categories.elementAt(i));
			cgm.updateCategory();
			trpm.updateTrainingPages();
			tspm.updateTestingPages();
		}catch(Exception ex){new StampaErrore(this.parent, 
			"Modify Category", "Exception:\n" + ex.getMessage());
			ex.printStackTrace();
		} finally {setCursor(new Cursor(Cursor.DEFAULT_CURSOR));}
	}
}

//-----------------------------------------------------

	  /**
         * Restituisce la categoria da cancellare
         */
	  public String getCategory() {
		return categoriaDaCancellare;
	  }	


}
		
		
		

	