package uniba.gui;

import java.net.*;
import java.io.*;
import uniba.databanker.*;

/**
 * Thread per il rendez vous con Internet Explorer. Precisamente,
 * quando il browser richiede una pagina web nel database, questa classe esegue una
 * interrogazione sql per estrarre il testo del documento, e ne invia il contenuto
 * al richiedente. La porta su cui questo demone  in ascolto  la 4444.
 */
public class MultiServer extends Thread {

	private ServerSocket serverSocket = null;
	private boolean listening = true;
	private Thread currentThread = this;
      private Databanker db = null;
      private String utente = null;

	
     
      public MultiServer(Databanker db, String utente) {
          this.db = db;
          this.utente = utente;
          currentThread.start();
      } 
         
	

	public void run () {
       
         try {
          	serverSocket = new ServerSocket(new Integer((String)db.getConfiguration(utente).elementAt(13)).intValue());
	      
		while (listening)
			new MultiServerThread(serverSocket.accept(), db).start();
          
            serverSocket.close();
         } 
         catch (Exception ioe) {
               ioe.printStackTrace();
         }
      }

      
}
		
	
		