package uniba.gui;

import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.sql.SQLException;
import uniba.databanker.*;
import uniba.core.*;


/**
* Attraverso la finestra di dialogo generata dalla<br>
* seguente classe  possibile creare, eseguire, visualizzare,<br>
* ed eliminare le <b>query in linguaggio naturale</b> che<br>
* un utente formula al sistema digitandone il testo in un'apposita casella.
*/

public class NaturalLanguageQueryDialog extends Dialog implements 	MouseListener,
												ItemListener,
												TextListener {

	Frame parent = null;
	Label lQueryName, lQueryText, lCategories;
	Button saveBut, executeBut, loadBut, clearBut, closeBut;
	java.awt.List listQuery;
	TextArea tQueryText;
	TextField tQueryName;
	String queryText = "";
	String queryName = "";
	String utente;
	String[] items;
	Databanker db;
	DocumentSignificanceDialog dsg;
	LoadQuery lqry;	
	Vector documents = new Vector();
	
	public NaturalLanguageQueryDialog(Frame parent, String utente, Databanker db) throws 									SQLException{
		
		super(parent, "WebClass - Qtf-Tf*Idf -", true);
		this.parent = parent;
		this.db = db;
		this.utente = utente;
		GridBagLayout gridbag = new GridBagLayout();
		GridBagConstraints constraints = new GridBagConstraints();
		constraints.insets = new Insets(0,0,0,15);
		setLayout(gridbag);

		// Etichetta nome query
		buildConstraints(constraints, 0, 0, 2, 1, 0, 13);
		constraints.fill = GridBagConstraints.NONE;
		constraints.anchor = GridBagConstraints.WEST;
		lQueryName = new Label("Query Name", Label.LEFT);
		gridbag.setConstraints(lQueryName, constraints);
		add(lQueryName);
		lQueryName.setBackground(Color.lightGray);

		// Etichetta selezione categorie
		buildConstraints(constraints, 2, 0, 1, 1, 0, 13);
		constraints.fill = GridBagConstraints.NONE;
		constraints.anchor = GridBagConstraints.WEST;
		lCategories = new Label("Select Categories", Label.LEFT);
		gridbag.setConstraints(lCategories, constraints);
		add(lCategories);
		lCategories.setBackground(Color.lightGray);

		// Campo nome query
		buildConstraints(constraints, 0, 1, 1, 1, 50, 13);
		constraints.fill = GridBagConstraints.HORIZONTAL;
		tQueryName = new TextField(15);
		gridbag.setConstraints(tQueryName, constraints);
		tQueryName.addTextListener(this);
		add(tQueryName);

		// Pulsamte salva
		buildConstraints(constraints, 1, 1, 1, 1, 20, 0);
		constraints.fill = GridBagConstraints.NONE;
		constraints.anchor = GridBagConstraints.CENTER;
		saveBut = new Button("Save Query");
		gridbag.setConstraints(saveBut, constraints);
		saveBut.addMouseListener(this);
		add(saveBut);

		// Scelta categorie
		buildConstraints(constraints, 2, 1, 1, 3, 0, 0);
		constraints.fill = GridBagConstraints.BOTH;
		listQuery = new java.awt.List(6, true);
		Vector categorie = db.getCategories(utente);
		listQuery.add("All Categories");
		for (int i = 0;i < categorie.size();i++)
			listQuery.add((String)categorie.elementAt(i));
		listQuery.select(0);
		items  = new String[1];
		items[0] = "All Categories";
		gridbag.setConstraints(listQuery, constraints);
		listQuery.addItemListener(this);
		add(listQuery);

		// Etichetta testo query
		buildConstraints(constraints, 0, 2, 2, 1, 0, 13);
		constraints.fill = GridBagConstraints.NONE;
		constraints.anchor = GridBagConstraints.WEST;
		lQueryText = new Label("Query Text", Label.LEFT);
		gridbag.setConstraints(lQueryText, constraints);
		add(lQueryText);

		// Area di testo query
		buildConstraints(constraints, 0, 3, 2, 5, 0, 0);
		constraints.fill = GridBagConstraints.NONE;
		tQueryText = new TextArea(9, 30);
		gridbag.setConstraints(tQueryText, constraints);
		tQueryText.setFont(new Font("Courier",0,12));
		tQueryText.addTextListener(this);
		add(tQueryText);

		// Pulsante execute
		buildConstraints(constraints, 2, 4, 1, 1, 30, 12);
		constraints.fill = GridBagConstraints.HORIZONTAL;
		constraints.anchor = GridBagConstraints.CENTER;
		executeBut = new Button("Execute");
		gridbag.setConstraints(executeBut, constraints);
		executeBut.addMouseListener(this);
		add(executeBut);

		// Pulsante load
		buildConstraints(constraints, 2, 5, 1, 1, 30, 12);
		constraints.fill = GridBagConstraints.HORIZONTAL;
		constraints.anchor = GridBagConstraints.CENTER;
		loadBut = new Button("Load Query");
		gridbag.setConstraints(loadBut, constraints);
		loadBut.addMouseListener(this);
		add(loadBut);

		// Pulsante clear
		buildConstraints(constraints, 2, 6, 1, 1, 30, 12);
		constraints.fill = GridBagConstraints.HORIZONTAL;
		constraints.anchor = GridBagConstraints.CENTER;
		clearBut = new Button("Clear");
		gridbag.setConstraints(clearBut, constraints);
		clearBut.addMouseListener(this);
		add(clearBut);

		// Pulsante close
		buildConstraints(constraints, 2, 7, 1, 1, 30, 12);
		constraints.fill = GridBagConstraints.HORIZONTAL;
		constraints.anchor = GridBagConstraints.CENTER;
		closeBut = new Button("Close");
		gridbag.setConstraints(closeBut, constraints);
		closeBut.addMouseListener(this);
		add(closeBut);
		
		if ((tQueryName.getText().equals("")) && (tQueryText.getText().equals(""))) {
			saveBut.disable();
			executeBut.disable();
		}
	
		this.addWindowListener(new WindowAdapter() {
				public void windowClosing(WindowEvent e) {
					setVisible(false);}
			});

		setSize(350, 250); 
            Toolkit t = parent.getToolkit();
	      int scw   = t.getScreenSize().width;
	      int sch   = t.getScreenSize().height;
	      int w     = this.size().width;
	      int h     = this.size().height;
	      setLocation((scw/2)-(w/2), (sch/2)-(h/2));	
            setResizable(false);
            setVisible(true);
	}

//-----------------------------------------------------------------------------
		

private void buildConstraints(GridBagConstraints gbc, int gx, int gy, int gw, int gh,
	int wx, int wy) {
           
      gbc.gridx = gx;
      gbc.gridy = gy;
      gbc.gridwidth = gw;
      gbc.gridheight = gh;
      gbc.weightx = wx;
      gbc.weighty = wy;
}

//-----------------------------------------------------------------

public void mousePressed(MouseEvent e) {}

public void mouseReleased(MouseEvent e) {}

public void mouseEntered(MouseEvent e) {}

public void mouseExited(MouseEvent e) {}

public void mouseClicked(MouseEvent e) {
	if (((Button)e.getSource()).equals(closeBut)) {
		setVisible(false);
	} else
	if (((Button)e.getSource()).equals(loadBut)) {
		setCursor(new Cursor(Cursor.WAIT_CURSOR));
		try {
			lqry = new LoadQuery(parent, db.getQueryNames(utente), utente, db);
			if (!lqry.getQueryName().equals("")) {
				Vector categories = lqry.getQueryCategories();
				for (int i = 0;i < listQuery.getItemCount();i++) {
					if (categories.contains(listQuery.getItem(i))) {
						listQuery.select(i);
					} else {
						listQuery.deselect(i);
					}
				}
				tQueryName.setText(lqry.getQueryName());
				tQueryText.setText(lqry.getQueryText());
				executeBut.enable();
			}
			saveBut.disable();
		}catch(Exception ex){new StampaErrore(this.parent, 
			"Load Query", "Exception:\n" + ex.getMessage());
			ex.printStackTrace();
		} finally {setCursor(new Cursor(Cursor.DEFAULT_CURSOR));}
	} else
	if (((Button)e.getSource()).equals(clearBut)) {
		tQueryText.setText("");
		tQueryName.setText("");
	} else
	if ((((Button)e.getSource()).equals(saveBut)) && (saveBut.isEnabled())) {
		setCursor(new Cursor(Cursor.WAIT_CURSOR));
		queryName = tQueryName.getText();
		queryText = tQueryText.getText();	
		try {
			saveQuery();
		}catch(Exception ex){new StampaErrore(this.parent, 
			"Save Query", "Exception:\n" + ex.getMessage());
			ex.printStackTrace();
		} finally {setCursor(new Cursor(Cursor.DEFAULT_CURSOR));}
	} else
	if ((((Button)e.getSource()).equals(executeBut)) && (executeBut.isEnabled())) {
		setCursor(new Cursor(Cursor.WAIT_CURSOR));
		boolean nonValida = false;
		queryName = tQueryName.getText();
		queryText = tQueryText.getText();	
		try {
			if (nonValida = ((queryName.equals("")) || 
				(!db.existQuery(utente, queryName)))){ 
				queryName = "Temporary_Query_Title";
				saveQuery();
			}
			dsg = new DocumentSignificanceDialog(parent, utente, queryName, 
				getSelectedCategories(), db);
			if (nonValida) {
				db.eraseQuery(utente, queryName);
				queryName = "";
			}
			saveBut.enable();
			executeBut.enable();
		} catch(Exception ex){new StampaErrore(this.parent, 
			"DocumentSignificanceDialog", "Exception:\n" + ex.getMessage());
			ex.printStackTrace();
		} finally {setCursor(new Cursor(Cursor.DEFAULT_CURSOR));}
	}
}

//-----------------------------------------------------

public void itemStateChanged(ItemEvent e) {
	items = listQuery.getSelectedItems();
	if (items.length > 0) {
		if ((!tQueryText.getText().equals("")) && (!tQueryName.getText().equals(""))) 
			saveBut.enable();
		if (!tQueryText.getText().equals(""))
			executeBut.enable();	
		if (items[0].equals("All Categories")) {
			for (int i = 1;i < listQuery.getItemCount();i++) 
				if (listQuery.isIndexSelected(i))
					listQuery.deselect(i);
		}
	} else {
		saveBut.disable();
		executeBut.disable();
	}
}

//-----------------------------------------------------

public void textValueChanged(TextEvent e) {
	if (e.getID() == TextEvent.TEXT_VALUE_CHANGED) {
		if ((!tQueryText.getText().equals("")) &&  (items.length > 0)){
			executeBut.enable();
			if (!tQueryName.getText().equals("")) {
				saveBut.enable();
			} else {
				saveBut.disable();
			}
		} else {
			executeBut.disable();
			saveBut.disable();
		}
	}
}

//----------------------------------------------------------

private Vector getSelectedCategories() throws SQLException{
	Vector categories = new Vector();
	items = listQuery.getSelectedItems();
	if (items.length > 0) {
		saveBut.enable();
		if (items[0].equals("All Categories")) {
			categories = db.getCategories(utente);
		} else {
			for (int i = 0;i < items.length;i++) 
				categories.addElement(items[i]);
		}
	}
	return categories;
}
	
//--------------------------------------------------------------

private void saveQuery() throws Exception {
	if (queryName.equals("")) {
		throw new Exception("Nome della query non valido.");
	} else 
	if (queryText.equals("")) {
		throw new Exception("Testo della query non valido.");
	} else {
		queryText.replace('\n', ' ');
		Vector conf = db.getConfiguration(utente);
		Vector stop = db.getStopword(utente);
		Vector tokQ = (new QueryTokenizer(queryText, conf, stop)).getTokenQuery();
		db.setQuery(utente, queryName, queryText, tokQ, getSelectedCategories());
	}
}

//--------------------------------------------------------------

}
 