package uniba.gui;

import java.awt.*;
import java.awt.event.*;
import java.util.Vector;
import java.util.Enumeration;
import java.sql.SQLException;
import uniba.core.*;
import uniba.databanker.*;



/**
 * Permette di effettuare query in linguaggio naturale.
 */
public class NaturalQueryDialog extends Dialog implements MouseListener,
									    TextListener,
									    ItemListener,
									    FocusListener,
									    Viewer {
									  

	private Frame parent = null;
      public java.awt.List docRitrovati = new java.awt.List(6, false);
      public java.awt.List report = new java.awt.List(6, false);
      public TextArea query = new TextArea(5, 15);
	public TextField nome = new TextField(10);
      public Button esegui = new Button("Find"); 
      public java.awt.List repQuery = new java.awt.List(6, false);
      public Button view = new Button("View");
      private List cat = new List(4, true);
      private Label queryL = new Label("Natural Language Query:");
      private Label repQueryLbl = new Label("Report:");
      private Label docR = new Label("Retrieved Document:");
      private Label docRil = new Label("Similarity:");
      private String utente;
      private Databanker db;
	private RepresentManager rpm;
      private String titolo = null;
	private Button salvaQuery = new Button("Save Query");
	private Button caricaQuery = new Button("Load Query");
      private Vector selectedCategories = null;
	      
	public NaturalQueryDialog(Frame parent,
					  String titolo, 
                                Databanker db,
                                String utente,
                                RepresentManager rpm) {

		    super(parent, "WebClass - " + titolo, true);
                this.parent = parent;
                this.db = db;
                this.utente = utente;
                this.rpm = rpm;
                this.titolo = titolo;
		    if (titolo.equals("Simple Matching"))	
				docRil.setText("Number of Matching Terms:");
		    selectedCategories = new Vector();
                GridBagLayout gridbag = new GridBagLayout();
                GridBagConstraints constraints = new GridBagConstraints();
                setLayout(gridbag);
                                
		    buildConstraints(constraints, 0, 0, 1, 1, 40, 10, GridBagConstraints.NONE, GridBagConstraints.CENTER);
                gridbag.setConstraints(queryL, constraints);
                add(queryL);
                queryL.setBackground(Color.lightGray);

                buildConstraints(constraints, 0, 1, 1, 3, 40, 30, GridBagConstraints.BOTH, GridBagConstraints.CENTER);
                gridbag.setConstraints(query, constraints);
                add(query);
                query.addTextListener(this);

                buildConstraints(constraints, 1, 0, 1, 1, 0, 10, GridBagConstraints.NONE, GridBagConstraints.CENTER);
                gridbag.setConstraints(repQueryLbl, constraints);
                add(repQueryLbl);
                repQueryLbl.setBackground(Color.lightGray);

		    buildConstraints(constraints, 1, 1, 1, 3, 0, 30, GridBagConstraints.VERTICAL, GridBagConstraints.CENTER);
                gridbag.setConstraints(repQuery, constraints);
                add(repQuery);
                repQuery.addFocusListener(this);

		    buildConstraints(constraints, 2, 1, 1, 1, 40, 10, GridBagConstraints.NONE, GridBagConstraints.CENTER);
                gridbag.setConstraints(nome, constraints);
                add(nome);
                
                buildConstraints(constraints, 2, 2, 1, 1, 40, 10, GridBagConstraints.NONE, GridBagConstraints.CENTER);
                gridbag.setConstraints(esegui, constraints);
                add(esegui);
                esegui.addMouseListener(this);
                esegui.setEnabled(false);

		    buildConstraints(constraints, 2, 3, 1, 1, 40, 10, GridBagConstraints.NONE, GridBagConstraints.CENTER);
                gridbag.setConstraints(cat, constraints);
                add(cat);
		    try {	
		    		Vector categories = db.getCategories(utente);	
		    		for (int j=0; j<categories.size(); j++)	
					cat.add((String)categories.elementAt(j));
		    } catch (Exception ce) {}
		                    
		    buildConstraints(constraints, 0, 4, 1, 1, 40, 10, GridBagConstraints.NONE, GridBagConstraints.CENTER);
                gridbag.setConstraints(docR, constraints);
                add(docR);
                docR.setBackground(Color.lightGray);
                                
                buildConstraints(constraints, 2, 4, 1, 1, 40, 10, GridBagConstraints.NONE, GridBagConstraints.CENTER);
                gridbag.setConstraints(docRil, constraints);
                add(docRil);
		    docRil.setBackground(Color.lightGray);
                
                buildConstraints(constraints, 0, 5, 2, 1, 40, 40, GridBagConstraints.BOTH, GridBagConstraints.CENTER);
                gridbag.setConstraints(docRitrovati, constraints);
                add(docRitrovati);
                docRitrovati.addItemListener(this);
                

                buildConstraints(constraints, 2, 5, 1, 1, 40, 40, GridBagConstraints.BOTH, GridBagConstraints.CENTER);
                gridbag.setConstraints(report, constraints);
                add(report);
                report.addItemListener(this);
                report.addFocusListener(this);

                buildConstraints(constraints, 0, 7, 1, 1, 0, 10, GridBagConstraints.NONE, GridBagConstraints.CENTER);
                gridbag.setConstraints(view, constraints);
                add(view);
                view.setEnabled(false);
                view.addMouseListener(this);

		    buildConstraints(constraints, 1, 7, 1, 1, 0, 10, GridBagConstraints.NONE, GridBagConstraints.CENTER);
                gridbag.setConstraints(salvaQuery, constraints);
                add(salvaQuery);
		    salvaQuery.addMouseListener(this);	

		    buildConstraints(constraints, 2, 7, 1, 1, 0, 10, GridBagConstraints.NONE, GridBagConstraints.CENTER);
                gridbag.setConstraints(caricaQuery, constraints);
                add(caricaQuery);		
		    caricaQuery.addMouseListener(this);	

                
                addWindowListener( new WindowAdapter() {
                                     public void windowClosing(WindowEvent e) {
                                          setVisible(false);
						 }
                                   } );

		  
                
		    setSize(500, 350); 
                Toolkit t = parent.getToolkit();
	          int scw   = t.getScreenSize().width;
	          int sch   = t.getScreenSize().height;
	          int w     = this.size().width;
	          int h     = this.size().height;
	          setLocation((scw/2)-(w/2), (sch/2)-(h/2));	
                setResizable(false);
                setVisible(true);
                

        }

         private void buildConstraints(GridBagConstraints gbc, int gx,
           int gy, int gw, int gh, int wx, int wy,
           int fill, int anchor) {
             
             gbc.gridx = gx;
             gbc.gridy = gy;
             gbc.gridwidth = gw;
             gbc.gridheight = gh;
             gbc.weightx = wx;
             gbc.weighty = wy;
             gbc.fill = fill;
             gbc.anchor = anchor;
        }

        public void mouseClicked(MouseEvent me) {
        
             Button source = (Button)me.getSource();
             if (source.equals(esegui)) {
                    docRitrovati.removeAll();
			  selectedCategories.removeAllElements();	
                    report.removeAll();
                    view.setEnabled(false);
                    esegui.setEnabled(false);
                    impostaCursore(true);
                    String categ[] = cat.getSelectedItems();
			  for (int j=0; j<categ.length; j++)
				selectedCategories.addElement(categ[j]);
			  if (titolo.equals("Simple Matching"))	{
			  	try {
                    		new SimpleMatching(parent, utente, selectedCategories, query.getText(), db, this);
			  	} catch (Exception ee) {
					new StampaErrore(parent, titolo, ee.getMessage());
                    	}
			  } else if (titolo.equals("Dice's Coefficient")) {
				try {
                    		new Dice(parent, utente, selectedCategories, query.getText(), db, this);
                    		
			  	} catch (Exception ee) {
					new StampaErrore(parent, titolo, ee.getMessage());
                    	}
			  }	else {
			  	try {
                    		new Idf(parent, utente, selectedCategories, query.getText(), db, this);
                    		
			  	} catch (Exception ee) {
					new StampaErrore(parent, titolo, ee.getMessage());
				}
			  }

             }
		 else if (source.equals(salvaQuery)) {
			impostaCursore(true);
			selectedCategories.removeAllElements();
			String categ[] = cat.getSelectedItems();
			for (int j=0; j<categ.length; j++)
				selectedCategories.addElement(categ[j]);
			String testoQuery = query.getText();
		      String nomeQuery = nome.getText();
		      if ((testoQuery.equals("")) || (nomeQuery.equals(""))) {
				impostaCursore(false);
				new StampaErrore(parent, "Save Query", 
                  	"Inserire nome e testo della query.");	
			} else {
				
				try {
					Vector conf = db.getConfiguration(utente);
					Vector stop = db.getStopword(utente);
					Vector tokenQueryHW = 
						(new QueryTokenizer(testoQuery, conf, stop)).getTokenQuery();
					db.setQuery(utente, nomeQuery, testoQuery, tokenQueryHW,
						selectedCategories);
				} catch(Exception ex) {
					new StampaErrore(parent, 
							     "Save Query", 
							     "Exception:\n" + ex.getMessage());
					ex.printStackTrace();
				} finally {
					impostaCursore(false);
				}
			}
		 }
		 else if (source.equals(caricaQuery)) {
			try {
				LoadQuery lq = new LoadQuery(parent, db.getQueryNames(utente), utente, db);
				if (!lq.getQueryName().equals("")) {
					nome.setText(lq.getQueryName());
					query.setText(lq.getQueryText());
					selectedCategories.removeAllElements();
					selectedCategories = lq.getQueryCategories();
					int items = cat.getItemCount();
					int j = 0;
					while (j < items) {
						cat.deselect(j);
						j++;
					}
					for (int i=0; i<selectedCategories.size(); i++) {
						String categoria = (String)selectedCategories.elementAt(i);
						j = 0;
						while (j < items) {
							if (cat.getItem(j).equals(categoria))
								cat.select(j);
							j++;
						}
					}
					docRitrovati.removeAll();
					report.removeAll();
					repQuery.removeAll();
				}
			} catch (Exception ex) {
				new StampaErrore(parent, 
						     "Load Query", 
						     "Exception:\n" + ex.getMessage());
				ex.printStackTrace();
			}
		 } 	
             else if ( source.equals(view) ) {
		     String host = null;
		     String porta = null;		
		     String url = null;	
		     try {	
		     		host = (String)db.getConfiguration(utente).elementAt(12);	
		     		porta = (String)db.getConfiguration(utente).elementAt(13);	
				url = "http://" + host + ":" + porta + "/";
		     } catch (Exception se) {
				new StampaErrore(parent, "Query Dialog", se.getMessage());
		     }	
                 String item = docRitrovati.getSelectedItem(); 
		     if (url != null) {	
                 		url = url + item;
		     		try {
                     		new Explorer(url, 4);
                 		} catch (UnsatisfiedLinkError ule) {
                     		new StampaErrore(parent, "Query Dialog", 
                                      "Impossibile aprire Internet Explorer:\n" +
                                      "per utilizzare questa funzione, compilare\n" +
                                      "ed eseguire WebClass con i tools\n" +
                                      "Microsoft per Java.");

                 		}
		     }	
             }
	  }

        public void mousePressed(MouseEvent me) {}

        public void mouseReleased(MouseEvent me) {}

        public void mouseEntered(MouseEvent me) {}

        public void mouseExited(MouseEvent me) {}

        public void textValueChanged(TextEvent te) {
                if ( !query.getText().equals("") ) 
                     esegui.setEnabled(true);
                else
			   esegui.setEnabled(false);
		    
        } 	

        public void itemStateChanged(ItemEvent ie) {
		java.awt.List source = (java.awt.List)ie.getSource();
            if ( source.equals(docRitrovati) ) {
                if ( !docRitrovati.getSelectedItem().equals("No Match Found") ) {
                		view.setEnabled(true);
                        report.select(docRitrovati.getSelectedIndex());
                }
            }
	  }
        
	  public synchronized void impostaCursore(boolean attesa) {
             Cursor newCursor; 
             if (attesa) 
                  newCursor = new Cursor(Cursor.WAIT_CURSOR);
             else     
                  newCursor = new Cursor(Cursor.DEFAULT_CURSOR);

             docRitrovati.setCursor(newCursor);
             report.setCursor(newCursor);
             query.setCursor(newCursor);
             esegui.setCursor(newCursor); 
             view.setCursor(newCursor);
             queryL.setCursor(newCursor);
             docR.setCursor(newCursor);
             docRil.setCursor(newCursor);
             setCursor(newCursor);
             
        }

	  public void focusGained(FocusEvent e) {}

	  public void focusLost(FocusEvent e) {
		java.awt.List source = (java.awt.List)e.getSource();
		if (source.equals(report))
			report.deselect(report.getSelectedIndex());
		
		else if (source.equals(repQuery))
			repQuery.deselect(repQuery.getSelectedIndex());

        }

	  public void printRetrievedDocument(String line) {
		docRitrovati.add(line);
	  }	

	  public void printTime(Enumeration r) {
		repQuery.clear();
		while (r.hasMoreElements())
			repQuery.add((String)r.nextElement());
	  }	

	  public void waitCursor(boolean vv) {
		impostaCursore(vv);
	  }	

	  public void printReport(double sim) {
		report.add(new Double(sim).toString());
	  }

	  
		
		

}