package uniba.gui;

//import java.io.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.sql.SQLException;
import java.net.URL;

import uniba.core.*;
import uniba.databanker.*;


/**
 * Mostra una finestra per la classificazione delle pagine Web.
 */
public class PageClassifyDialog extends Dialog implements MouseListener{

	private static final int GAP = 5;
	private GridBagLayout gridbag;
	private GridBagConstraints c;
	
  	private Label label;
  	private TextField location;
  	private Vector history;
  	private int historyIndex;
	private int length;
  	private Event evt = null;
  	private String start = null;

  	private Button openFileButton;
  	private Button forward;
  	private Button backward;
  	private Button reload;
  	private Button classify1Button;
  	private Button classify2Button;
  	private Button classify3Button;
  	private Button classify4Button;
  	private Button classify5Button;
	private Button store;
	private Button view;
	private Button canc;

  	private TextField resultClass;
  	private Label label2;


  	Frame father;

  	TextArea 			resultText;
  	java.awt.List           wordList;
  	FileDialog              openFile;
  	Label                   blankLabel;
  	Label                   blankLabel1;
  	Label                   blankLabel2;
  	Label                   blankLabel3;
  	Label                   blankLabel4;
  	Label                   blankLabel5;
  	Label                   blankLabel6;
  	Label                   blankLabel7;
  	Label                   blankLabel8;
  	Label                   blankLabel9;

  	TextField urlName; 

	CategoriesManager cgm;
	RepresentManager rpm;
	TrainingPagesManager trpm;
	FeaturesManager ftm;

	Classifier classfr;
	DTClassifyAPage dtcap;
	String utente;
	String categoria;
	String nomeDocumento;
	Databanker db;
	HtmlPage currentPage;  
	Vector configurazione;
	Vector stopwords;
	int mode;


	public PageClassifyDialog(Frame parent, CategoriesManager cgm, 
	  	RepresentManager rpm, TrainingPagesManager trpm, FeaturesManager ftm,
		String utente, Databanker db, int mode)throws SQLException, OperationException {

   	super(parent, "WebClass - Classify a page -", false);
	father = parent;
	this.mode = mode;
	gridbag = new GridBagLayout();
	c = new GridBagConstraints();
	setLayout(gridbag);
    	history = new Vector();
    	historyIndex = -1;

	c.fill = GridBagConstraints.HORIZONTAL;
	c.gridwidth = 1;
	c.gridheight = 2;
	c.weightx = 3.0;
	c.weighty = 3.0;
    	openFileButton = new Button("Open file");
	gridbag.setConstraints(openFileButton, c);
	openFileButton.addMouseListener(this); 
	add(openFileButton);

	backward = new Button("Backward");
	gridbag.setConstraints(backward, c);
	backward.addMouseListener(this);
	add(backward);

    	forward = new Button("Forward");
	gridbag.setConstraints(forward, c);
	forward.addMouseListener(this);
	add(forward);

	c.gridwidth = GridBagConstraints.REMAINDER;
    	reload = new Button("Reload");
	gridbag.setConstraints(reload, c);
	reload.addMouseListener(this);
	add(reload);

	c.gridwidth = 1;
    	label = new Label("Location:");
	gridbag.setConstraints(label, c);
	add(label);

	c.gridwidth = GridBagConstraints.REMAINDER;
    	location = new TextField("",30);
	gridbag.setConstraints(location, c);
	add(location);

	c.gridwidth = 1;
	blankLabel8 = new Label("   ");
	gridbag.setConstraints(blankLabel8, c);
	add(blankLabel8);	

	c.gridwidth = GridBagConstraints.RELATIVE;
    	classify1Button = new Button("Classify by Decision Tree");
	gridbag.setConstraints(classify1Button, c);
	classify1Button.addMouseListener(this);
	add(classify1Button);

	c.gridwidth = GridBagConstraints.REMAINDER;
	blankLabel9 = new Label("   ");
	gridbag.setConstraints(blankLabel9, c);
	add(blankLabel9);	

	c.gridwidth = 1;
	blankLabel = new Label("   ");
	gridbag.setConstraints(blankLabel, c);
	add(blankLabel);	

	c.gridwidth = GridBagConstraints.RELATIVE;
    	classify2Button = new Button("Classify by Centroids");
	gridbag.setConstraints(classify2Button, c);
	classify2Button.addMouseListener(this);
	add(classify2Button);

	c.gridwidth = GridBagConstraints.REMAINDER;
	blankLabel6 = new Label("   ");
	gridbag.setConstraints(blankLabel6, c);
	add(blankLabel6);	

	c.gridwidth = 1;
	blankLabel1 = new Label("   ");
	gridbag.setConstraints(blankLabel1, c);
	add(blankLabel1);	

	c.gridwidth = GridBagConstraints.RELATIVE;
    	classify3Button = new Button("Classify by NN");
	gridbag.setConstraints(classify3Button, c);
	classify3Button.addMouseListener(this);
	add(classify3Button);

	c.gridwidth = GridBagConstraints.REMAINDER;
	blankLabel2 = new Label("   ");
	gridbag.setConstraints(blankLabel2, c);
	add(blankLabel2);	

	c.gridwidth = 1;
	blankLabel3 = new Label("   ");
	gridbag.setConstraints(blankLabel3, c);
	add(blankLabel3);	

	c.gridwidth = GridBagConstraints.RELATIVE;
    	classify4Button = new Button("Classify by k-NN");
	gridbag.setConstraints(classify4Button, c);
	classify4Button.addMouseListener(this);
	add(classify4Button);

	c.gridwidth = GridBagConstraints.REMAINDER;
	blankLabel4 = new Label("   ");
	gridbag.setConstraints(blankLabel4, c);
	add(blankLabel4);	

	c.gridwidth = 1;
	blankLabel5 = new Label("   ");
	gridbag.setConstraints(blankLabel5, c);
	add(blankLabel5);	

	c.gridwidth = GridBagConstraints.RELATIVE;
    	classify5Button = new Button("Classify by naive-Bayesian");
	gridbag.setConstraints(classify5Button, c);
	classify5Button.addMouseListener(this);
	add(classify5Button);

	c.gridwidth = GridBagConstraints.REMAINDER;
	blankLabel7 = new Label("   ");
	gridbag.setConstraints(blankLabel7, c);
	add(blankLabel7);	


	c.fill = GridBagConstraints.HORIZONTAL;
	c.gridwidth = 1;
	c.gridheight = 2;
    	label2 = new Label("Class:");
	gridbag.setConstraints(label2, c);
	add(label2);

	c.gridwidth = GridBagConstraints.REMAINDER;
    	resultClass = new TextField("",20);
	gridbag.setConstraints(resultClass, c);
	add(resultClass);

	c.gridwidth = 1;
	store = new Button("Store Page");
	gridbag.setConstraints(store, c);
	store.addMouseListener(this);
	add(store);

	c.gridwidth = GridBagConstraints.RELATIVE;
	canc = new Button("Cancel");
	gridbag.setConstraints(canc, c);
	canc.addMouseListener(this);
	add(canc);

	c.gridwidth = GridBagConstraints.REMAINDER;
	view = new Button("View Page");
	gridbag.setConstraints(view, c);
	view.addMouseListener(this);
	add(view);

    	backward.disable();
    	forward.disable();

    	setBackground(Color.lightGray);
    	pack();
    	resize(500, 300);
      Toolkit t = parent.getToolkit();
	int scw   = t.getScreenSize().width;
	int sch   = t.getScreenSize().height;
	int w     = this.size().width;
	int h     = this.size().height;
	setLocation((scw/2)-(w/2), (sch/2)-(h/2));	
      setResizable(false);
      setVisible(true);  

	this.addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent evtw) {
				setVisible(false);
			}
		});

    	openFile = new FileDialog(father,"Open File",openFile.LOAD);
	openFile.setDirectory("./html/");
    	openFile.setFile("*.htm");

	classify1Button.disable();
	classify2Button.disable();
	classify3Button.disable();
	classify4Button.disable();
	classify5Button.disable();
   	
	this.rpm = rpm;
   	this.cgm = cgm;
   	this.trpm = trpm;
   	this.ftm = ftm;
	this.utente = utente;
	this.db = db;
	configurazione = db.getConfiguration(utente);
	stopwords = db.getStopword(utente);
	
   	urlName = new TextField("HTTP://",35);

	show();
	classfr = new Classifier(cgm, trpm, utente, db);

}

//-----------------------------------------------------------------------------------

public void mousePressed(MouseEvent evt) {}

public void mouseReleased(MouseEvent evt) {}

public void mouseEntered(MouseEvent evt) {}

public void mouseExited(MouseEvent evt) {}

public void mouseClicked(MouseEvent evt) {
	if (((Button)evt.getSource()).equals(openFileButton)) {
    		resultClass.setText("");
    		location.setText("");	
    		openFile.setFile("*.htm");
    		openFile.show();
    		if (openFile.getFile() != null) {
			setCursor(new Cursor(Cursor.WAIT_CURSOR));
			classify1Button.disable();
			classify2Button.disable();
			classify3Button.disable();
			classify4Button.disable();
			classify5Button.disable();
     			String fileName=openFile.getDirectory() + openFile.getFile();
     			try {
				currentPage = new HtmlPage(File.trasforma(fileName), 								configurazione, stopwords, db);
			}catch(Exception e) {new StampaErrore(father,"HtmlPage",
					"Exception:\n"+e.getMessage());} 
			finally {
				setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
				classify1Button.enable();
				classify2Button.enable();
				classify3Button.enable();
				classify4Button.enable();
				classify5Button.enable();
			}
		     	location.setText(File.trasforma(fileName));
			history.addElement(File.trasforma(fileName));
			historyIndex = history.size() - 1;
			forward.disable();
			if (historyIndex > 0) 
				backward.enable();
		}
	} else
	if (((Button)evt.getSource()).equals(forward)) {
     		resultClass.setText("");
		location.setText("");	
		historyIndex++;
		backward.enable();
		if (historyIndex == history.size() - 1)
			forward.disable();
		String fileUrl = (String) history.elementAt(historyIndex);
     		try {
			setCursor(new Cursor(Cursor.WAIT_CURSOR));
			currentPage = new HtmlPage(fileUrl, configurazione, stopwords, db);
     		}catch(Exception e){new StampaErrore(father,"HtmlPage",
					"Exception:\n"+e.getMessage());} 
		finally {
			setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
		}
		location.setText(fileUrl);
	} else
	if (((Button)evt.getSource()).equals(backward)) {
     		resultClass.setText("");
		location.setText("");	
		historyIndex--;
		forward.enable();
		if (historyIndex == 0)
			backward.disable();
		String fileUrl = (String) history.elementAt(historyIndex);
     		try {
			setCursor(new Cursor(Cursor.WAIT_CURSOR));
			currentPage = new HtmlPage(fileUrl, configurazione,stopwords, db);
     		}catch (Exception e){new StampaErrore(father,"HtmlPage",
					"Exception:\n"+e.getMessage());} 
		finally {
			setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
		}
		location.setText(fileUrl);
	} else
	if (((Button)evt.getSource()).equals(reload)) {
     		resultClass.setText("");
		String url = location.getText().trim();
		if (!url.equalsIgnoreCase("")){
			classify1Button.disable();
			classify2Button.disable();
			classify3Button.disable();
			classify4Button.disable();
			classify5Button.disable();
			try {
				setCursor(new Cursor(Cursor.WAIT_CURSOR));
				currentPage = new HtmlPage(File.trasforma(url), configurazione, 									stopwords, db);
     	 		}catch (Exception e){new StampaErrore(father,"HtmlPage",
					"Exception:\n"+e.getMessage());} 
			finally {
				setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
				classify1Button.enable();
				classify2Button.enable();
				classify3Button.enable();
				classify4Button.enable();
				classify5Button.enable();
			}
		}else{
			new StampaErrore(father,"Load Page",
				"Inserire un URL valido prima di effettuare\n"+
				"questa operazione");
		}
	} else
	if ((((Button)evt.getSource()).equals(classify1Button)) &&
		(classify1Button.isEnabled())) {
     		resultClass.setText("");
		classify1Button.disable();
		classify2Button.disable();
		classify3Button.disable();
		classify4Button.disable();
		classify5Button.disable();
		try {
			setCursor(new Cursor(Cursor.WAIT_CURSOR));
			db.getAutoma().Transizione("ct");
           		rpm.represent(currentPage.getWords(), currentPage.getNumWords());                               
			dtcap = new DTClassifyAPage(utente, cgm, mode,
				rpm.getCurrentRepresentation());
			String result = dtcap.getResult();					
			resultClass.setText(result);
			if (result.equalsIgnoreCase(cgm.categoryName(cgm.totalCategories()))) 
				store.disable();
			else
				store.enable();
		}catch(Exception e){new StampaErrore(father,"Classifier", 
                           	"Exception:\n" + e.getMessage());e.printStackTrace();}
		finally {
			setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
			classify1Button.enable();
			classify2Button.enable();
			classify3Button.enable();
			classify4Button.enable();
			classify5Button.enable();
		}
	} else
	if ((((Button)evt.getSource()).equals(classify2Button)) &&
		(classify2Button.isEnabled())) {
     		resultClass.setText("");
		classify1Button.disable();
		classify2Button.disable();
		classify3Button.disable();
		classify4Button.disable();
		classify5Button.disable();
		try {
			setCursor(new Cursor(Cursor.WAIT_CURSOR));
			db.getAutoma().Transizione("cc");
           		rpm.represent(currentPage.getWords(), currentPage.getNumWords());                               
			String result = classfr.classifyCentroidPage									(rpm.getCurrentRepresentation());
			resultClass.setText(result);
			if (result.equalsIgnoreCase(cgm.categoryName(cgm.totalCategories()))) 
				store.disable();
			else
				store.enable();
		}catch(Exception e){new StampaErrore(father,"Classifier", 
   	                           	"Exception:\n" + e.getMessage());e.printStackTrace();}
		finally {
			setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
			classify1Button.enable();
			classify2Button.enable();
			classify3Button.enable();
			classify4Button.enable();
			classify5Button.enable();
		}
	} else
	if ((((Button)evt.getSource()).equals(classify3Button)) &&
		(classify3Button.isEnabled())) {
	     	resultClass.setText("");
		classify1Button.disable();
		classify2Button.disable();
		classify3Button.disable();
		classify4Button.disable();
		classify5Button.disable();
		try {
			setCursor(new Cursor(Cursor.WAIT_CURSOR));
			db.getAutoma().Transizione("cnn");
			rpm.represent(currentPage.getWords(), currentPage.getNumWords());           
		      String result = classfr.classifyNNPage(rpm.getCurrentRepresentation());
			resultClass.setText(result);
			if (result.equalsIgnoreCase(cgm.categoryName(cgm.totalCategories()))) 
				store.disable();
			else
				store.enable();
		}catch(Exception e){new StampaErrore(father,"Classifier", 
                            "Exception:\n" + e.getMessage());e.printStackTrace();}
		finally {
			setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
			classify1Button.enable();
			classify2Button.enable();
			classify3Button.enable();
			classify4Button.enable();
			classify5Button.enable();
		}
	} else
	if ((((Button)evt.getSource()).equals(classify4Button)) &&
		(classify4Button.isEnabled())) {
      	resultClass.setText("");
		classify1Button.disable();
		classify2Button.disable();
		classify3Button.disable();
		classify4Button.disable();
		classify5Button.disable();
		try {
			setCursor(new Cursor(Cursor.WAIT_CURSOR));
			db.getAutoma().Transizione("cnn");
			rpm.represent(currentPage.getWords(), currentPage.getNumWords());           
			String result = classfr.classifyKNNPage(rpm.getCurrentRepresentation());
			resultClass.setText(result);
			if (result.equalsIgnoreCase(cgm.categoryName(cgm.totalCategories()))) 
				store.disable();
			else
				store.enable();
		}catch(Exception e){new StampaErrore(father,"Classifier", 
                              "Exception:\n" + e.getMessage());e.printStackTrace();}
		finally {
			setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
			classify1Button.enable();
			classify2Button.enable();
			classify3Button.enable();
			classify4Button.enable();
			classify5Button.enable();
		}
	} else
	if ((((Button)evt.getSource()).equals(classify5Button)) &&
		(classify5Button.isEnabled())) {
    		resultClass.setText("");
		classify1Button.disable();
		classify2Button.disable();
		classify3Button.disable();
		classify4Button.disable();
		classify5Button.disable();
		try {
			setCursor(new Cursor(Cursor.WAIT_CURSOR));
			db.getAutoma().Transizione("cb");
			rpm.represent(currentPage.getWords(), currentPage.getNumWords());           
			String result = classfr.classifyNaiveBayesianPage								(rpm.getCurrentRepresentation());
                 	resultClass.setText(result);
			if (result.equalsIgnoreCase(cgm.categoryName(cgm.totalCategories()))) 
				store.disable();
			else
				store.enable();
		}catch(Exception e){new StampaErrore(father,"Classifier", 
   	                           	"Exception:\n" + e.getMessage());e.printStackTrace();}
		finally {
			setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
			classify1Button.enable();
			classify2Button.enable();
			classify3Button.enable();
			classify4Button.enable();
			classify5Button.enable();
		}
	} else
	if (((Button)evt.getSource()).equals(store)) {
		classify1Button.disable();
		classify2Button.disable();
		classify3Button.disable();
		classify4Button.disable();
		classify5Button.disable();
		try {
			String url = location.getText();
			categoria = resultClass.getText();
			if (!url.equalsIgnoreCase("")){
				if (!categoria.equalsIgnoreCase("")){
					setCursor(new Cursor(Cursor.WAIT_CURSOR));
					new Thread_4(this, utente, categoria, currentPage,
								((Vector)ftm.getFeatures()).elements(),db);
					location.setText(" ");
					resultClass.setText(" ");	
				}else{
					new StampaErrore(father,"Explorer",
						"Prima di memorizzare occorre\nclassificare il " + 							"documento\nper determinarne la categoria");
				}
			}else{
				new StampaErrore(father,"Explorer",
					"Caricare un documento dal disco o "+
					"dal Web prima di memorizzarlo.");
			}
		}catch(Exception e){new StampaErrore(father,"Classifier", 
   	                           	"Exception:\n" + e.getMessage());e.printStackTrace();}
		finally {
			classify1Button.enable();
			classify2Button.enable();
			classify3Button.enable();
			classify4Button.enable();
			classify5Button.enable();
		}
	} else
	if (((Button)evt.getSource()).equals(view)) {
		try {
			String url = location.getText();
			if (!url.equalsIgnoreCase("")) 
				new Explorer(url, 4);
			else
				new StampaErrore(father,"Explorer",
					"Caricare un documento dal disco o "+
					"dal Web prima di visualizzarlo.");
		}catch(Exception e){new StampaErrore(father,"Classifier", 
   	                           	"Exception:\n" + e.getMessage());e.printStackTrace();}
	} else
	if (((Button)evt.getSource()).equals(canc)) {
		hide();  
	}
}		

//---------------------------------------------------------------------------------

}
