package uniba.gui;

import java.awt.*;
import java.awt.event.*;

class PannelloDocumento extends Panel implements TextListener,
                                FocusListener, MouseListener  {
 
        private InserimentoDocumentoTT myController;
        private CheckboxGroup cbg = new CheckboxGroup();
        private Checkbox file = new Checkbox("From File:", cbg, true);
        private Checkbox internet = new Checkbox("From Internet:", cbg, false);
        private TextField tfint = new TextField(50);
        private TextField tffile = new TextField(50);
        private Button browse = new Button("Browse");
        private Label l = new Label("Retriev Document:");
        private Frame parent = null;
	  

        PannelloDocumento(InserimentoDocumentoTT myController, Frame parent) {
                super();
                this.parent = parent;
                this.myController = myController;
                GridBagLayout gridbag = new GridBagLayout();
                GridBagConstraints constraints = new GridBagConstraints();
                setLayout(gridbag);
                setBackground(Color.lightGray);
                
                buildConstraints(constraints, 0, 0, 1, 1, 20, 20, GridBagConstraints.NONE, GridBagConstraints.WEST);
                gridbag.setConstraints(l, constraints);
                l.setBackground(Color.lightGray);
                add(l);

                buildConstraints(constraints, 1, 1, 1, 1, 20, 40, GridBagConstraints.NONE, GridBagConstraints.WEST);
                gridbag.setConstraints(internet, constraints);
                internet.addFocusListener(this);
                internet.setBackground(Color.lightGray);
                add(internet);

                buildConstraints(constraints, 2, 1, 2, 1, 40, 40, GridBagConstraints.NONE, GridBagConstraints.WEST);
                gridbag.setConstraints(tfint, constraints);
                tfint.setEnabled(false);
                tfint.addTextListener(this);
                tfint.setBackground(Color.lightGray);
                add(tfint);

                buildConstraints(constraints, 1, 2, 1, 1, 20, 40, GridBagConstraints.NONE, GridBagConstraints.WEST);
                gridbag.setConstraints(file, constraints);
                file.addFocusListener(this);
                file.setBackground(Color.lightGray);
                add(file);

                buildConstraints(constraints, 2, 2, 1, 1, 40, 40, GridBagConstraints.NONE, GridBagConstraints.WEST);
                gridbag.setConstraints(tffile, constraints);
                tffile.addTextListener(this);
                tffile.setBackground(Color.lightGray);
                add(tffile);

                buildConstraints(constraints, 3, 2, 1, 1, 20, 40, GridBagConstraints.NONE, GridBagConstraints.CENTER);
                gridbag.setConstraints(browse, constraints);
                browse.addMouseListener(this);
                browse.setBackground(Color.lightGray);
                add(browse);
        }

        public void textValueChanged(TextEvent te) {
                TextField tf = (TextField)te.getSource();
                if (tf.equals(tfint)) {
                    myController.internet = false;
                    if (!tf.getText().equals("")) {
                         myController.internet = true;
                         if (myController.categoria & myController.alias)
                                myController.memorizza(true);
                    } else 
                         myController.memorizza(false);
                    
                } else
                    if (tf.equals(tffile)) {
                         myController.file = false;
                         if (!tf.getText().equals("")) {
                               myController.file = true;
                               if (myController.categoria & myController.alias)
                                     myController.memorizza(true);
                         } else 
                               myController.memorizza(false);
                    }
        }


        private void buildConstraints(GridBagConstraints gbc, int gx,
           int gy, int gw, int gh, int wx, int wy,
           int fill, int anchor) {
             
             gbc.gridx = gx;
             gbc.gridy = gy;
             gbc.gridwidth = gw;
             gbc.gridheight = gh;
             gbc.weightx = wx;
             gbc.weighty = wy;
             gbc.fill = fill;
             gbc.anchor = anchor;
        }

	  String getOption() {
		if (cbg.getSelectedCheckbox().getLabel().equals("From File:"))
			return  tffile.getText();
		else
			return  tfint.getText();
	  }



        public void focusGained(FocusEvent e) {
            Checkbox source = (Checkbox)e.getSource();    
            if (source.equals(internet)) {
                internet.setState(true);
                tffile.setEnabled(false);
                browse.setEnabled(false);
                tfint.setText("");
                myController.internet = false;
                myController.memorizza(false);
                tfint.setEnabled(true);
            } else {
                 file.setState(true);
                 tffile.setEnabled(true);
                 tffile.setText("");
                 myController.file=false;
                 myController.memorizza(false);
                 browse.setEnabled(true);
                 tfint.setEnabled(false);
            }
        }


        public void mouseEntered(MouseEvent e) {}

        public void mouseExited(MouseEvent e) {}

        public void mousePressed(MouseEvent e) {}

        public void mouseReleased(MouseEvent e) {}

        public void mouseClicked(MouseEvent e) {
              FileDialog fd = new FileDialog(parent,"Recupera File");
              fd.setFile("*.htm; *.html");
              fd.setMode(fd.LOAD);
		  fd.setDirectory("./html/");	
              fd.setVisible(true);
              String file = fd.getDirectory() + fd.getFile();
              myController.file = false;
              if (fd.getFile() != null) {
                      tffile.setText(fd.getDirectory()+fd.getFile());
                      myController.file = true;
                      if (myController.categoria & myController.alias)
                                     myController.memorizza(true);
              } else {
                      myController.memorizza(false);
                      tffile.setText("");
              }
        }

        public void focusLost(FocusEvent e) {}

}


