package uniba.gui;

import java.awt.*;
import java.awt.event.*;
import java.util.StringTokenizer;

class PannelloValori extends Panel implements ItemListener, FocusListener {
 
        
        List featuresList = new List(8, false);
        private Label l1 = new Label("Feature");
        private List freqList = new List(8, false);
        private Label l2 = new Label("Frequency");
        private List htmlwList = new List(8, false);
        private Label l3 = new Label("HTML weight");
        private List totwList = new List(8, false);
        private Label l4 = new Label("Tot weight");
        private List htmlcList = new List(8, false);
        private Label l5 = new Label("HTML context");
	  private List l = null;	

        PannelloValori() {
                super();
                GridBagLayout gridbag = new GridBagLayout();
                GridBagConstraints constraints = new GridBagConstraints();
                setLayout(gridbag);
                setBackground(Color.lightGray);

                l1.setBackground(Color.lightGray);
                buildConstraints(constraints, 0, 0, 1, 1, 20, 100, GridBagConstraints.NONE, GridBagConstraints.CENTER);
                gridbag.setConstraints(l1, constraints);
                add(l1);

                featuresList.setForeground(new Color(0).black);
   		    featuresList.setBackground(new Color(0).white);
   		    featuresList.setFont(new Font("Courier", 0, 12));
                featuresList.addItemListener(this);
                featuresList.addFocusListener(this);
		    buildConstraints(constraints, 0, 1, 1, 1, 20, 100, GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER);
                gridbag.setConstraints(featuresList, constraints);
                add(featuresList);

                l2.setBackground(Color.lightGray);
                buildConstraints(constraints, 1, 0, 1, 1, 20, 100, GridBagConstraints.NONE, GridBagConstraints.CENTER);
                gridbag.setConstraints(l2, constraints);
                add(l2);

		    freqList.setForeground(new Color(0).black);
   		    freqList.setBackground(new Color(0).white);
   		    freqList.setFont(new Font("Courier", 0, 12));
                freqList.addItemListener(this);
                freqList.addFocusListener(this);
                buildConstraints(constraints, 1, 1, 1, 1, 20, 100, GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER);
                gridbag.setConstraints(freqList, constraints);
                add(freqList);

		    l3.setBackground(Color.lightGray);
                buildConstraints(constraints, 2, 0, 1, 1, 20, 100, GridBagConstraints.NONE, GridBagConstraints.CENTER);
                gridbag.setConstraints(l3, constraints);
                add(l3);

		    htmlwList.setForeground(new Color(0).black);
   		    htmlwList.setBackground(new Color(0).white);
   		    htmlwList.setFont(new Font("Courier", 0, 12));
                htmlwList.addItemListener(this);
                htmlwList.addFocusListener(this);
                buildConstraints(constraints, 2, 1, 1, 1, 20, 100, GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER);
                gridbag.setConstraints(htmlwList, constraints);
                add(htmlwList);

		    l4.setBackground(Color.lightGray);
                buildConstraints(constraints, 3, 0, 1, 1, 20, 100, GridBagConstraints.NONE, GridBagConstraints.CENTER);
                gridbag.setConstraints(l4, constraints);
                add(l4);

		    totwList.setForeground(new Color(0).black);
   		    totwList.setBackground(new Color(0).white);
   		    totwList.setFont(new Font("Courier", 0, 12));
                totwList.addItemListener(this);
                totwList.addFocusListener(this);
                buildConstraints(constraints, 3, 1, 1, 1, 20, 100, GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER);
                gridbag.setConstraints(totwList, constraints);
                add(totwList);

		    l5.setBackground(Color.lightGray);
                buildConstraints(constraints, 4, 0, 1, 1, 20, 100, GridBagConstraints.NONE, GridBagConstraints.CENTER);
                gridbag.setConstraints(l5, constraints);
                add(l5);

		    htmlcList.setForeground(new Color(0).black);
   		    htmlcList.setBackground(new Color(0).white);
   		    htmlcList.setFont(new Font("Courier", 0, 12));
                htmlcList.addItemListener(this);
                htmlcList.addFocusListener(this);
                buildConstraints(constraints, 4, 1, 1, 1, 20, 100, GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER);
                gridbag.setConstraints(htmlcList, constraints);
                add(htmlcList);
	

        }

	  public void setList(List l) {
		this.l = l;
	  }

       


        private void buildConstraints(GridBagConstraints gbc, int gx,
           int gy, int gw, int gh, int wx, int wy,
           int fill, int anchor) {
             
             gbc.gridx = gx;
             gbc.gridy = gy;
             gbc.gridwidth = gw;
             gbc.gridheight = gh;
             gbc.weightx = wx;
             gbc.weighty = wy;
             gbc.fill = fill;
             gbc.anchor = anchor;
        }

        void setFeature(String fea) {
                featuresList.addItem(fea);
        }

        void setFrequency(String freq) {
                freqList.addItem(freq);
        }

	  void setHtmlWeight(String w) {
                htmlwList.addItem(w);
        }

        void setTotWeight(String tw) {
                totwList.addItem(tw);
        }

        void setHtmlContext(String c) {
                htmlcList.addItem(c);
        }

        void clear() {
            htmlwList.clear();
		htmlcList.clear();
            totwList.clear();
            freqList.clear();
            featuresList.clear();
        }

	  public void itemStateChanged(ItemEvent ie) {
		List source = (List)ie.getSource();
		if (source.equals(featuresList)) {
			int ind = featuresList.getSelectedIndex();
                  htmlwList.select(ind);
			htmlcList.select(ind);
      	      totwList.select(ind);
            	freqList.select(ind);
			
            } 
            else if (source.equals(htmlwList)) {
                 	int ind = htmlwList.getSelectedIndex();
                  featuresList.select(ind);
			htmlcList.select(ind);
      	      totwList.select(ind);
            	freqList.select(ind);
		}
            else if (source.equals(htmlcList)) {
                 	int ind = htmlcList.getSelectedIndex();
                  featuresList.select(ind);
			htmlwList.select(ind);
      	      totwList.select(ind);
            	freqList.select(ind);
		}
            else if (source.equals(totwList)) {
                 	int ind = totwList.getSelectedIndex();
                  featuresList.select(ind);
			htmlcList.select(ind);
      	      htmlwList.select(ind);
            	freqList.select(ind);
		}
            else if (source.equals(freqList)) {
                 	int ind = freqList.getSelectedIndex();
                  featuresList.select(ind);
			htmlcList.select(ind);
      	      totwList.select(ind);
            	htmlwList.select(ind);
		}
		int ni = l.countItems();
            int i = 0;
            boolean presente = false;
		while (i < ni && !presente) {
			String item = l.getItem(i);
			StringTokenizer st = new StringTokenizer(item);
			int numToc = st.countTokens();
			for (int j=0; j<numToc-2; j++)
				st.nextToken();
			if (st.nextToken().equalsIgnoreCase(featuresList.getSelectedItem())) {
				presente = true;
				l.select(i);
			} else {
				l.deselect(l.getSelectedIndex());
				i++;
			}
		} 
        } 

	  public void focusGained(FocusEvent fe) {}

        public void focusLost(FocusEvent fe) {
		 featuresList.deselect(featuresList.getSelectedIndex());
             freqList.deselect(freqList.getSelectedIndex()); 
             totwList.deselect(totwList.getSelectedIndex());
             htmlcList.deselect(htmlcList.getSelectedIndex());
             htmlwList.deselect(htmlwList.getSelectedIndex());
        }

	  public void select(String it) {
	  	int ni = featuresList.countItems();
            int i = 0;
            boolean presente = false;
		while (i < ni && !presente) {
			String item = featuresList.getItem(i);
			if (item.equals(it)) {
				presente = true;
				featuresList.select(i);
				htmlwList.select(i);
				htmlcList.select(i);
      	      	totwList.select(i);
            		freqList.select(i);

			} else {
				deselect();
     				i++;
                  }
		}
	  }

	  private void deselect() {
		featuresList.deselect(featuresList.getSelectedIndex());	
		htmlwList.deselect(htmlwList.getSelectedIndex());
            htmlcList.deselect(htmlcList.getSelectedIndex());
            totwList.deselect(totwList.getSelectedIndex());
            freqList.deselect(freqList.getSelectedIndex());
	  }
            

                  

}


