package uniba.gui;

import java.awt.*;
import java.awt.event.*;
import java.util.Vector;
import java.util.StringTokenizer;
import java.net.URL;
import java.net.MalformedURLException;
import uniba.databanker.*;
import uniba.core.*;
import java.sql.SQLException;

/**
 * Permette la visualizzazione dei documenti
 * di un utente
 */
public class PropertiesDialog extends Dialog implements MouseListener, FocusListener {

	private Label id = new Label("Document id.:");
	private Label url = new Label("URL:");
	private Label category = new Label("Category:");
	private Label tipo = new Label("Type:");
	private TextField idTxt = new TextField(10);
	private TextField urlTxt = new TextField(50);
	private TextField categoryTxt = new TextField(20);
	private CheckboxGroup cbg = new CheckboxGroup();
	private Checkbox tr = new Checkbox("Training", cbg, true);
	private Checkbox ts = new Checkbox("Testing", cbg,  false);
	private Checkbox rj = new Checkbox("Reject", cbg,  false);
	private Checkbox none = new Checkbox("None", cbg,  false);
	private Frame parent = null;	
	private Vector doc = null;
	private Button cancella = new Button("Cancel");
	private Button salva = new Button("Save");
	private boolean save = false;
	private Databanker db = null;
	private TrainingPagesManager trpm = null;
	private TestingPagesManager tspm = null;
	private RejectPagesManager rjpm = null;


	public PropertiesDialog(Frame p, Vector doc, Databanker db,TrainingPagesManager trpm,
				    TestingPagesManager tspm,
				    RejectPagesManager rjpm ) {

		super(p, "Document Properties", true);
		this.doc = doc;
            this.parent = p;
		this.db = db;
		this.trpm = trpm;
		this.tspm = tspm;
		this.rjpm = rjpm;
		GridBagLayout gridbag = new GridBagLayout();
            GridBagConstraints constraints = new GridBagConstraints();
            setLayout(gridbag);
		setBackground(Color.lightGray);
		
		addWindowListener( new WindowAdapter() {
						public void windowClosing(WindowEvent we) {
							save = false;
                                          setVisible(false);
						}
					 });
					
            buildConstraints(constraints, 0, 0, 1, 1, 50, 10, GridBagConstraints.NONE, GridBagConstraints.CENTER);
            gridbag.setConstraints(id, constraints);
		add(id);
		id.setBackground(Color.lightGray);
		
		buildConstraints(constraints, 1, 0, 1, 1, 50, 10, GridBagConstraints.NONE, GridBagConstraints.WEST);
            gridbag.setConstraints(idTxt, constraints);
		add(idTxt);
		idTxt.setText(((Integer)doc.elementAt(0)).toString());
		idTxt.setEditable(false);
				
		buildConstraints(constraints, 0, 1, 1, 1, 50, 10, GridBagConstraints.NONE, GridBagConstraints.CENTER);
            gridbag.setConstraints(url, constraints);
		add(url); 
		url.setBackground(Color.lightGray);
		
		buildConstraints(constraints, 1, 1, 1, 1, 50, 10, GridBagConstraints.HORIZONTAL, GridBagConstraints.WEST);
            gridbag.setConstraints(urlTxt, constraints);
		add(urlTxt); 
		urlTxt.setText((String)doc.elementAt(1));

		buildConstraints(constraints, 0, 2, 1, 1, 50, 10, GridBagConstraints.NONE, GridBagConstraints.CENTER);
            gridbag.setConstraints(category, constraints);
		add(category);
		category.setBackground(Color.lightGray);

		buildConstraints(constraints, 1, 2, 1, 1, 50, 10, GridBagConstraints.NONE, GridBagConstraints.WEST);
            gridbag.setConstraints(categoryTxt, constraints);
		add(categoryTxt);
		categoryTxt.setText((String)doc.elementAt(2));
		if (categoryTxt.getText().equals("Reject"))
			categoryTxt.setEditable(false);
						
		buildConstraints(constraints, 0, 3, 1, 4, 50, 10, GridBagConstraints.NONE, GridBagConstraints.CENTER);
            gridbag.setConstraints(tipo, constraints);
		add(tipo);
		tipo.setBackground(Color.lightGray);

		buildConstraints(constraints, 1, 3, 1, 1, 50, 10, GridBagConstraints.NONE, GridBagConstraints.WEST);
            gridbag.setConstraints(tr, constraints);
		add(tr);
		tr.addFocusListener(this);
		
		buildConstraints(constraints, 1, 4, 1, 1, 50, 10, GridBagConstraints.NONE, GridBagConstraints.WEST);
            gridbag.setConstraints(ts, constraints);
		add(ts);
		ts.addFocusListener(this);

		buildConstraints(constraints, 1, 5, 1, 1, 50, 10, GridBagConstraints.NONE, GridBagConstraints.WEST);
            gridbag.setConstraints(rj, constraints);
		add(rj);
		rj.addFocusListener(this);

		buildConstraints(constraints, 1, 6, 1, 1, 50, 10, GridBagConstraints.NONE, GridBagConstraints.WEST);
            gridbag.setConstraints(none, constraints);
		add(none);
		none.addFocusListener(this);

		buildConstraints(constraints, 0, 7, 1, 1, 50, 30, GridBagConstraints.NONE, GridBagConstraints.CENTER);
            gridbag.setConstraints(salva, constraints);
		add(salva);
		salva.addMouseListener(this);

		buildConstraints(constraints, 1, 7, 1, 1, 50, 30, GridBagConstraints.NONE, GridBagConstraints.CENTER);
            gridbag.setConstraints(cancella, constraints);
		add(cancella);
		cancella.addMouseListener(this);

		String tipo = (String)doc.elementAt(3);
		if (tipo.equalsIgnoreCase("training"))
			tr.setState(true);
		else if (tipo.equalsIgnoreCase("testing"))
			ts.setState(true);
		else if (tipo.equalsIgnoreCase("reject"))
			rj.setState(true);
		else
			none.setState(true);

		setSize(700, 250);
		Toolkit t = parent.getToolkit();
            int scw   = t.getScreenSize().width;
	      int sch   = t.getScreenSize().height;
	      int w     = this.size().width;
	      int h     = this.size().height;
	      setLocation((scw/2)-(w/2), (sch/2)-(h/2));	
            setResizable(false);
            setVisible(true);
	}

	private void buildConstraints(GridBagConstraints gbc, int gx,
           int gy, int gw, int gh, int wx, int wy,
           int fill, int anchor) {
             
             gbc.gridx = gx;
             gbc.gridy = gy;
             gbc.gridwidth = gw;
             gbc.gridheight = gh;
             gbc.weightx = wx;
             gbc.weighty = wy;
             gbc.fill = fill;
             gbc.anchor = anchor;
        }

	  
	 

	public void mouseClicked(MouseEvent e) {
		Button source = (Button)e.getSource();
		if (source.equals(salva)) {
			save = true;
			String url = getUrl();
			int j = url.indexOf(" ");
			if (j != -1) {
				new StampaErrore(parent, "Save Properties", "L'URL del documento non deve contenere spazi.");
				save = false;
			}
			try {
				new URL(url);
			} catch (MalformedURLException mue) {
				new StampaErrore(parent, "Save Properties", mue.getMessage());
				save = false;
			}
			if (save) {
			try {
				setCursor(new Cursor(Cursor.WAIT_CURSOR));
				salva.setEnabled(false);
				cancella.setEnabled(false);
				/*
			       *      Controllo consistena
				 */
				if ( !getCategory().equals((String)doc.elementAt(2)) ||
				     !getType().equals((String)doc.elementAt(3)) ) {

					if (!getCategory().equals((String)doc.elementAt(2))) {
						if ( ((String)doc.elementAt(3)).equalsIgnoreCase("TRAINING") &&
				           		getType().equalsIgnoreCase("TRAINING") ) {
								db.getAutoma().Transizione("rtp", (String)doc.elementAt(2));
								db.getAutoma().Transizione("atp", getCategory());
						} else if ( ((String)doc.elementAt(3)).equalsIgnoreCase("TESTING") &&
				          	      	getType().equalsIgnoreCase("TESTING")) {
									db.getAutoma().Transizione("rsp", (String)doc.elementAt(2));
									db.getAutoma().Transizione("asp", getCategory());
						}
					}

					if ( ((String)doc.elementAt(3)).equalsIgnoreCase("TRAINING") &&
				           getType().equalsIgnoreCase("TESTING") ) {
							db.getAutoma().Transizione("rtp", (String)doc.elementAt(2));
							db.getAutoma().Transizione("asp", getCategory());
					} else if ( ((String)doc.elementAt(3)).equalsIgnoreCase("TESTING") &&
				          	      getType().equalsIgnoreCase("TRAINING")) {
								db.getAutoma().Transizione("rsp", (String)doc.elementAt(2));
								db.getAutoma().Transizione("atp", getCategory());
					} else if ( ((String)doc.elementAt(3)).equalsIgnoreCase("TRAINING") &&
				            	!getType().equalsIgnoreCase("TESTING")) {
								db.getAutoma().Transizione("rtp", (String)doc.elementAt(2));
					} else if ( ((String)doc.elementAt(3)).equalsIgnoreCase("TESTING") &&
				            	!getType().equalsIgnoreCase("TRAINING")) {
								db.getAutoma().Transizione("rsp", (String)doc.elementAt(2));	
					} else if ( ((String)doc.elementAt(3)).equalsIgnoreCase("REJECT") &&
				            	getType().equalsIgnoreCase("TRAINING")) {
								db.getAutoma().Transizione("atp", getCategory());	
					} else if ( ((String)doc.elementAt(3)).equalsIgnoreCase("REJECT") &&
				            	getType().equalsIgnoreCase("TESTING")) {
								db.getAutoma().Transizione("asp", getCategory());
					} else if ( ((String)doc.elementAt(3)).equalsIgnoreCase("") &&
				            	getType().equalsIgnoreCase("TRAINING")) {
								db.getAutoma().Transizione("atp", getCategory());	
					} else if ( ((String)doc.elementAt(3)).equalsIgnoreCase("") &&
				            	getType().equalsIgnoreCase("TESTING")) {
								db.getAutoma().Transizione("asp", getCategory());
					} 
				}
				/*
				 *      fine controllo consistenza
				 */		

				db.updateDocument(((Integer)doc.elementAt(0)).intValue(),
							getUrl(),
						      getCategory(),
						      getType());
				rjpm.updateRejectPages();
				trpm.updateTrainingPages();
				tspm.updateTestingPages();
				setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
				setVisible(false);
			} catch (Exception s) {
				new StampaErrore(parent, "Save Properties", s.getMessage());
			} finally {
				setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
				salva.setEnabled(true);
				cancella.setEnabled(true);
			}
			}
		} else if (source.equals(cancella)) {
			save = false;
			setVisible(false);
		}
	}

	public void mousePressed(MouseEvent e) {}

      public void mouseReleased(MouseEvent e) {}

      public void mouseEntered(MouseEvent e) {}
 
      public void mouseExited(MouseEvent e) {}

	String getUrl() {
		return urlTxt.getText();
	}

	String getCategory() {
		return categoryTxt.getText();
	}

	String getType() {
		String tipo = cbg.getSelectedCheckbox().getLabel().toUpperCase();
		if (tipo.equals(""))
			return "";
		else
			return tipo;
	}	

	public void focusGained(FocusEvent f) {
		Checkbox source = (Checkbox)f.getSource();
		if (source.equals(rj)) {
			categoryTxt.setText("Reject");
			categoryTxt.setEditable(false);
		} else {
			categoryTxt.setText((String)doc.elementAt(2));
			categoryTxt.setEditable(true);
		}
	}

	public void focusLost(FocusEvent f) {}



}
		
		
		

	