package uniba.gui;

import java.awt.*;
import java.awt.event.*;

/**
 * Permette la stampa di messaggi di errore
 */
public class StampaErrore extends Dialog implements FocusListener,
   KeyListener {

	  private Button ok = null;
	  private TextArea messaggio = null;

        public StampaErrore(Frame parent, String title, String msg) {
                super(parent, title, true);
                GridBagLayout gridbag = new GridBagLayout();
                GridBagConstraints constraints = new GridBagConstraints();
                setLayout(gridbag);
                setBackground(Color.lightGray);
		    
                messaggio = new TextArea(msg, 5, 30);
		    messaggio.addFocusListener(this); 	
                buildConstraints(constraints, 0, 0, 1, 1, 100, 50, GridBagConstraints.BOTH, GridBagConstraints.CENTER);
                gridbag.setConstraints(messaggio, constraints);
                messaggio.setEditable(false);
                add(messaggio);
                messaggio.setBackground(Color.lightGray);
                
                ok = new Button("OK");
		    ok.addKeyListener(this);
                buildConstraints(constraints, 0, 1, 1, 1, 100, 50, GridBagConstraints.NONE, GridBagConstraints.CENTER);
                gridbag.setConstraints(ok, constraints);
                ok.addMouseListener(new MouseAdapter() {
                                public void mouseClicked(MouseEvent e) {
                                        setVisible(false);
                                }});
                add(ok);

                addWindowListener(new WindowAdapter() {
                                   public void windowClosing(WindowEvent e) {
                                        setVisible(false);
                                   } } );
		    pack();	
                Toolkit t = parent.getToolkit();
	          int scw   = t.getScreenSize().width;
	          int sch   = t.getScreenSize().height;
	          int w     = this.size().width;
	          int h     = this.size().height;
	          setLocation((scw/2)-(w/2), (sch/2)-(h/2));	
                setResizable(false);
                setVisible(true);
                
       }



        private void buildConstraints(GridBagConstraints gbc, int gx,
           int gy, int gw, int gh, int wx, int wy,
           int fill, int anchor) {
             
             gbc.gridx = gx;
             gbc.gridy = gy;
             gbc.gridwidth = gw;
             gbc.gridheight = gh;
             gbc.weightx = wx;
             gbc.weighty = wy;
             gbc.fill = fill;
             gbc.anchor = anchor;
        }

	  public void focusGained(FocusEvent fe) {
		messaggio.transferFocus();
	  }	

	  public void focusLost(FocusEvent fe) {}

	  public void keyPressed(KeyEvent ke) {
		if (ke.getKeyChar() == ke.VK_ENTER) 
			setVisible(false);
	  }

	  public void keyTyped(KeyEvent ke) {}

	  public void keyReleased(KeyEvent ke) {}
  


}

