package uniba.gui;

import java.awt.*;
import java.awt.event.*;
import uniba.databanker.*;

/**
 * Permette la stampa di messaggi di errore
 * proponendo i bottoni <i>Si</i> e <i>No</i>.
 */
public class StampaErrore2 extends Dialog implements FocusListener,
   KeyListener {
	
	  private Button si = null;
        private Button no = null;		
	  private TextArea messaggio = null;
	  private Frame parent2;
	  private Databanker dtbk;

	  public boolean validato = false;

        public StampaErrore2(Frame parent, String title, String msg, Databanker db) {
		    super(parent, title, true);
                parent2 = parent;
		    dtbk = db;
		    GridBagLayout gridbag = new GridBagLayout();
                GridBagConstraints constraints = new GridBagConstraints();
                setLayout(gridbag);
                setBackground(Color.lightGray);
		    
                messaggio = new TextArea(msg+"\nValidare il training set corrente?", 5, 30);
		    messaggio.addFocusListener(this); 	
                buildConstraints(constraints, 0, 0, 1, 1, 100, 50, GridBagConstraints.BOTH, 				GridBagConstraints.CENTER);
                gridbag.setConstraints(messaggio, constraints);
                messaggio.setEditable(false);
                add(messaggio);
                messaggio.setBackground(Color.lightGray);
                
                si = new Button("    Si    ");
		    si.addKeyListener(this);
                buildConstraints(constraints, 0, 1, 1, 1, 100, 50, GridBagConstraints.NONE, 				GridBagConstraints.WEST);
                gridbag.setConstraints(si, constraints);
                si.addMouseListener(new MouseAdapter() {
                        public void mouseClicked(MouseEvent e1) {
                		try {
					setVisible(false);
                              dtbk.getAutoma().Transizione("atp");
					validato = true;	
	                  } catch (Exception e) {new StampaErrore(parent2, 
					"inserimentoDocumentoTT", "Exception:\n"+e.getMessage());}
                        }});
                add(si);

                no = new Button("    No    ");
		    no.addKeyListener(this);
                buildConstraints(constraints, 0, 1, 1, 1, 100, 50, GridBagConstraints.NONE, 				GridBagConstraints.EAST);
                gridbag.setConstraints(no, constraints);
                no.addMouseListener(new MouseAdapter() {
                        public void mouseClicked(MouseEvent e2) {
                                setVisible(false);
                        }});
                add(no);

                addWindowListener(new WindowAdapter() {
                                   public void windowClosing(WindowEvent e) {
                                        setVisible(false);
                                   } } );
		    pack();	
                Toolkit t = parent.getToolkit();
	          int scw   = t.getScreenSize().width;
	          int sch   = t.getScreenSize().height;
	          int w     = this.size().width;
	          int h     = this.size().height;
	          setLocation((scw/2)-(w/2), (sch/2)-(h/2));	
                setResizable(false);
                setVisible(true);
                
       }



        private void buildConstraints(GridBagConstraints gbc, int gx,
           int gy, int gw, int gh, int wx, int wy,
           int fill, int anchor) {
             
             gbc.gridx = gx;
             gbc.gridy = gy;
             gbc.gridwidth = gw;
             gbc.gridheight = gh;
             gbc.weightx = wx;
             gbc.weighty = wy;
             gbc.fill = fill;
             gbc.anchor = anchor;
        }

	  public void focusGained(FocusEvent fe) {
		messaggio.transferFocus();
	  }	

	  public void focusLost(FocusEvent fe) {}

	  public void keyPressed(KeyEvent ke) {
		if (ke.getKeyChar() == ke.VK_ENTER) 
			setVisible(false);
	  }

	  public void keyTyped(KeyEvent ke) {}

	  public void keyReleased(KeyEvent ke) {}
  
	  public boolean validato() {
		return validato;
	  }


}

