package uniba.gui;

import java.awt.*;
import java.io.*;
import java.awt.event.*;
import java.util.*;
import java.sql.SQLException;
import uniba.databanker.*;

/**
* La classe implementa l'interfaccia per l'utente<br>
* che consente di selezionare il file dal quale estrarre le stopword.
*/

public class StopwordDialog extends Dialog implements MouseListener {

	Frame parent = null;
	Label l1;
	TextField tf;
	Button cancellBut, insertBut;
	String utente;
	Databanker db;
	
	public StopwordDialog(Frame parent, String utente, Databanker db) {
		
		super(parent, "Insert a Stopword", true);
		this.parent = parent;
		this.db = db;
		this.utente = utente;
		GridBagLayout gridbag = new GridBagLayout();
		GridBagConstraints constraints = new GridBagConstraints();
		constraints.insets = new Insets(0,0,0,0);
		setLayout(gridbag);

		// Etichetta
		buildConstraints(constraints, 0, 0, 1, 1, 50, 50);
		constraints.fill = GridBagConstraints.NONE;
		l1 = new Label("Insert Stopword: ");
		gridbag.setConstraints(l1, constraints);
		add(l1);
		l1.setBackground(Color.lightGray);

		// campo di testo
		buildConstraints(constraints, 1, 0, 1, 1, 50, 50);
		constraints.fill = GridBagConstraints.HORIZONTAL;
		tf = new TextField("", 10);
		gridbag.setConstraints(tf, constraints);
		tf.setFont(new Font("Courier",0,12));
		add(tf);

		// Pulsante cancellBut
		buildConstraints(constraints, 0, 1, 1, 1, 0, 0);
		constraints.fill = GridBagConstraints.NONE;
		constraints.anchor = GridBagConstraints.EAST;
		cancellBut = new Button("Cancell");
		gridbag.setConstraints(cancellBut, constraints);
		cancellBut.addMouseListener(this);
		add(cancellBut);

		// Pulsante insertBut
		buildConstraints(constraints, 1, 1, 1, 1, 0, 0);
		constraints.fill = GridBagConstraints.NONE;
		constraints.anchor = GridBagConstraints.WEST;
		insertBut = new Button("Insert");
		gridbag.setConstraints(insertBut, constraints);
		insertBut.addMouseListener(this);
		add(insertBut);

		this.addWindowListener(new WindowAdapter() {
				public void windowClosing(WindowEvent e) {
					hide();}
				});

		
		setSize(300, 100); 
            Toolkit t = parent.getToolkit();
	      int scw   = t.getScreenSize().width;
	      int sch   = t.getScreenSize().height;
	      int w     = this.size().width;
	      int h     = this.size().height;
	      setLocation((scw/2)-(w/2), (sch/2)-(h/2)+23);	
            setResizable(false);
		setVisible(true);
	
            
	}

//-----------------------------------------------------------------------------
		

private void buildConstraints(GridBagConstraints gbc, int gx, int gy, int gw, int gh,
	int wx, int wy) {
           
      gbc.gridx = gx;
      gbc.gridy = gy;
      gbc.gridwidth = gw;
      gbc.gridheight = gh;
      gbc.weightx = wx;
      gbc.weighty = wy;
}

//----------------------------------------------------------------------------

public void mousePressed(MouseEvent e) {}

public void mouseReleased(MouseEvent e) {}

public void mouseEntered(MouseEvent e) {}

public void mouseExited(MouseEvent e) {}

public void mouseClicked(MouseEvent e) {
	if (((Button)e.getSource()).equals(cancellBut)) {
		setVisible(false); 
	} else
	if (((Button)e.getSource()).equals(insertBut)) {
		setVisible(false);
		String parola = tf.getText();
//		setCursor(new Cursor(Cursor.WAIT_CURSOR));
		try {
			if (parola.equals("")) 
				throw new Exception("Parola non valida come stopword"); 
			else
				db.insertStopword(utente, tf.getText());
		} catch(Exception ex) {
                   new StampaErrore(parent, 
                       	"Insert a Stopword", 
                        "Exception:\n" + ex.getMessage());ex.printStackTrace();
           	} finally {
//			setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
		}
	}
}

//-------------------------------------------------------
	
}
