package uniba.gui;

import java.awt.*;

import uniba.core.*;
import uniba.databanker.*;



/**
 * Questa classe racchiude in un thread le operazioni effettuate da HtmlPage
 * e dal metodo del databanker che inserisce un documento di training o 
 * testing. Inserire queste operazioni in un thread  necessario poich 
 * sono operazioni lunghe e procurano effetti indesiderati riguardo alla grafica.
 */
public class Thread_1 extends Thread {

	private HtmlPage page = null;
	private Databanker db = null;
	private InserimentoDocumentoTT insTT = null;
	private Thread currentThread = null;
	private Frame parent = null; 
	private String utente = null;
      private TrainingPagesManager trpm = null;
      private TestingPagesManager tspm = null;
      private RejectPagesManager rjpm = null;

	public Thread_1(Frame parent, 
                      InserimentoDocumentoTT insTT, 
                      Databanker db,
                      String utente,
                      TrainingPagesManager trpm,
                      TestingPagesManager tspm,
			    RejectPagesManager rjpm) {

		super();
            this.parent = parent;
		this.insTT = insTT;
            this.utente = utente;
            this.trpm = trpm;
            this.tspm = tspm;
            this.rjpm = rjpm;
		this.db = db;
            currentThread = this;
            currentThread.start();

      }


	public void run() {
	  if (insTT.getName() != null) {
		try {
		    page = new HtmlPage(File.trasforma(insTT.getPath()),
                                    db.getConfiguration(utente), 
                                    db.getStopword(utente), db);   
	          db.inserisciDocumentoTT(utente, 
                		                insTT.getCategory(),
	                                  page, 
                                        insTT.getType());
                trpm.updateTrainingPages();
                tspm.updateTestingPages();
                rjpm.updateRejectPages();
            } catch (Exception e) {
		    new StampaErrore(parent, 
                                 "Thread_1",
                                 "Exception:\n" + e.getMessage());
					   e.printStackTrace(); 	
            }
            finally {
               parent.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
            }
	  } else
		parent.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
 
	}

}