package uniba.gui;

import java.awt.*;


import uniba.databanker.*;
import uniba.core.*;
import java.util.Vector;


/**
 * Questa classe racchiude in un thread l'operazione di cancellazione di una 
 * categoria dal database.
 * Inserire questa operazione in un thread  necessario poich  un'operazione
 * lunghe e procura effetti indesiderati riguardo alla grafica.
 */
public class Thread_2 extends Thread {

	private HtmlPage page = null;
	private Databanker db = null;
	private CancellazioneCategoria canCat = null;
	private Thread currentThread = null;
	private Frame parent = null; 
	private String utente = null;
      private TrainingPagesManager trpm = null;
      private TestingPagesManager tspm = null;
      private CategoriesManager cgm = null;

	public Thread_2(Frame parent, 
                      CancellazioneCategoria canCat, 
                      Databanker db,
                      String utente,
                      TrainingPagesManager trpm,
                      TestingPagesManager tspm,
                      CategoriesManager cgm) {

		super();
            this.parent = parent;
		this.canCat = canCat;
            this.utente = utente;
            this.cgm = cgm;
            this.trpm = trpm;
            this.tspm = tspm;
		this.db = db;
            currentThread = this;
            currentThread.start();

      }


	public void run() {
		try {
		    Vector d = db.getAllDocuments(utente, canCat.getCategory());
		    if (d.size() > 0)
				new StampaErrore(parent, 
                                         "Thread_2",
                                         "La categoria selezionata\n" + 
                                         "contiene documenti;\ncancellare prima "+
                                         "tali documenti.");
		    else {
				db.deleteCategory(canCat.getCategory(),
		                              utente); 
                		cgm.updateCategory();
                		trpm.updateTrainingPages();
                		tspm.updateTestingPages();
		    }	
            } catch (Exception e) {
                new StampaErrore(parent, 
                                 "Thread_2",
                                 "Exception:\n" + e.getMessage());
            }
            finally {
                parent.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
            }
	}

}