package uniba.gui;

import java.awt.*;

import uniba.core.*;
import uniba.databanker.*;



/**
 * Questa classe racchiude in un thread l'operazione che inserisce una
 * categoria nel database. Inserire tale operazione in un thread  necessario
 * poich le operazioni che interessano il database possono diventare lunghe
 * e provocare effetti indesiderati come per esempio il mancato aggiornamento
 * delle finestre attive o delle forme del cursore.
 */
public class Thread_3 extends Thread {

	private HtmlPage page = null;
	private Databanker db = null;
	private InserimentoCategoria insCat = null;
	private Thread currentThread = null;
	private Frame parent = null; 
	private String utente = null;
      private CategoriesManager cgm = null;

	public Thread_3(Frame parent, 
                      InserimentoCategoria insCat, 
                      Databanker db,
                      String utente,
                      CategoriesManager cgm) {

		super();
            this.parent = parent;
		this.insCat = insCat;
            this.utente = utente;
            this.cgm = cgm;
            this.db = db;
            currentThread = this;
            currentThread.start();

      }


	public void run() {
		try {
                  db.insertCategory(insCat.getCategory(), utente);
                  cgm.updateCategory();
            } catch (Exception e) {
                new StampaErrore(parent, 
                                 "Thread_3",
                                 "Exception:\n" + e.getMessage());
            }
            finally {
                parent.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
            }
	}

}