package uniba.gui;

import java.awt.*;

import uniba.core.*;
import uniba.databanker.*;



/**
 * Questa classe racchiude in un thread l'operazione di cancellazione di un 
 * documento dal database.
 * Inserire questa operazione in un thread  necessario poich  un'operazione
 * lunghe e procura effetti indesiderati riguardo alla grafica.
 */
public class Thread_5 extends Thread {

	private HtmlPage page = null;
	private Databanker db = null;
	private ViewDocumentDialog vdd = null;
	private Thread currentThread = null;
	private Frame parent = null; 
	private String utente = null;
      CategoriesManager cgm = null;
      TrainingPagesManager trpm = null;
      TestingPagesManager tspm = null;
      RejectPagesManager rjpm = null;



	public Thread_5(Frame parent, 
                      ViewDocumentDialog vdd, 
                      Databanker db,
			    CategoriesManager cgm,
			    TrainingPagesManager trpm,
			    TestingPagesManager tspm,
			    RejectPagesManager rjpm){

		super();
            this.parent = parent;
		this.vdd = vdd;
            this.db = db;
            this.trpm = trpm;
		this.tspm = tspm;
            this.cgm = cgm;
            this.rjpm = rjpm;
            currentThread = this;
            currentThread.start();
            

      }


	public void run() {
		try {
		    int id[] = vdd.getIdDoc();
                String url[] = vdd.getUrlDoc(); 	
		    for (int i=0; i<id.length; i++) {	
		    		db.deleteDocument(id[i]); 
                		cgm.updateCategory();
                		trpm.updateTrainingPages();
                		tspm.updateTestingPages();
				rjpm.updateRejectPages();
		    }	
            } catch (Exception e) {
                new StampaErrore(parent, 
                                 "Thread_5",
                                 "Exception:\n" + e.getMessage());
			e.printStackTrace();
            }
            finally {
                parent.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
            }
	}

}