package uniba.gui;

import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.sql.SQLException;
import uniba.databanker.*;
import uniba.core.*;

/**
* Attraverso la finestra di dialogo generata dalla<br>
* seguente classe  possibile assegnare uno spazio di lavoro ad<br>
* un nuovo utente. 
*/

public class UserDialog extends Dialog implements MouseListener {

	Frame parent = null;
	Label lName, lSurname, lLogin, lPass, lPassConf, lEmail, vuoto;
	Label lMinLW, lMaxLW, lProxy, lSocks, lMaxWCF, lMaxSCD, lRepType, lKFactor;
	TextField fName, fSurname, fLogin, fPass, fPassConf, fEmail;
	TextField fMinLW, fMaxLW, fProxy, fSocks, fMaxWCF, fMaxSCD, fKFactor;
	Choice RepType;
	Button okBut, cancelBut, closeBut;
	String utente;
	int mwcf, mscd, rept;
	Databanker db;
	

	public UserDialog(Frame parent, String utente, String titolo, Databanker db)
							throws SQLException {
		super(parent, "WebClass - " + titolo + " -", true);
	 	this.parent = parent;
		this.db = db;
		this.utente = utente;
		init();
	}

//---------------------------------------------------------------------------------------

	public UserDialog(Frame parent, String titolo, Databanker db) throws SQLException {
		super(parent, "WebClass - " + titolo + " -", true);
	 	this.parent = parent;
		this.db = db;
		this.utente = "";
		init();
	}

//---------------------------------------------------------------------------------------
		
private void init() throws SQLException {
	GridBagLayout gridbag = new GridBagLayout();
	GridBagConstraints constraints = new GridBagConstraints();
	constraints.insets = new Insets(0,0,0,0);
	setLayout(gridbag);

	// Etichetta lName
	buildConstraints(constraints, 0, 0, 1, 1, 45, 0);
	constraints.fill = GridBagConstraints.NONE;
	constraints.anchor = GridBagConstraints.SOUTHWEST;
	lName = new Label("Name:", Label.LEFT);
	gridbag.setConstraints(lName, constraints);
	add(lName);
	lName.setBackground(Color.lightGray);

	// Etichetta vuoto
	buildConstraints(constraints, 1, 0, 1, 1, 10, 0);
	constraints.fill = GridBagConstraints.NONE;
	constraints.anchor = GridBagConstraints.WEST;
	vuoto = new Label();
	gridbag.setConstraints(vuoto, constraints);
	add(vuoto);
	vuoto.setBackground(Color.lightGray);

	// Etichetta lSurname
	buildConstraints(constraints, 2, 0, 1, 1, 45, 6);
	constraints.fill = GridBagConstraints.NONE;
	constraints.anchor = GridBagConstraints.SOUTHWEST;
	lSurname = new Label("Surname:", Label.LEFT);
	gridbag.setConstraints(lSurname, constraints);
	add(lSurname);
	lSurname.setBackground(Color.lightGray);

	// Etichetta lLogin
	buildConstraints(constraints, 0, 2, 1, 1, 0, 0);
	constraints.fill = GridBagConstraints.NONE;
	constraints.anchor = GridBagConstraints.SOUTHWEST;
	lLogin = new Label("Login:", Label.LEFT);
	gridbag.setConstraints(lLogin, constraints);
	add(lLogin);
	lLogin.setBackground(Color.lightGray);

	// Etichetta lPass
	buildConstraints(constraints, 2, 2, 1, 1, 0, 6);
	constraints.fill = GridBagConstraints.NONE;
	constraints.anchor = GridBagConstraints.SOUTHWEST;
	lPass = new Label("Password:", Label.LEFT);
	gridbag.setConstraints(lPass, constraints);
	add(lPass);
	lPass.setBackground(Color.lightGray);

	// Etichetta lPassConf
	buildConstraints(constraints, 2, 4, 1, 1, 0, 6);
	constraints.fill = GridBagConstraints.NONE;
	constraints.anchor = GridBagConstraints.SOUTHWEST;
	lPassConf = new Label("Password confermation:", Label.LEFT);
	gridbag.setConstraints(lPassConf, constraints);
	add(lPassConf);
	lPassConf.setBackground(Color.lightGray);

	// Etichetta lEmail
	buildConstraints(constraints, 0, 4, 1, 1, 0, 0);
	constraints.fill = GridBagConstraints.NONE;
	constraints.anchor = GridBagConstraints.SOUTHWEST;
	lEmail = new Label("E-mail:", Label.LEFT);
	gridbag.setConstraints(lEmail, constraints);
	add(lEmail);
	lEmail.setBackground(Color.lightGray);

	// Etichetta lMinLW
	buildConstraints(constraints, 0, 6, 2, 1, 0, 0);
	constraints.fill = GridBagConstraints.NONE;
	constraints.anchor = GridBagConstraints.WEST;
	lMinLW = new Label("Word minimum lenght:", Label.LEFT);
	gridbag.setConstraints(lMinLW, constraints);
	add(lMinLW);
	lMinLW.setBackground(Color.lightGray);

	// Etichetta lMaxLW
	buildConstraints(constraints, 0, 7, 2, 1, 0, 0);
	constraints.fill = GridBagConstraints.NONE;
	constraints.anchor = GridBagConstraints.WEST;
	lMaxLW = new Label("Word maximum lenght:", Label.LEFT);
	gridbag.setConstraints(lMaxLW, constraints);
	add(lMaxLW);
	lMaxLW.setBackground(Color.lightGray);

	// Etichetta lProxy
	buildConstraints(constraints, 0, 8, 2, 1, 0, 0);
	constraints.fill = GridBagConstraints.NONE;
	constraints.anchor = GridBagConstraints.WEST;
	lProxy = new Label("Proxy server:", Label.LEFT);
	gridbag.setConstraints(lProxy, constraints);
	add(lProxy);
	lProxy.setBackground(Color.lightGray);

	// Etichetta llSocks
	buildConstraints(constraints, 0, 9, 2, 1, 0, 0);
	constraints.fill = GridBagConstraints.NONE;
	constraints.anchor = GridBagConstraints.WEST;
	lSocks = new Label("Socks server:", Label.LEFT);
	gridbag.setConstraints(lSocks, constraints);
	add(lSocks);
	lSocks.setBackground(Color.lightGray);

	// Etichetta lMaxWCF
	buildConstraints(constraints, 0, 10, 2, 1, 0, 0);
	constraints.fill = GridBagConstraints.NONE;
	constraints.anchor = GridBagConstraints.WEST;
	lMaxWCF = new Label("Max. word per category as features:", Label.LEFT);
	gridbag.setConstraints(lMaxWCF, constraints);
	add(lMaxWCF);
	lMaxWCF.setBackground(Color.lightGray);

	// Etichetta lMaxSCD
	buildConstraints(constraints, 0, 11, 2, 1, 0, 0);
	constraints.fill = GridBagConstraints.NONE;
	constraints.anchor = GridBagConstraints.WEST;
	lMaxSCD = new Label("Maximum size of category dictionary:", Label.LEFT);
	gridbag.setConstraints(lMaxSCD, constraints);
	add(lMaxSCD);
	lMaxSCD.setBackground(Color.lightGray);

	// Etichetta lKFactor
	buildConstraints(constraints, 0, 12, 2, 1, 0, 0);
	constraints.fill = GridBagConstraints.NONE;
	constraints.anchor = GridBagConstraints.WEST;
	lKFactor = new Label("K - NN factor:", Label.LEFT);
	gridbag.setConstraints(lKFactor, constraints);
	add(lKFactor);
	lKFactor.setBackground(Color.lightGray);

	// Etichetta lRepType
	buildConstraints(constraints, 0, 13, 2, 1, 0, 0);
	constraints.fill = GridBagConstraints.NONE;
	constraints.anchor = GridBagConstraints.WEST;
	lRepType = new Label("Representation type:", Label.LEFT);
	gridbag.setConstraints(lRepType, constraints);
	add(lRepType);
	lRepType.setBackground(Color.lightGray);

	// Campo fName
	buildConstraints(constraints, 0, 1, 1, 1, 0, 0);
	constraints.fill = GridBagConstraints.HORIZONTAL;
	constraints.anchor = GridBagConstraints.NORTH;
	fName = new TextField();
	gridbag.setConstraints(fName, constraints);
	add(fName);

	// Campo fSurname
	buildConstraints(constraints, 2, 1, 1, 1, 0, 6);
	constraints.fill = GridBagConstraints.HORIZONTAL;
	constraints.anchor = GridBagConstraints.NORTH;
	fSurname = new TextField();
	gridbag.setConstraints(fSurname, constraints);
	add(fSurname);

	// Campo fLogin
	buildConstraints(constraints, 0, 3, 1, 1, 0, 0);
	constraints.fill = GridBagConstraints.HORIZONTAL;
	constraints.anchor = GridBagConstraints.NORTH;
	fLogin = new TextField();
	gridbag.setConstraints(fLogin, constraints);
	add(fLogin);

	// Campo fPass
	buildConstraints(constraints, 2, 3, 1, 1, 0, 6);
	constraints.fill = GridBagConstraints.HORIZONTAL;
	constraints.anchor = GridBagConstraints.NORTH;
	fPass = new TextField();
	gridbag.setConstraints(fPass, constraints);
	fPass.setEchoChar('*');
	add(fPass);

	// Campo fPassConf
	buildConstraints(constraints, 2, 5, 1, 1, 0, 6);
	constraints.fill = GridBagConstraints.HORIZONTAL;
	constraints.anchor = GridBagConstraints.NORTH;
	fPassConf = new TextField();
	gridbag.setConstraints(fPassConf, constraints);
	fPassConf.setEchoChar('*');
	add(fPassConf);

	// Campo fEmail
	buildConstraints(constraints, 0, 5, 1, 1, 0, 0);
	constraints.fill = GridBagConstraints.HORIZONTAL;
	constraints.anchor = GridBagConstraints.NORTH;
	fEmail = new TextField();
	gridbag.setConstraints(fEmail, constraints);
	add(fEmail);

	// Campo fMinLW
	buildConstraints(constraints, 2, 6, 1, 1, 0, 7);
	constraints.fill = GridBagConstraints.HORIZONTAL;
	constraints.anchor = GridBagConstraints.CENTER;
	fMinLW = new TextField("2");
	gridbag.setConstraints(fMinLW, constraints);
	add(fMinLW);

	// Campo fMaxLW
	buildConstraints(constraints, 2, 7, 1, 1, 0, 7);
	constraints.fill = GridBagConstraints.HORIZONTAL;
	constraints.anchor = GridBagConstraints.CENTER;
	fMaxLW = new TextField("20");
	gridbag.setConstraints(fMaxLW, constraints);
	add(fMaxLW);

	// Campo fProxy
	buildConstraints(constraints, 2, 8, 1, 1, 0, 7);
	constraints.fill = GridBagConstraints.HORIZONTAL;
	constraints.anchor = GridBagConstraints.CENTER;
	fProxy = new TextField();
	gridbag.setConstraints(fProxy, constraints);
	add(fProxy);

	// Campo fSocks
	buildConstraints(constraints, 2, 9, 1, 1, 0, 7);
	constraints.fill = GridBagConstraints.HORIZONTAL;
	constraints.anchor = GridBagConstraints.CENTER;
	fSocks = new TextField();
	gridbag.setConstraints(fSocks, constraints);
	add(fSocks);

	// Campo fMaxWCF
	buildConstraints(constraints, 2, 10, 1, 1, 0, 7);
	constraints.fill = GridBagConstraints.HORIZONTAL;
	constraints.anchor = GridBagConstraints.CENTER;
	fMaxWCF = new TextField("25");
	gridbag.setConstraints(fMaxWCF, constraints);
	add(fMaxWCF);

	// Campo fMaxSCD
	buildConstraints(constraints, 2, 11, 1, 1, 0, 7);
	constraints.fill = GridBagConstraints.HORIZONTAL;
	constraints.anchor = GridBagConstraints.CENTER;
	fMaxSCD = new TextField("25");
	gridbag.setConstraints(fMaxSCD, constraints);
	add(fMaxSCD);

	// Campo fKFactor
	buildConstraints(constraints, 2, 12, 1, 1, 0, 7);
	constraints.fill = GridBagConstraints.HORIZONTAL;
	constraints.anchor = GridBagConstraints.CENTER;
	fKFactor = new TextField("7");
	gridbag.setConstraints(fKFactor, constraints);
	add(fKFactor);

	// Scelta RepType
	buildConstraints(constraints, 2, 13, 1, 1, 0, 7);
	constraints.fill = GridBagConstraints.HORIZONTAL;
	constraints.anchor = GridBagConstraints.CENTER;
	RepType = new Choice();
	gridbag.setConstraints(RepType, constraints);
	RepType.addItem("Normal enphasis");
	RepType.addItem("Additive enphasis");
	RepType.addItem("Multiplicative enphasis");
	add(RepType);

	// Pulsante okBut
	buildConstraints(constraints, 0, 14, 1, 1, 0, 0);
	constraints.fill = GridBagConstraints.NONE;
	constraints.anchor = GridBagConstraints.EAST;
	okBut = new Button("     Save     ");
	gridbag.setConstraints(okBut, constraints);
	okBut.addMouseListener(this);
	add(okBut);
		
	// Pulsante closeBut
	buildConstraints(constraints, 1, 14, 1, 1, 0, 0);
	constraints.fill = GridBagConstraints.HORIZONTAL;
	constraints.anchor = GridBagConstraints.CENTER;
	closeBut = new Button("Close");
	gridbag.setConstraints(closeBut, constraints);
	closeBut.addMouseListener(this);
	add(closeBut);

	// Pulsante cancelBut
	buildConstraints(constraints, 2, 14, 1, 1, 0, 8);
	constraints.fill = GridBagConstraints.NONE;
	constraints.anchor = GridBagConstraints.WEST;
	cancelBut = new Button("   Clear   ");
	gridbag.setConstraints(cancelBut, constraints);
	cancelBut.addMouseListener(this);
	add(cancelBut);

	setField();

	this.addWindowListener(new WindowAdapter() {
		public void windowClosing(WindowEvent e) {
			setVisible(false);}
		});

	setSize(400, 500); 
      Toolkit t = parent.getToolkit();
      int scw   = t.getScreenSize().width;
      int sch   = t.getScreenSize().height;
      int w     = this.size().width;
      int h     = this.size().height;
      setLocation((scw/2)-(w/2), (sch/2)-(h/2));	
      setResizable(false);
      setVisible(true);
}

//-----------------------------------------------------------------------------
		

private void buildConstraints(GridBagConstraints gbc, int gx, int gy, int gw, int gh,
	int wx, int wy) {
           
      gbc.gridx = gx;
      gbc.gridy = gy;
      gbc.gridwidth = gw;
      gbc.gridheight = gh;
      gbc.weightx = wx;
      gbc.weighty = wy;
}

//-----------------------------------------------------------------

public void mousePressed(MouseEvent e) {}

public void mouseReleased(MouseEvent e) {}

public void mouseEntered(MouseEvent e) {}

public void mouseExited(MouseEvent e) {}

public void mouseClicked(MouseEvent e) {

	if (((Button)e.getSource()).getLabel().equals("Close")) {
		setVisible(false);
	} else
	if (((Button)e.getSource()).getLabel().equals("   Clear   ")) {
		fName.setText("");
		fSurname.setText("");
		fLogin.setText("");
		fPass.setText("");
		fPassConf.setText("");
		fEmail.setText("");
	} else
	if (((Button)e.getSource()).getLabel().equals("     Save     ")) {
		setCursor(new Cursor(Cursor.WAIT_CURSOR));
		boolean lancia = false;
		
		String msg = "Riempire i campi :\n";
		try {
			if (fName.getText().equals("")) {
				msg += "'Name'\n";   
				lancia = true;
			}
			if (fSurname.getText().equals("")) {
				msg += "'Surname'\n";	
				lancia = true;
			}
			if (fLogin.getText().equals("")) {
				msg += "'Login'\n";
				lancia = true;
			}
			if (fPass.getText().equals("")) {
				msg += "'Password'\n";	
				lancia = true;
			}
			if (fPassConf.getText().equals("")) {
				msg += "'Password confermation'\n";	
				lancia = true;
			}
			if (fMinLW.getText().equals("")) {
				msg += "'Word minimum lenght'\n";	
				lancia = true;
			}
			if (fMaxLW.getText().equals("")) {
				msg += "'Word maximum lenght'\n";	
				lancia = true;
			}
			if (fMaxWCF.getText().equals("")) {
				msg += "'Max. word per category as features'\n";
				lancia = true;
			}
			if (fMaxSCD.getText().equals("")) {
				msg += "'Maximum size of category dictionary'\n";	
				lancia = true;
			}
			if (fKFactor.getText().equals("")) {
				msg += "'K - NN factor'\n";	
				lancia = true;
			}
			if (!(fPass.getText().equals(fPassConf.getText()))) {
				if (msg.length() > 20)
					msg += "\nErrore nel digitare la password\no la sua conferma!";
				else
					msg = "\nErrore nel digitare la password\no la sua conferma!";
				lancia = true;
			}
			if (lancia) {throw new Exception(msg);}
			else {
				int mwcf2 = new Integer(fMaxWCF.getText()).intValue();
				int mscd2 = new Integer(fMaxSCD.getText()).intValue();
				int rept2 = RepType.getSelectedIndex();
				if ((mwcf != mwcf2) | (mscd != mscd2) | (rept != rept2))
					db.getAutoma().Transizione("upc");
				db.putUser(	fLogin.getText(),
						fPass.getText(),
						fName.getText(), 
						fSurname.getText(),
						fEmail.getText(),
						"FINALE",
						new Integer(fMinLW.getText()).intValue(),
						new Integer(fMaxLW.getText()).intValue(),	
						mwcf2,
						mscd2,
						rept2,
						new Integer(fKFactor.getText()).intValue(),
						"localhost",
						"8080"); 
			}
		} catch (Exception ex) {new StampaErrore(parent, "User Dialog",                      			"Exception:\n" + ex.getMessage());ex.printStackTrace();
		} finally { setCursor(new Cursor(Cursor.DEFAULT_CURSOR));}
	}
}		

//--------------------------------------------------------------

private void setField() throws SQLException {
	if (utente != "") {
		Vector user = new Vector();
		Vector conf = new Vector();
		user = db.getUser(utente);
		conf = db.getConfiguration(utente);
		fLogin.setText((String)user.elementAt(0));
		fPass.setText((String)user.elementAt(1));
		fPassConf.setText((String)user.elementAt(1));
		fName.setText((String)user.elementAt(2));
		fSurname.setText((String)user.elementAt(3));
		fEmail.setText((String)user.elementAt(4));
		fMinLW.setText(((Integer)conf.elementAt(0)).toString());
		fMaxLW.setText(((Integer)conf.elementAt(1)).toString());
		fProxy.setText((String)conf.elementAt(2));
		fSocks.setText((String)conf.elementAt(3));
		rept = ((Integer)conf.elementAt(4)).intValue();
		RepType.select(rept);
		mscd = ((Integer)conf.elementAt(5)).intValue();
		fMaxSCD.setText("" + mscd + "");
		mwcf = ((Integer)conf.elementAt(6)).intValue();
		fMaxWCF.setText("" + mwcf + "");
		fKFactor.setText(((Integer)conf.elementAt(7)).toString());
	}
}

//--------------------------------------------------------------

public void stampa(){
	System.out.println(fLogin.getText() + "\n" +
	fPass.getText() + "\n" +
	fPassConf.getText() + "\n" +
	fName.getText() + "\n" +
	fSurname.getText() + "\n" +
	fEmail.getText() + "\n" +
	fMinLW.getText() + "\n" +
	fMaxLW.getText() + "\n" +
	fProxy.getText() + "\n" +
	fSocks.getText() + "\n" +
	RepType.getSelectedItem() + "\n" +
	RepType.getSelectedIndex() + "\n" +
	fMaxSCD.getText() + "\n" +
	fMaxWCF.getText() + "\n" +
	fKFactor.getText());
}

//--------------------------------------------------------------

}
 
