package uniba.gui;

import java.awt.*;
import java.io.*;
import java.util.*;

import uniba.databanker.*;

/**
 * Mostra le probabilit bayesiane.
 */
public class ViewBayesianProbabilitiesDialog extends Dialog {

  private Button okButton;
  private TextArea BayesianProbabilitiesArea;
  private Frame parent = null;
  private Databanker db = null;
  private String utente = null;
  
  
  public  ViewBayesianProbabilitiesDialog(Frame f, String utente, Databanker db) {
	super(f,"View Bayesian Probabilities",true);
      this.parent = f;
      this.db = db;
      this.utente = utente;
	setBackground(new Color(0).lightGray);
	BayesianProbabilitiesArea = new TextArea(25,40);
	BayesianProbabilitiesArea.setForeground(new Color(0).blue);
	BayesianProbabilitiesArea.setBackground(new Color(0).white);
	BayesianProbabilitiesArea.setFont(new Font("Courier",0,12));
	BayesianProbabilitiesArea.setText(" ");
	Label BayesianProbabilitiesLabel = new Label("Bayesian Probabilities");
	Panel listPanel = new Panel();
	listPanel.setLayout(new BorderLayout());
	listPanel.add("North",BayesianProbabilitiesLabel);
	listPanel.add("Center",BayesianProbabilitiesArea);
	okButton=new Button("Ok");
	Panel buttonPanel = new Panel();
	buttonPanel.add(okButton);
	add("Center",listPanel);
	add("South",buttonPanel);
	resize(500,450);
	setResizable(false);
	setupBayesianProbabilitiesArea();
	setVisible(true);
  }  


  public boolean handleEvent(Event evt) {
	if (evt.id==evt.WINDOW_DESTROY) {
	  hide();
	  return true;
	}
	else
	if (evt.id==evt.ACTION_EVENT) {
	  if (evt.target instanceof Button) {
		if (evt.arg.equals("Ok")) {
		  hide();
		  return true;
		}
	  }
	}
	return false;
  }  

  public void setupBayesianProbabilitiesArea() {
	BayesianProbabilitiesArea.setText(" ");
	try{
         Vector prob = db.getBayesianProbabilities(utente);
         Enumeration e = prob.elements();
	   String c="";
	   String result = "";
	   String spazi = "                           ";	
         while (e.hasMoreElements()) {
		 StringTokenizer temp = new StringTokenizer((String)e.nextElement());
		 c  = (String)temp.nextToken() + spazi;
		 result = result + c.substring(0, 20);
		 c = (String)temp.nextToken() + spazi;
		 result = result + c.substring(0,25) + (String)temp.nextToken() + "\n";
	   }
	   c = "Feature" + spazi;
	   c = c.substring(0,20) + "Prob" + spazi;
	   c = c.substring(0,45) + "Category" + "\n" + "\n";	
	   BayesianProbabilitiesArea.setText(c + result);
	} 
	catch(Exception e){
           new StampaErrore(parent, "ViewBayesianProbabilities", "Exception:\n"+e.getMessage());
      }
  }  
}
