package uniba.gui;

import java.awt.*;
import java.io.*;
import uniba.core.*;

public class ViewDTDialog extends Dialog {

  private Button okButton;
  private TextArea dtText;
  private Frame parent = null;
  private FeaturesManager ftm;
  private String PRUNED = null;	
  private String UNPRUNED = null;	
  private String utente = null;
  
  public ViewDTDialog (Frame f, FeaturesManager ftm, String utente) {
	super(f, "Current Decision Tree", true);
      this.parent = f;
      this.utente = utente;
      PRUNED = ".\\dt\\"+utente+"\\training.dt";	
      UNPRUNED = ".\\dt\\"+utente+"\\training.unp";
	setBackground(new Color(0).lightGray);
	dtText = new TextArea(20, 60);
	dtText.setBackground(new Color(0).white);
	dtText.setFont(new Font("Curier", 0, 12));
	dtText.setEditable(false);
	Label dtLabel = new Label("Decision Tree");
	Panel dtPanel = new Panel();
	dtPanel.setLayout(new BorderLayout());
	dtPanel.add("North", dtLabel);
	dtPanel.add("Center", dtText);
	okButton=new Button("Ok");
	Panel buttonPanel = new Panel();
	buttonPanel.add(okButton);
	add("Center", dtPanel);
	add("South", buttonPanel);
	resize(600, 400);
	setResizable(false);
	this.ftm = ftm;
  } 

 
  public boolean handleEvent(Event evt) {
	if (evt.id==evt.WINDOW_DESTROY) {
	  hide();
	  return true;
	}
	else
	if (evt.id==evt.ACTION_EVENT) {
	  if (evt.target instanceof Button) {
		if (evt.arg.equals("Ok")) {
		  hide();
		  return true;
		}
	  }
	}
	return false;
  }
  

  /**
   * Legge il file contenente l'albero di decisione
   * e lo visualizza.
   */ 		
  public void loadDecisionTree() {
	FileReader fr = null;
	try {
		fr = new FileReader(PRUNED);
	} catch (FileNotFoundException f1) {
		fr = null;
	}
	if (fr != null) {
		try {
			StringBuffer buf = new StringBuffer();
			int c = 0;
			do {
				c = fr.read();
				buf.append((char)c);
			} while (c != -1);
			fr.close();
			String source = buf.toString();
			String x;
	  		while (source.indexOf("x[")!=-1) {
				x=source.substring(source.indexOf("x["),source.indexOf("] +")+1);
				x=x.substring(x.indexOf("[")+1,x.indexOf("]"));
				Integer Index = new Integer(x);
				source=source.substring(0,source.indexOf("x[")-1)+
				" * "+ftm.getFeature(Index.intValue()-1)+
				source.substring(source.indexOf("] +")+3);
	  		}  
			dtText.setText(source);
		} catch(IOException ioe) {
			new StampaErrore(parent,
                                   "View Decision tree",
				           "Exception:\n" + ioe.getMessage());
                  ioe.printStackTrace();
		}
	} else
		dtText.setText("Decision Tree Not created."); 
  }
  
}