package uniba.gui;

import java.awt.*;
import java.sql.SQLException;
import java.awt.event.*;
import java.util.Vector;
import java.util.StringTokenizer;
import uniba.databanker.*;

/**
 * Permette la visualizzazione dei documenti
 * di un utente
 */
public class ViewDocumentDialog extends Dialog implements ItemListener, MouseListener {

	private List documenti = new List(15, true);
	private Vector doc = null;
	private Button cancella = new Button("Delete Document");
	private Button view = new Button("View Document");
	private String urlDoc[] = null;
	private int idDoc[] = null;
	Frame parent = null;	
	Databanker db = null;
	String utente = null;

	public ViewDocumentDialog(Frame p, Vector doc, Databanker db, String utente) {

		super(p, "Delete Documents", true);
		this.doc = doc;
            this.parent = p;
		this.db = db;
		this.utente = utente;
		GridBagLayout gridbag = new GridBagLayout();
            GridBagConstraints constraints = new GridBagConstraints();
            setLayout(gridbag);
		setBackground(Color.lightGray);
		
		addWindowListener( new WindowAdapter() {
						public void windowClosing(WindowEvent we) {
                                          urlDoc = null;
							idDoc = null;
							setVisible(false);
						}
					 });
					
            
		for (int j=0; j<doc.size(); j++) 
			documenti.addItem((String)doc.elementAt(j));
		
            cancella.setEnabled(false);
		buildConstraints(constraints, 0, 0, 2, 1, 100, 50, GridBagConstraints.BOTH, GridBagConstraints.CENTER);
            gridbag.setConstraints(documenti, constraints);
		add(documenti);
		documenti.addItemListener(this);
		
		buildConstraints(constraints, 0, 1, 1, 1, 50, 50, GridBagConstraints.NONE, GridBagConstraints.CENTER);
            gridbag.setConstraints(view, constraints);
		add(view); 
		view.setEnabled(false);
		view.addMouseListener(this);

		cancella.addMouseListener(new MouseAdapter() {
							public void mouseClicked(MouseEvent me) {
								String items[] = documenti.getSelectedItems();
                                                idDoc = new int[items.length];
                                                urlDoc = new String[items.length];
                                                for (int i=0; i<items.length; i++) {
							      	StringTokenizer st = new StringTokenizer(items[i]);	
							      	idDoc[i] = new Integer(st.nextToken()).intValue();
                                                	urlDoc[i] = st.nextToken(); 
                                                	setVisible(false);
								}		
							}
						  });
		buildConstraints(constraints, 1, 1, 1, 1, 50, 50, GridBagConstraints.NONE, GridBagConstraints.CENTER);
            gridbag.setConstraints(cancella, constraints);
		add(cancella);
		setSize(600, 300);
            Toolkit t = parent.getToolkit();
            int scw   = t.getScreenSize().width;
	      int sch   = t.getScreenSize().height;
	      int w     = this.size().width;
	      int h     = this.size().height;
	      setLocation((scw/2)-(w/2), (sch/2)-(h/2));	
            setResizable(false);
            setVisible(true);

	}

	private void buildConstraints(GridBagConstraints gbc, int gx,
           int gy, int gw, int gh, int wx, int wy,
           int fill, int anchor) {
             
             gbc.gridx = gx;
             gbc.gridy = gy;
             gbc.gridwidth = gw;
             gbc.gridheight = gh;
             gbc.weightx = wx;
             gbc.weighty = wy;
             gbc.fill = fill;
             gbc.anchor = anchor;
        }

	  
	  public int[] getIdDoc() {
		return idDoc;
	  }	

	  public String[]  getUrlDoc() {
		return urlDoc;
	  }	

	  public void itemStateChanged(ItemEvent ie) {
		int sel[] = documenti.getSelectedIndexes();
		if (sel.length == 1) {
			view.setEnabled(true);
            } else
			view.setEnabled(false);
		if (sel.length > 0)
			cancella.setEnabled(true);
		else
			cancella.setEnabled(false);
	  } 

	public void mouseClicked(MouseEvent e) {
		String host = null;
		String porta = null;		
		String url = null;	
		try {	
			host = (String)db.getConfiguration(utente).elementAt(12);	
			porta = (String)db.getConfiguration(utente).elementAt(13);	
			url = "http://" + host + ":" + porta + "/";
		} catch (Exception se) {
			new StampaErrore(parent, "Delete Documents", se.getMessage());
		}	
		if (url != null) {
			url = url + documenti.getSelectedItem();
			try {
            		new Explorer(url, 4);
            	} catch (UnsatisfiedLinkError ule) {
             		new StampaErrore(parent, "ViewDocuments", "Impossibile aprire Internet Explorer:\n" +
                           						"per utilizzare questa funzione, compilare\n" +
                           						"ed eseguire WebClass con i tools\n" +
                           						"della Microsoft per Java.");
			}
		}
	}

		

	 public void mousePressed(MouseEvent e) {}

        public void mouseReleased(MouseEvent e) {}

        public void mouseEntered(MouseEvent e) {}
 
        public void mouseExited(MouseEvent e) {}



}
		
		
		

	