package uniba.gui;

import java.awt.*;
import java.util.Enumeration;
import uniba.core.*;

/**
 * Mostra le feature correnti
 */
public class ViewFeaturesDialog extends Dialog {

  private Button okButton;
  private List featuresList;
  private FeaturesManager ftm;
  
  public ViewFeaturesDialog (Frame f, FeaturesManager ftm) {
	super(f,"View Features",true);
	setBackground(new Color(0).lightGray);
	featuresList = new List(14,false);
	featuresList.setForeground(new Color(0).blue);
	featuresList.setBackground(new Color(0).white);
	featuresList.setFont(new Font("Courier",0,12));
	Label featuresLabel = new Label("Features");
	Panel listPanel = new Panel();
	listPanel.setLayout(new BorderLayout());
	listPanel.add("North",featuresLabel);
	listPanel.add("Center",featuresList);
	okButton=new Button("Ok");
	Panel buttonPanel = new Panel();
	buttonPanel.add(okButton);
	add("Center",listPanel);
	add("South",buttonPanel);
	resize(300,500);
	setResizable(false);
	this.ftm=ftm;
	setupFeaturesList();
      Toolkit t = f.getToolkit();
      int scw   = t.getScreenSize().width;
      int sch   = t.getScreenSize().height;
      int w     = this.size().width;
      int h     = this.size().height;
      setLocation((scw/2)-(w/2), (sch/2)-(h/2));

  }  


  public boolean handleEvent(Event evt) {
	if (evt.id==evt.WINDOW_DESTROY) {
	  hide();
	  return true;
	}
	else
	if (evt.id==evt.ACTION_EVENT) {
	  if (evt.target instanceof Button) {
		if (evt.arg.equals("Ok")) {
		  hide();
		  return true;
		}
	  }
	}
	return false;
  }  

  /**
   * Elenca le feature correnti
   */
  public void setupFeaturesList() {
	featuresList.clear();
	Enumeration e = ftm.listFeatures();
	String c;
	while (e.hasMoreElements())
	 {
		c=(String) e.nextElement();
		featuresList.addItem(c);
	 } 
  }  
}