package uniba.gui;

import java.awt.*;
import java.io.*;
import java.util.*;
import uniba.databanker.*;


public class ViewRejectThresholdsDialog extends Dialog {

  private Button okButton;
  private java.awt.List RejectThresholdsList;
  private String utente = null;
  private Databanker db = null;
  private Frame parent = null;
    
  public  ViewRejectThresholdsDialog(Frame f, String utente, Databanker db) {

	super(f, "View Reject Thresholds", true);
	this.utente = utente;
      this.db = db;
      this.parent = f;
	setBackground(new Color(0).lightGray);
	RejectThresholdsList = new java.awt.List(14,false);
	RejectThresholdsList.setForeground(new Color(0).blue);
	RejectThresholdsList.setBackground(new Color(0).white);
	RejectThresholdsList.setFont(new Font("Courier",0,12));
	Label RejectThresholdsLabel = new Label("Reject Thresholds");
	Panel listPanel = new Panel();
	listPanel.setLayout(new BorderLayout());
	listPanel.add("North",RejectThresholdsLabel);
	listPanel.add("Center",RejectThresholdsList);
	okButton = new Button("Ok");
	Panel buttonPanel = new Panel();
	buttonPanel.add(okButton);
	add("Center",listPanel);
	add("South",buttonPanel);
	resize(400, 450);
	setResizable(false);
	setupRejectThresholdsList();
  }

  
  public boolean handleEvent(Event evt) {
	if (evt.id==evt.WINDOW_DESTROY) {
	  hide();
	  return true;
	}
	else
	if (evt.id==evt.ACTION_EVENT) {
	  if (evt.target instanceof Button) {
		if (evt.arg.equals("Ok")) {
		  hide();
		  return true;
		}
	  }
	}
	return false;
  }

  
  private void setupRejectThresholdsList() {
	RejectThresholdsList.clear();
	try{
	    Vector soglie = db.getThresholdes(utente);	  
	    for (int i=0; i<soglie.size(); i++)
	    		RejectThresholdsList.addItem((String)soglie.elementAt(i));
       
	} 
	catch(Exception e){
		new StampaErrore(parent,
                             "View Thresholds",
				     "Exception:\n" + e.getMessage());
            e.printStackTrace();
	}
  }  


}
